/*!
 * All Studio Web Components
 * Copyright (c) Halfcute Internet Pvt Ltd
 */
import { Host, h } from '@stencil/core';
import Swiper, { Navigation } from 'swiper';
// import Flickity from 'flickity';
// import "flickity-hash";
import { jitsuClient } from '@jitsu/sdk-js';
// import posthog from 'posthog-js'
// if (!window.location.host.includes('127.0.0.1') && !window.location.host.includes('localhost')) {
//   posthog.init('phc_PFn3ipf7jR88MXFX73PMM6l7A0G5EeZf0llC0u5FVKv', { api_host: 'https://app.posthog.com', autocapture: false, capture_pageview: false})
// }
const jitsu = jitsuClient({
  key: "js.ku52f0vferwtf16hunn8p6.s4zhwpli8w7pwz9k0y1kc",
  tracking_host: "https://t.jitsu.com"
});
export class AsCarousel {
  constructor() {
    this.autofullscreen = false;
    this.hoverPlayer = null;
    this.fullscreenPlayer = null;
    this.viewport = false;
    this.viewportcount = 0;
    this.showfootertitle = true;
    this.showProductChip = false;
    this.showProductCard = false;
    this.items = [];
    this.playlistId = undefined;
    this.channelId = null;
    this.fsplaylist = undefined;
    this.env = '';
    this.mode = 'default';
    this.fullscreen = false;
    this.pt = null;
    this.platform = 'web';
    this.ep = null;
    this.mainElzIndex = '';
    this.selectedVid = 0;
    this.tk = true;
    this.variant = "title";
    this.ch = 400;
    this.size = 'default';
    this.carouselReady = false;
    this.carouselPlayerReady = false;
    this.activeVideoId = null;
    this.flkCsl = [];
    this.fullscreenOpen = false;
    this.playlist = null;
    this.loading = true;
    this.forcemute = false;
    this.cslready = false;
    this.swiperloaded = false;
  }
  // private remaining: number = 0;
  async scrollPage() {
    // await this.checkVisibleItems(this);
    return Promise.resolve();
  }
  async onPageLoaded() {
    // const els = this.el.shadowRoot.querySelectorAll('.carousel-cell');
    // els.forEach((el, index) => {
    //   if(index < 12) {
    //     this.loadEle(el, null);
    //   }
    // });
  }
  async selectIndex(index) {
    // show a prompt
    // console.log('selecting index', this.flkCsl, index);
    this.selectedVid = index;
    const asreels = this.el.shadowRoot.querySelector('as-reels');
    asreels === null || asreels === void 0 ? void 0 : asreels.enter(this.selectedVid);
    // if(force) {
    //   this.flkCsl[0].select(this.selectedVid);
    // }
    this.trackEvent('full_screen', {
      category: 'carousel',
      index,
      type: this.items[index].type,
      typeid: this.items[index].typeId,
      videoid: (this.items[index].type === 'video') ? this.items[index].typeId : null,
      photoid: (this.items[index].type === 'photo') ? this.items[index].typeId : null,
    });
    // this.flkCsl[0].select(index);
    return Promise.resolve();
  }
  async exitFullScreen() {
    // show a prompt
    // console.log('exiting full screen', this.flkCsl);
    // const aplayers: any = this.el?.shadowRoot.querySelectorAll(".carousel-cell as-player");
    // console.log('pause a players', aplayers, this.selectedVid);
    // if(aplayers) {
    //   await aplayers?.forEach(async (p) =>await p.pause());
    // }
    // this.flkCsl[0].exitFullscreen();
    const asreels = this.el.shadowRoot.querySelector('as-reels');
    asreels === null || asreels === void 0 ? void 0 : asreels.exit();
    this.trackEvent('close_full_screen', {
      category: 'carousel',
    });
    return Promise.resolve();
  }
  componentWillLoad() {
    var _a;
    if (this.size === 'mini') {
      this.ch = 240;
    }
    var style = document.createElement('style');
    style.innerHTML = `:root { --ascarousel-ch: ${this.ch}px; }`;
    if (this.ch <= 360) {
      style.innerHTML = `${style.innerHTML}  @media (min-width: 768px) { :root { --ascarousel-ch: ${this.ch * 1.5}px; } }`;
    }
    document.body.appendChild(style);
    if (this.tk === undefined) {
      this.tk = true;
    }
    if (!this.fullscreen) {
      const mainEl = this.getHighestParent(this.el);
      this.mainElzIndex = mainEl.style.zIndex;
      // console.log(mainEl, this.mainElzIndex);
    }
    if (this.variant != 'title') {
      this.showfootertitle = false;
    }
    if (this.variant === 'chip') {
      this.showProductChip = true;
    }
    if (this.fullscreen) {
      this.showfootertitle = false;
      this.showProductCard = true;
      this.showProductChip = false;
    }
    this.playlist = this.fsplaylist || null;
    this.items = ((_a = this.playlist) === null || _a === void 0 ? void 0 : _a.itemsdata) || [];
    if (!this.fsplaylist) {
      for (var i = 0; i < 10; i++) {
        this.items.push({
          title: '',
          url: null,
          loading: true,
        });
      }
    }
    else {
      this.loading = false;
    }
  }
  async componentDidLoad() {
    var _a, _b;
    // this.setupLoadingFlkty();
    var style = document.createElement('style');
    style.innerHTML = `.carouselWrapper { --ascarousel-ch: ${this.ch}px; }`;
    if (this.ch <= 360) {
      style.innerHTML = `${style.innerHTML}  @media (min-width: 768px) { .carouselWrapper { --ascarousel-ch: ${this.ch * 1.5}px; } }`;
    }
    this.el.shadowRoot.appendChild(style);
    if (!this.fsplaylist) {
      let cheader = {
        "Content-type": "application/json;charset=UTF-8",
      };
      if (this.channelId) {
        cheader["channel_id"] = this.channelId;
      }
      const playlistResponse = await fetch(`${this.getApiUrl(this.env)}/web/playlists/${this.playlistId}`, {
        method: "GET",
        headers: cheader,
      });
      if (playlistResponse.status === 200) {
        this.playlist = await playlistResponse.json();
        this.items = this.playlist.itemsdata;
        this.loading = false;
      }
      else {
        return false;
      }
    }
    if (this.items.length > 0) {
      this.channelId = this.playlist.channelId;
      if (this.tk) {
        jitsu.set({
          channelid: this.channelId,
          playlistid: this.playlistId,
          env: this.env === '' ? 'live' : this.env,
          appid: 'allstudio',
          accountid: (_a = this.playlist.channel) === null || _a === void 0 ? void 0 : _a.accountId,
          mode: this.mode,
          category: 'carousel'
        });
        //group posthog
        // posthog.group('accountid', `${this.env === 'live' || this.env === '' ? '': `${this.env}_`}${this.playlist.channel?.accountId}`, {
        //   env: this.env,
        //   channelid: this.channelId,
        //   channel: this.playlist.channel?.title,
        // });
      }
    }
    else {
      return false;
    }
    if (this.items) {
      if (window.location.hash.includes("#as-playlist-item-true")) {
        this.autofullscreen = true;
        this.forcemute = true;
      }
      if (this.ep) {
        // console.log('excluding current product', this.ep);
        this.items = (_b = this.items) === null || _b === void 0 ? void 0 : _b.filter((v) => { var _a, _b; return (((_b = (_a = v.data) === null || _a === void 0 ? void 0 : _a.shoppableData) === null || _b === void 0 ? void 0 : _b.productId) !== this.ep); });
      }
      window.history.pushState({
        fullscreen: false,
        firststate: true,
      }, null, "");
      const s = this;
      setTimeout(() => s.setupObserver(), 0);
      if (this.autofullscreen && !this.fullscreen) {
        const mainEl = this.getHighestParent(this.el);
        mainEl.style.zIndex = 2147483647;
        this.fullscreenOpen = true;
      }
      this.backCheck();
    }
    // final
  }
  render() {
    var _a, _b;
    return (h(Host, null, h("div", { class: { carouselWrapper: true, fullScreen: this.fullscreen, sizemini: (this.size === 'mini') } }, this.loading && (h("div", { id: `as-carousel-${this.playlistId}-${this.fullscreen}-loading`, class: this.fullscreen ? 'fs-as-carousel-loading swiper' : 'as-carousel-loading swiper' }, h("div", { class: "swiper-wrapper" }, (_a = this.items) === null || _a === void 0 ? void 0 : _a.map(() => (h("div", { class: "carousel-cell swiper-slide", key: `as-playlist-video-${this.fullscreen}-${this.playlistId}-${Date.now() * Math.random()}-loading` }, h("div", { class: "cards" }, h("div", { class: "card_image loading" })))))))), !this.loading && h("div", { id: `as-carousel-${this.playlistId}-${this.fullscreen}-loaded`, class: 'as-carousel swiper' }, h("div", { class: "swiper-wrapper" }, (_b = this.items) === null || _b === void 0 ? void 0 : _b.map((item, index) => (h("div", { class: "carousel-cell swiper-slide", id: `as-playlist-item-${this.fullscreen}-${this.playlistId}-${item.type}-${item.typeId}`, key: `as-playlist-item-${this.fullscreen}-${this.playlistId}-${item.type}-${item.typeId}` }, this.carouselReady && item.type === 'video' ? (h("as-player", { size: this.size, index: index,
      // productoverlay={this.el.shadowRoot.querySelector('as-product-overlay')}
      tk: this.tk, playlistId: this.playlistId, videoId: item.typeId, env: this.env, autoplay: this.mode === 'autoplay' ? true : false, fullscreen: this.fullscreen, fvideo: item.data, platform: this.platform, showheader: this.fullscreen, showfootertitle: this.showfootertitle, showproductchip: this.showProductChip, showproductcard: this.showProductCard, forcemute: this.fullscreen ? this.forcemute : null, widget: `carousel_player${this.fullscreen ? '_fullscreen' : ''}`, playclick: this.fullscreen ? false : (() => {
        // const fel: any = this.el.shadowRoot.querySelector('.fullScreenCarousel as-carousel');
        // fel?.selectIndex(index);
        const asreels = this.el.shadowRoot.querySelector('as-reels');
        asreels === null || asreels === void 0 ? void 0 : asreels.enter(index);
        // const aplayers: any = this.el?.shadowRoot.querySelectorAll(".as-carousel as-player");
        // aplayers?.forEach((item) => {
        //   item?.pause();
        //     });
        if (this.fullscreenOpen) {
          const mainEl = this.getHighestParent(this.el);
          mainEl.style.zIndex = 2147483647;
          this.el.shadowRoot.querySelector('.fullScreenCarousel').classList.add('isOpen');
        }
        else {
          const mainEl = this.getHighestParent(this.el);
          mainEl.style.zIndex = 2147483647;
          this.fullscreenOpen = true;
        }
        //fel?.selectIndex(index);
        this.selectedVid = index;
      }), piphandler: !this.fullscreen ? false : (() => {
        var _a;
        // const fel: any = this.el.shadowRoot.querySelector('.fullScreenCarousel as-carousel');
        // console.log('handling pip', fel);
        (_a = this.fullscreenPlayer) === null || _a === void 0 ? void 0 : _a.pause();
        this.exitFullScreen();
        // this.fullscreenOpen = false;
        // this.el.shadowRoot.querySelector('.fullScreenCarousel').classList.remove('isOpen');
      }), mutehandler: !this.fullscreen ? false : ((val) => {
        var _a;
        this.forcemute = val;
        // console.log('mute handler', this.forcemute);
        const aplayers = (_a = this.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelectorAll(".fs-as-carousel as-player");
        aplayers === null || aplayers === void 0 ? void 0 : aplayers.forEach((item) => {
          item === null || item === void 0 ? void 0 : item.muted(this.forcemute);
        });
      }) })) : h("div", null), this.carouselReady && item.type === 'photo' ? (h("as-photo-viewer", { size: this.size, index: index,
      // productoverlay={this.el.shadowRoot.querySelector('as-product-overlay')}
      tk: this.tk, playlistId: this.playlistId, photoId: item.typeId, env: this.env, fullscreen: this.fullscreen, fphoto: item.data, platform: this.platform, showheader: this.fullscreen, showfootertitle: this.showfootertitle, showproductchip: this.showProductChip, showproductcard: this.showProductCard, widget: `carousel_photo_viewer${this.fullscreen ? '_fullscreen' : ''}`, playclick: this.fullscreen ? false : (() => {
        // const fel: any = this.el.shadowRoot.querySelector('.fullScreenCarousel as-carousel');
        // fel?.selectIndex(index);
        const asreels = this.el.shadowRoot.querySelector('as-reels');
        asreels === null || asreels === void 0 ? void 0 : asreels.enter(index);
        if (this.fullscreenOpen) {
          const mainEl = this.getHighestParent(this.el);
          mainEl.style.zIndex = 2147483647;
          this.el.shadowRoot.querySelector('.fullScreenCarousel').classList.add('isOpen');
        }
        else {
          const mainEl = this.getHighestParent(this.el);
          mainEl.style.zIndex = 2147483647;
          this.fullscreenOpen = true;
        }
        this.selectedVid = index;
      }), piphandler: !this.fullscreen ? false : (() => {
        // const fel: any = this.el.shadowRoot.querySelector('.fullScreenCarousel as-carousel');
        // console.log('handling pip', fel);
        this.exitFullScreen();
        // this.fullscreenOpen = false;
        // this.el.shadowRoot.querySelector('.fullScreenCarousel').classList.remove('isOpen');
      }) })) : h("div", null))))), h("div", { class: "swiper-button-prev" }), h("div", { class: "swiper-button-next" })), (!this.fullscreen && !this.loading && this.swiperloaded) ? (h("as-reels", { playlistId: this.playlistId, fullscreen: true, fsplaylist: this.playlist, open: false, env: this.env, platform: this.platform })) : h("div", null))));
  }
  getApiUrl(env) {
    let apiUrl = `https://apiv2.allstudio.live`;
    if (env === 'dev') {
      apiUrl = `${apiUrl}/dev`;
    }
    else if (env === 'qa') {
      apiUrl = `${apiUrl}/qa`;
    }
    else if (env === 'local') {
      apiUrl = 'http://localhost:4011';
    }
    return apiUrl;
  }
  getVideoUrl(vid) {
    let finalUrl = vid.url;
    try {
      if (vid.isProcessed && vid.processedUrls['576p']) {
        finalUrl = vid.processedUrls['576p'];
      }
    }
    catch (e) {
      finalUrl = vid.url;
    }
    // console.log('finalUrl', finalUrl);
    return finalUrl;
  }
  getHighestParent(el) {
    var _a;
    let parent = el;
    while (parent) {
      if (((_a = parent.parentNode) === null || _a === void 0 ? void 0 : _a.tagName) === 'BODY') {
        break;
      }
      parent = parent.parentNode;
    }
    // console.log('parent', parent);
    return parent;
  }
  isInViewport(el) {
    const rect = (el === null || el === void 0 ? void 0 : el.getBoundingClientRect()) || {
      top: 0,
      left: 0,
      bottom: 0,
      right: 0,
    };
    // console.log(rect);
    return (rect.top >= 0 &&
      rect.left >= 0 &&
      rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
      rect.right <= (window.innerWidth || document.documentElement.clientWidth));
  }
  async checkVisibleItems(s = this, hoverIndex = null) {
    var _a, _b;
    if (!s.fullscreen) {
      const acarousel = (_a = s.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelector(".as-carousel");
      if (s.isInViewport(acarousel)) {
        if (!s.viewport) {
          s.viewport = true;
          s.viewportcount++;
          s.trackEvent('impression', {
            category: 'carousel',
            view_count: s.viewportcount,
          });
        }
      }
      else {
        s.viewport = false;
      }
      const aplayers = (_b = s.el) === null || _b === void 0 ? void 0 : _b.shadowRoot.querySelectorAll(".as-carousel .carousel-cell");
      if (aplayers.length === s.items.length) {
        if (s.mode === 'default') {
          s.hoverPlayer = null;
        }
        aplayers === null || aplayers === void 0 ? void 0 : aplayers.forEach((item, index) => {
          var _a;
          const p = item.querySelector('as-player');
          if (p && s.items[index].type === 'video') {
            // console.log('visible player', p, index, p ? s.isInViewport(p) : false);
            if (s.mode === 'autoplay') {
              // console.log('visible trying to play');
              p === null || p === void 0 ? void 0 : p.play();
              s.hoverPlayer = p;
              // s.trackEvent("viewport_play_video", {
              //     index,
              //     type: 'video',
              //     typeid: p?.videoId,
              //     videoid: p?.videoId,
              //     category: "carousel",
              //   });
            }
            else {
              if (!s.hoverPlayer && hoverIndex === null) {
                s.hoverPlayer = p;
                p === null || p === void 0 ? void 0 : p.play();
                // s.trackEvent("viewport_play_hover_video", {
                //     index,
                //     type: 'video',
                //     typeid: s.hoverPlayer?.videoId,
                //     videoid: s.hoverPlayer?.videoId,
                //     category: "carousel",
                //   });
              }
              else if (hoverIndex === index) {
                // console.log('pause hover player');
                // s.hoverPlayer?.pause();
                s.hoverPlayer = p;
                p === null || p === void 0 ? void 0 : p.play();
                s.hoverPlayer = p;
                // s.trackEvent("viewport_play_video", {
                //     index,
                //     type: 'video',
                //     typeid: p?.videoId,
                //     videoid: p?.videoId,
                //     category: "carousel",
                //   });
              }
              else if (s.hoverPlayer && ((_a = s.hoverPlayer) === null || _a === void 0 ? void 0 : _a.videoId) !== (p === null || p === void 0 ? void 0 : p.videoId)) {
                // console.log('not hover player so pause from visible', p.videoId, s.hoverPlayer.videoId);
                // p.pause();
                // s.trackEvent("viewport_pause_video", {
                //     videoid: p?.videoId,
                //     category: "carousel",
                //   });
              }
              else if (s.mode === 'default' && s.hoverPlayer) {
                if (s.hoverPlayer.videoId === p.videoId) {
                  s.hoverPlayer.play();
                  // s.trackEvent("viewport_play_hover_video", {
                  //     index,
                  //     type: 'video',
                  //     typeid: s.hoverPlayer?.videoId,
                  //     videoid: s.hoverPlayer?.videoId,
                  //     category: "carousel",
                  //   });
                }
                else {
                  // s.hoverPlayer.pause();
                  // s.trackEvent("viewport_pause_hover_video", {
                  //     videoid: s.hoverPlayer?.videoId,
                  //     category: "carousel",
                  //   });
                }
              }
            }
          }
          else if (s.items[index].type === 'video' && !p) {
            setTimeout(async () => await s.checkVisibleItems(s), 100);
          }
        });
      }
      else {
        setTimeout(async () => await s.checkVisibleItems(s), 100);
      }
    }
  }
  async addHoverListener(s = this) {
    var _a;
    if (!s.fullscreen && !s.fullscreenOpen && s.mode === 'default') {
      const aplayers = (_a = s.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelectorAll(".as-carousel .carousel-cell");
      if (aplayers.length === s.items.length) {
        aplayers.forEach((item, index) => {
          const p = item.querySelector('as-player');
          if (p && s.items[index].type === 'video') {
            p.addEventListener("mouseover", function () {
              var _a, _b, _c;
              // console.log('mouse over player', p, index);
              if (((_a = s.hoverPlayer) === null || _a === void 0 ? void 0 : _a.videoId) !== (p === null || p === void 0 ? void 0 : p.videoId) && !((_b = s.hoverPlayer) === null || _b === void 0 ? void 0 : _b.isPlaying)) {
                // console.log('mouse over player change', p, index);
                // s.hoverPlayer?.pause();
                // s.trackEvent("pause_hover_video", {
                //   videoid: s.hoverPlayer?.videoId,
                //   category: "carousel",
                // });
                s.hoverPlayer = p;
                (_c = s.hoverPlayer) === null || _c === void 0 ? void 0 : _c.play();
                // s.trackEvent("play_hover_video", {
                //   index,
                //   type: 'video',
                //   typeid: s.hoverPlayer?.videoId,
                //   videoid: s.hoverPlayer?.videoId,
                //   category: "carousel",
                // });
              }
            }, {
              passive: true,
            });
          }
          else if (!p && s.items[index].type === 'video') {
            setTimeout(() => s.addHoverListener(s), 100);
          }
        });
      }
      else {
        setTimeout(() => s.addHoverListener(s), 100);
      }
    }
  }
  checkSetupFlkty(s) {
    var _a;
    const videonodes = (_a = s.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelectorAll(`${this.fullscreen ? '.fs-as-carousel .carousel-cell' : '.as-carousel .carousel-cell'}`);
    if ((videonodes === null || videonodes === void 0 ? void 0 : videonodes.length) === s.items.length) {
      s.setupFlkty();
    }
    else {
      setTimeout(() => s.checkSetupFlkty(s), 100);
    }
  }
  setupFlkty() {
    var _a, _b, _c;
    // console.log('setting up flkty', this.items, this.fullscreen);
    const els = this.el.shadowRoot.querySelectorAll('.carousel-cell');
    els.forEach((el) => {
      this.loadEle(el, null);
    });
    this.swiperloaded = true;
    var selector = '.as-carousel';
    var elem = (_a = this.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelector(selector);
    // console.log('element', elem, selector);
    const s = this;
    const nextEl = (_b = this.el) === null || _b === void 0 ? void 0 : _b.shadowRoot.querySelector(`.swiper-button-next`);
    const prevEl = (_c = this.el) === null || _c === void 0 ? void 0 : _c.shadowRoot.querySelector(`.swiper-button-prev`);
    try {
      var flk = new Swiper(elem, {
        modules: [Navigation],
        direction: 'horizontal',
        grabCursor: true,
        slidesPerView: 'auto',
        navigation: {
          nextEl,
          prevEl,
        },
        // initialIndex: (s.fullscreen) ? s.pt.selectedVid : 0,
        on: {
          afterInit: function () {
            // console.log('flk ready', elem, s.autofullscreen, s.fullscreen, s.loading);
            s.carouselReady = true;
            // s.addHoverListener(s);
          },
          slideChange: async function () {
            // console.log('change', swiper.activeIndex, s.loading);
            // const oel: any = s.el.shadowRoot.querySelector('as-product-overlay');
            // oel?.close();
            if (!s.loading) {
              // await s.checkVisibleItems(s, swiper.activeIndex);
            }
          },
        },
      });
      s.flkCsl.push(flk);
      // console.log('flkcsl', s.flkCsl);
      if (s.fullscreen) {
        // s.flkCsl[0].viewFullscreen();
        const asreels = this.el.shadowRoot.querySelector('as-reels');
        asreels === null || asreels === void 0 ? void 0 : asreels.enter(0);
        window.history.pushState({
          fullscreen: true,
        }, null, "");
      }
    }
    catch (e) {
      setTimeout(() => s.setupFlkty(), 100);
    }
  }
  backCheck() {
    var s = this;
    window.addEventListener('popstate', function (e) {
      var _a, _b, _c, _d, _e;
      // console.log(e.state);
      if (!((_a = e.state) === null || _a === void 0 ? void 0 : _a.fullscreen) || ((_b = e.state) === null || _b === void 0 ? void 0 : _b.firststate)) {
        e.preventDefault();
        // s.fullscreenPlayer?.pause();
        // s.flkCsl[0].exitFullscreen();
        const asreels = s.el.shadowRoot.querySelector('as-reels');
        asreels === null || asreels === void 0 ? void 0 : asreels.exit();
        // window.location.hash='';
      }
      else if (!((_c = e.state) === null || _c === void 0 ? void 0 : _c.firststate) && e.state.fullscreen && ((_d = s.el.shadowRoot.querySelector('as-product-overlay')) === null || _d === void 0 ? void 0 : _d.isVisible())) {
        e.preventDefault();
        (_e = s.el.shadowRoot.querySelector('as-product-overlay')) === null || _e === void 0 ? void 0 : _e.handleOverlay(e);
      }
      else {
        e.preventDefault();
        // window.location.hash='';
        // s.fullscreenPlayer?.pause();
        // s.flkCsl[0].exitFullscreen();
        const asreels = s.el.shadowRoot.querySelector('as-reels');
        asreels === null || asreels === void 0 ? void 0 : asreels.exit();
        window.history.replaceState({
          fullscreen: false,
        }, null, "");
      }
    }, {
      passive: true,
    });
  }
  loadEle(ele, observerRef) {
    const nel = this.el.shadowRoot.querySelector(`#${ele.getAttribute('id')}`);
    const cel = (nel === null || nel === void 0 ? void 0 : nel.querySelector('as-player')) || (nel === null || nel === void 0 ? void 0 : nel.querySelector('as-photo-viewer'));
    if (cel) {
      if (nel.querySelector('as-player')) {
        if (!observerRef) {
          cel === null || cel === void 0 ? void 0 : cel.load();
        }
        else {
          cel === null || cel === void 0 ? void 0 : cel.play();
        }
      }
      else {
        cel === null || cel === void 0 ? void 0 : cel.load();
        if (observerRef) {
          observerRef.unobserve(ele);
        }
      }
    }
    else {
      setTimeout(() => this.loadEle(ele, observerRef), 100);
    }
  }
  pauseEle(ele) {
    const nel = this.el.shadowRoot.querySelector(`#${ele.getAttribute('id')}`);
    const cel = (nel === null || nel === void 0 ? void 0 : nel.querySelector('as-player')) || (nel === null || nel === void 0 ? void 0 : nel.querySelector('as-photo-viewer'));
    if (cel) {
      if (nel.querySelector('as-player')) {
        cel === null || cel === void 0 ? void 0 : cel.pause();
      }
    }
    else {
      setTimeout(() => this.pauseEle(ele), 100);
    }
  }
  setupObserver() {
    // console.log('observer setup');
    const obs = new IntersectionObserver((entries, observerRef) => {
      // The callback is run when the visibility of one or more of the elements
      // being observed has changed. It's also called on page load.
      entries.forEach(async (entry) => {
        //`isIntersecting` will be `true` if any part of the element is currently visible
        if (entry.isIntersecting) {
          // We are assuming here that your Web Component is located in a file
          // named after it's tag name
          this.checkSetupFlkty(this);
          // Once we've observed this element come into view, we can safely remove
          // the observer since we won't need to import the WC code again
          observerRef.unobserve(entry.target);
          this.observer = new IntersectionObserver((entries, observerRef) => {
            // The callback is run when the visibility of one or more of the elements
            // being observed has changed. It's also called on page load.
            entries.forEach(async (entry) => {
              //`isIntersecting` will be `true` if any part of the element is currently visible
              if (entry.isIntersecting) {
                // We are assuming here that your Web Component is located in a file
                // named after it's tag name
                this.loadEle(entry.target, observerRef);
                // Once we've observed this element come into view, we can safely remove
                // the observer since we won't need to import the WC code again
                // observerRef.unobserve(entry.target);
              }
              else {
                this.pauseEle(entry.target);
              }
            });
          }, {
            rootMargin: '80px 0px 40px'
          });
          const els = this.el.shadowRoot.querySelectorAll('.carousel-cell');
          els.forEach((el) => {
            this.observer.observe(el);
          });
        }
      });
    }, {
      rootMargin: '120px 0px 50px'
    });
    setTimeout(() => {
      const els1 = this.el.shadowRoot.querySelectorAll('.as-carousel');
      els1.forEach((el) => {
        obs.observe(el);
      });
    }, 100);
  }
  trackEvent(name, data) {
    var _a;
    try {
      if (this.tk || this.tk === undefined) {
        // console.log('tracking event', name, data);
        jitsu.set({
          channelid: this.channelId,
          playlistid: this.playlistId,
          env: this.env === '' ? 'live' : this.env,
          appid: 'allstudio',
          accountid: (_a = this.playlist.channel) === null || _a === void 0 ? void 0 : _a.accountId,
          mode: this.mode,
        });
        // posthog.register_once({
        //   channelid : this.channelId,
        //   playlistid: this.playlistId,
        //   env: this.env === '' ? 'live' : this.env,
        //   appid: 'allstudio',
        //   accountid: this.playlist.channel?.accountId,
        //   mode: this.mode,
        // });
        try {
          jitsu.track(name, data);
          // posthog.capture(name,data);
        }
        catch (e) {
          console.log('jitsu tracking error', e);
        }
      }
    }
    catch (e) {
      console.log('track event', e.message);
    }
  }
  static get is() { return "as-carousel"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["as-carousel.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["as-carousel.css"]
    };
  }
  static get properties() {
    return {
      "playlistId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "pid",
        "reflect": false
      },
      "channelId": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "cid",
        "reflect": false,
        "defaultValue": "null"
      },
      "fsplaylist": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "fsplaylist",
        "reflect": false
      },
      "env": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "env",
        "reflect": false,
        "defaultValue": "''"
      },
      "mode": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "mode",
        "reflect": false,
        "defaultValue": "'default'"
      },
      "fullscreen": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "fullscreen",
        "reflect": false,
        "defaultValue": "false"
      },
      "pt": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "pt",
        "reflect": false,
        "defaultValue": "null"
      },
      "platform": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "platform",
        "reflect": false,
        "defaultValue": "'web'"
      },
      "ep": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "ep",
        "reflect": false,
        "defaultValue": "null"
      },
      "mainElzIndex": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "main-elz-index",
        "reflect": false,
        "defaultValue": "''"
      },
      "selectedVid": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "selected-vid",
        "reflect": false,
        "defaultValue": "0"
      },
      "tk": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "tk",
        "reflect": false,
        "defaultValue": "true"
      },
      "variant": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "variant",
        "reflect": false,
        "defaultValue": "\"title\""
      },
      "ch": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "ch",
        "reflect": false,
        "defaultValue": "400"
      },
      "size": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "'default'"
      }
    };
  }
  static get states() {
    return {
      "carouselReady": {},
      "carouselPlayerReady": {},
      "activeVideoId": {},
      "flkCsl": {},
      "fullscreenOpen": {},
      "playlist": {},
      "loading": {},
      "forcemute": {},
      "cslready": {},
      "swiperloaded": {}
    };
  }
  static get methods() {
    return {
      "selectIndex": {
        "complexType": {
          "signature": "(index: any) => Promise<void>",
          "parameters": [{
              "tags": [],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "exitFullScreen": {
        "complexType": {
          "signature": "() => Promise<void>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      }
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "scroll",
        "method": "scrollPage",
        "target": "window",
        "capture": false,
        "passive": true
      }, {
        "name": "load",
        "method": "onPageLoaded",
        "target": "window",
        "capture": false,
        "passive": false
      }];
  }
}
//# sourceMappingURL=as-carousel.js.map
