/*!
 * All Studio Web Components
 * Copyright (c) Halfcute Internet Pvt Ltd
 */
import { Host, h } from '@stencil/core';
import { jitsuClient } from '@jitsu/sdk-js';
// import posthog from 'posthog-js'
// if (!window.location.host.includes('127.0.0.1') && !window.location.host.includes('localhost')) {
//   posthog.init('phc_PFn3ipf7jR88MXFX73PMM6l7A0G5EeZf0llC0u5FVKv', { api_host: 'https://app.posthog.com', autocapture: false, capture_pageview: false})
// }
// //init
const jitsu = jitsuClient({
  key: "js.ku52f0vferwtf16hunn8p6.s4zhwpli8w7pwz9k0y1kc",
  tracking_host: "https://t.jitsu.com"
});
export class AsGrid {
  constructor() {
    this.items = [];
    this.showfootertitle = true;
    this.showProductChip = false;
    this.showProductCard = false;
    this.hoverPlayer = null;
    this.viewport = false;
    this.viewportcount = 0;
    this.playlistId = undefined;
    this.fsplaylist = undefined;
    this.env = '';
    this.fullscreen = false;
    this.variant = "title";
    this.tk = true;
    this.channelId = null;
    this.activeVideoId = null;
    this.fullscreenOpen = false;
    this.playlist = null;
    this.loading = true;
  }
  async scrollPage() {
    // await this.checkVisibleItems(this);
    return Promise.resolve();
  }
  componentWillLoad() {
    if (this.variant !== 'title') {
      this.showfootertitle = false;
    }
    if (this.variant === 'chip') {
      this.showProductChip = true;
    }
    if (this.fsplaylist) {
      this.playlist = this.fsplaylist;
      this.items = this.playlist.itemsdata;
      this.loading = false;
    }
    else {
      for (var i = 0; i < 10; i++) {
        this.items.push({
          title: '',
          url: null,
          loading: true,
        });
      }
    }
  }
  async componentDidLoad() {
    let cheader = {
      "Content-type": "application/json;charset=UTF-8",
    };
    if (this.channelId) {
      cheader["channel_id"] = this.channelId;
    }
    const response = await fetch(`${this.getApiUrl(this.env)}/web/playlists/${this.playlistId}`, {
      method: "GET",
      headers: cheader,
    });
    const data = await response.json();
    this.playlist = data;
    this.items = this.playlist.itemsdata;
    this.loading = false;
    try { // post hog group
      // posthog.group('accountid', `${this.env === 'live' || this.env === '' ? '': `${this.env}_`}${this.playlist.channel?.accountId}`, {
      //   env: this.env,
      //   channelid: this.channelId,
      //   channel: this.playlist.channel?.title,
      // });
    }
    catch (e) {
    }
    setTimeout(() => this.setupIntersection(), 200);
    // await this.checkVisibleItems(this, 0);
    // await this.addHoverListener(this);
    if (this.items) {
      // var elem = this.el?.shadowRoot.querySelector(`${this.fullscreen ? ".fs-as-carousel": ".as-grid"}`);
      // console.log('element', elem);
      // var s = this;
    }
  }
  render() {
    var _a, _b;
    if (!this.loading) {
      return (h(Host, null, h("div", { class: { gridWrapper: true, fullScreen: this.fullscreen } }, h("div", { id: `as-grid-${this.playlistId}`, class: 'as-grid auto-grid pure-g' }, (_a = this.items) === null || _a === void 0 ? void 0 : _a.map((item, index) => (h("div", { class: "grid-item pure-u-1-2 pure-u-sm-1-2 pure-u-md-1-4 pure-u-lg-1-4", id: `as-grid-playlist-item-${this.playlistId}-${item.type}-${item.typeId}`, key: `as-grid-playlist-item-${this.playlistId}-${item.type}-${item.typeId}` }, item.type === 'video' && h("as-player", { playlistId: this.playlistId, videoId: item.typeId, env: this.env, autoplay: false, fullscreen: this.fullscreen, fvideo: item.data, showheader: this.fullscreen, showfootertitle: this.showfootertitle, showproductchip: this.showProductChip, showproductcard: this.showProductCard, playclick: (() => {
          this.selectGridItem(index);
        }), widget: `grid_player${this.fullscreen ? '_fullscreen' : ''}` }), item.type === 'photo' && h("as-photo-viewer", { playlistId: this.playlistId, photoId: item.typeId, env: this.env, fullscreen: this.fullscreen, fphoto: item.data, showheader: this.fullscreen, showfootertitle: this.showfootertitle, showproductchip: this.showProductChip, showproductcard: this.showProductCard, playclick: (() => {
          this.selectGridItem(index);
        }), widget: `grid_player${this.fullscreen ? '_fullscreen' : ''}` }))))), h("div", { "aria-hidden": 'true' }, h("as-reels", { playlistId: this.playlistId, fullscreen: true, fsplaylist: this.playlist, tk: this.tk, env: this.env })))));
    }
    else {
      return (h(Host, null, h("div", { class: { gridWrapper: true, fullScreen: this.fullscreen } }, h("div", { id: `as-grid-${this.playlistId}-loading`, class: 'as-grid auto-grid pure-g' }, (_b = this.items) === null || _b === void 0 ? void 0 : _b.map((item, index) => (h("div", { class: "grid-item pure-u-1-2 pure-u-sm-1-2 pure-u-md-1-4 pure-u-lg-1-4", id: `as-grid-playlist-item-${this.playlistId}-${item === null || item === void 0 ? void 0 : item.title}-${index}`, key: `as-grid-playlist-item-${this.playlistId}-${item === null || item === void 0 ? void 0 : item.title}--${index}` }, h("div", { class: "cards" }, h("div", { class: "card_image loading" })))))))));
    }
  }
  setupIntersection() {
    const griditems = this.el.shadowRoot.querySelectorAll('.grid-item');
    if (griditems.length > 0 && griditems.length === this.items.length) {
      this.observer = new IntersectionObserver(this.onIntersection, {
        rootMargin: "50px 16px",
        threshold: [0, 0.4, 0.5, 1]
      });
      griditems.forEach((gi) => {
        this.observer.observe(gi);
      });
    }
    else {
      setTimeout(() => this.setupIntersection(), 100);
    }
  }
  async onIntersection(entries) {
    for (const entry of entries) {
      const aplayer = entry.target.querySelector('as-player');
      if (entry.isIntersecting) {
        if (aplayer) {
          if (entry.intersectionRatio >= 0.5) {
            aplayer.play();
          }
          else {
            aplayer.load();
            // const plid = entry.target.getAttribute('id');
            // console.log('pl', aplayer);
            aplayer === null || aplayer === void 0 ? void 0 : aplayer.pause();
          }
        }
        const aviewer = entry.target.querySelector('as-photo-viewer');
        if (aviewer) {
          aviewer.load();
          // if (this.observer) {
          //   this.observer.disconnect();
          // }
        }
      }
      else {
        if (aplayer) {
          aplayer.pause();
        }
      }
    }
  }
  ;
  getApiUrl(env) {
    let apiUrl = `https://apiv2.allstudio.live`;
    if (env === 'dev') {
      apiUrl = `${apiUrl}/dev`;
    }
    else if (env === 'qa') {
      apiUrl = `${apiUrl}/qa`;
    }
    else if (env === 'local') {
      apiUrl = 'http://localhost:4011';
    }
    return apiUrl;
  }
  getVideoUrl(vid) {
    let finalUrl = vid.url;
    try {
      if (vid.isProcessed && vid.processedUrls['576p']) {
        finalUrl = vid.processedUrls['576p'];
      }
    }
    catch (e) {
      finalUrl = vid.url;
    }
    // console.log('finalUrl', finalUrl);
    return finalUrl;
  }
  selectGridItem(index) {
    // const fel: any = this.el.shadowRoot.querySelector('.fullScreenCarousel as-carousel');
    const reels = this.el.shadowRoot.querySelector('as-reels');
    if (reels) {
      // if(this.fullscreenOpen) {
      //   this.el.shadowRoot.querySelector('.fullScreenCarousel').classList.add('isOpen');
      // } else {
      //   this.fullscreenOpen = true;
      // }
      // fel?.selectIndex(index, true);
      reels === null || reels === void 0 ? void 0 : reels.enter(index);
      this.el.shadowRoot.querySelectorAll('.grid-item').forEach((p) => { var _a; return (_a = p === null || p === void 0 ? void 0 : p.querySelector('as-player')) === null || _a === void 0 ? void 0 : _a.pause(); });
    }
    else {
      setTimeout(() => this.selectGridItem(index), 100);
    }
  }
  async addHoverListener(s = this) {
    var _a;
    if (!s.fullscreen && !s.fullscreenOpen) {
      const aplayers = (_a = s.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelectorAll(".as-grid .grid-item");
      if (aplayers.length === s.items.length) {
        aplayers.forEach((item, index) => {
          const p = item.querySelector('as-player');
          if (p && s.items[index].type === 'video') {
            p.addEventListener("mouseover", function () {
              var _a, _b, _c, _d;
              if (((_a = s.hoverPlayer) === null || _a === void 0 ? void 0 : _a.videoId) !== (p === null || p === void 0 ? void 0 : p.videoId) && !((_b = s.hoverPlayer) === null || _b === void 0 ? void 0 : _b.isPlaying)) {
                (_c = s.hoverPlayer) === null || _c === void 0 ? void 0 : _c.pause();
                s.hoverPlayer = p;
                (_d = s.hoverPlayer) === null || _d === void 0 ? void 0 : _d.play();
                // s.trackEvent("play_hover_video", {
                //   index,
                //   type: 'video',
                //   typeid: s.hoverPlayer?.videoId,
                //   videoid: s.hoverPlayer?.videoId,
                //   category: "grid",
                // });
              }
            }, {
              passive: true,
            });
          }
          else if (!p && s.items[index].type === 'video') {
            setTimeout(() => s.addHoverListener(s), 100);
          }
        });
      }
      else {
        setTimeout(() => s.addHoverListener(s), 100);
      }
    }
  }
  isInViewport(el) {
    const rect = el.getBoundingClientRect();
    // console.log(rect);
    return (rect.top >= 0 &&
      rect.left >= 0 &&
      rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
      rect.right <= (window.innerWidth || document.documentElement.clientWidth));
  }
  async checkVisibleItems(s = this, hoverIndex = null) {
    var _a, _b, _c;
    if (!s.fullscreen) {
      const agrid = (_a = s.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelector(".as-grid");
      if (s.isInViewport(agrid)) {
        if (!s.viewport) {
          s.viewport = true;
          s.viewportcount++;
          s.trackEvent('impression', {
            category: 'grid',
            view_count: s.viewportcount,
          });
        }
      }
      else {
        s.viewport = false;
      }
      const aplayers = (_b = s.el) === null || _b === void 0 ? void 0 : _b.shadowRoot.querySelectorAll(".as-grid .grid-item");
      if (aplayers.length === s.items.length) {
        (_c = s.hoverPlayer) === null || _c === void 0 ? void 0 : _c.pause();
        s.hoverPlayer = null;
        aplayers === null || aplayers === void 0 ? void 0 : aplayers.forEach((item, index) => {
          var _a, _b, _c;
          const p = item.querySelector('as-player');
          if (p && s.items[index].type === 'video') {
            if (!s.hoverPlayer && hoverIndex === null && s.isInViewport(p)) {
              (_a = s.hoverPlayer) === null || _a === void 0 ? void 0 : _a.pause();
              s.hoverPlayer = p;
              p === null || p === void 0 ? void 0 : p.play();
            }
            else if (hoverIndex === index) {
              (_b = s.hoverPlayer) === null || _b === void 0 ? void 0 : _b.pause();
              s.hoverPlayer = p;
              p === null || p === void 0 ? void 0 : p.play();
              s.hoverPlayer = p;
            }
            else if (s.hoverPlayer && ((_c = s.hoverPlayer) === null || _c === void 0 ? void 0 : _c.videoId) !== (p === null || p === void 0 ? void 0 : p.videoId)) {
              p === null || p === void 0 ? void 0 : p.pause();
            }
            else if (s.hoverPlayer) {
              if (s.hoverPlayer.videoId === p.videoId) {
                s.hoverPlayer.play();
              }
              else {
                s.hoverPlayer.pause();
              }
            }
          }
          else if (s.items[index].type === 'video' && !p) {
            // setTimeout(async ()=> await s.checkVisibleItems(s), 100);
          }
        });
      }
      else {
        // setTimeout(async ()=> await s.checkVisibleItems(s), 100);
      }
    }
  }
  trackEvent(name, data) {
    var _a;
    try {
      if (this.tk || this.tk === undefined) {
        // console.log('tracking event', name, data);
        jitsu.set({
          channelid: this.channelId,
          playlistid: this.playlistId,
          env: this.env === '' ? 'live' : this.env,
          appid: 'allstudio',
          accountid: (_a = this.playlist.channel) === null || _a === void 0 ? void 0 : _a.accountId,
          category: 'grid',
        });
        // posthog.register_once({
        //   channelid : this.channelId,
        //   playlistid: this.playlistId,
        //   env: this.env === '' ? 'live' : this.env,
        //   appid: 'allstudio',
        //   accountid: this.playlist.channel?.accountId,
        //   category: 'grid',
        // });
        try {
          jitsu.track(name, data);
          // posthog.capture(name,data);
        }
        catch (e) {
          // console.log('jitsu tracking error', e);
        }
      }
    }
    catch (e) {
      // console.log('track event', e.message);
    }
  }
  static get is() { return "as-grid"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["as-grid.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["as-grid.css"]
    };
  }
  static get properties() {
    return {
      "playlistId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "pid",
        "reflect": false
      },
      "fsplaylist": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "fsplaylist",
        "reflect": false
      },
      "env": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "env",
        "reflect": false,
        "defaultValue": "''"
      },
      "fullscreen": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "fullscreen",
        "reflect": false,
        "defaultValue": "false"
      },
      "variant": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "variant",
        "reflect": false,
        "defaultValue": "\"title\""
      },
      "tk": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "tk",
        "reflect": false,
        "defaultValue": "true"
      },
      "channelId": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "cid",
        "reflect": false,
        "defaultValue": "null"
      }
    };
  }
  static get states() {
    return {
      "activeVideoId": {},
      "fullscreenOpen": {},
      "playlist": {},
      "loading": {}
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "scroll",
        "method": "scrollPage",
        "target": "window",
        "capture": false,
        "passive": true
      }];
  }
}
//# sourceMappingURL=as-grid.js.map
