/*!
 * All Studio Web Components
 * Copyright (c) Halfcute Internet Pvt Ltd
 */
import { Host, h } from '@stencil/core';
import { jitsuClient } from '@jitsu/sdk-js';
// import posthog from 'posthog-js'
// if (!window.location.host.includes('127.0.0.1') && !window.location.host.includes('localhost')) {
//   posthog.init('phc_PFn3ipf7jR88MXFX73PMM6l7A0G5EeZf0llC0u5FVKv', { api_host: 'https://app.posthog.com', autocapture: false, capture_pageview: false})
// }
// import LazyLoad from "vanilla-lazyload";
// //init
const jitsu = jitsuClient({
  key: "js.ku52f0vferwtf16hunn8p6.s4zhwpli8w7pwz9k0y1kc",
  tracking_host: "https://t.jitsu.com"
});
export class AsPhotoViewer {
  constructor() {
    this.shopifyProduct = null;
    this.shopifyVariantId = null;
    this.shopifyQty = 1;
    this.imgloaded = false;
    this.photoId = undefined;
    this.fphoto = undefined;
    this.channelId = null;
    this.playlistId = null;
    this.env = '';
    this.showheader = true;
    this.showheadertitle = true;
    this.showfooterplay = false;
    this.showfootertitle = false;
    this.showproductchip = false;
    this.showproductcard = false;
    this.w = null;
    this.h = null;
    this.sw = undefined;
    this.sh = undefined;
    this.fullscreen = false;
    this.playclick = undefined;
    this.mode = 'story';
    this.position = 'br';
    this.piphandler = null;
    this.platform = 'web';
    this.widget = 'storyblok';
    this.shopify = false;
    this.tk = true;
    this.placeholder = true;
    this.productoverlay = null;
    this.index = null;
    this.size = 'default';
    this.photo = null;
    this.photoUrl = undefined;
    this.hidden = false;
    this.handlerPipMode = false;
    this.addedToCart = false;
    this.addToCartLoading = false;
    this.loading = true;
  }
  async windowResize() {
    // show a prompt
    var s = this;
    const vidEl = this.el.shadowRoot.querySelector('.as-photo-wrapper');
    this.resetHeight(vidEl, s);
  }
  async pageExit() {
    // show a prompt
    if (this.photo) {
      // this.trackEvent("page_exit", {
      //   category: this.getViewerCategory(),
      //   ...this.getCtaAttributes(this),
      // });
    }
  }
  async load() {
    if (this.loading) {
      setTimeout(this.load, 100);
    }
    else if (!this.imgloaded) {
      try {
        this.loadImg();
      }
      catch (e) {
        setTimeout(this.load, 100);
      }
    }
  }
  async closeoverlay() {
    const overlay = this.productoverlay ? this.productoverlay : this.el.shadowRoot.querySelector('as-product-overlay');
    overlay === null || overlay === void 0 ? void 0 : overlay.close(false);
  }
  componentWillLoad() {
    if (this.mode === 'pinned') {
      this.enablePip();
      if (this.widget === 'storyblok') {
        this.widget = 'floating_photo_viewer';
      }
    }
    if (this.piphandler) {
      // console.log('handler pip mode fls', this.fullscreen);
      this.handlerPipMode = true;
    }
  }
  async componentDidLoad() {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    var win = window;
    if (!this.sw) {
      this.sw = this.el.getBoundingClientRect().width;
      this.sh = this.el.getBoundingClientRect().height;
      if (this.h) {
        this.sh = parseInt(this.h.replace('px', ''));
      }
    }
    vidEl = this.el.shadowRoot.querySelector('.as-photo-wrapper');
    const s = this;
    this.resetHeight(vidEl, s);
    if ((win === null || win === void 0 ? void 0 : win.Shopify) && this.platform === 'shopify') {
      this.shopify = true;
      if (this.mode === 'pinned') {
        const sp = await this.onShopifyProductPage();
        if (!sp) {
          console.log('not product page - photo viewer wont load');
          return false;
        }
      }
      console.log('shopify product', this.shopifyProduct);
    }
    if (this.fphoto) {
      const finalphoto = this.fphoto;
      this.photoUrl = this.getPhotoUrl(finalphoto);
      this.photo = finalphoto;
    }
    let finalphoto = this.photo || null;
    if (this.placeholder) {
      //placeholder
    }
    if (!this.photo) {
      let cheader = {
        "Content-type": "application/json;charset=UTF-8",
      };
      if (this.channelId) {
        cheader["channel_id"] = this.channelId;
      }
      let vUrl = `${this.getApiUrl(this.env)}/web/photos/`;
      if (this.photoId) {
        vUrl = `${vUrl}${this.photoId}`;
      }
      else if (this.platform === 'shopify' && ((_b = (_a = this.shopifyProduct) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id)) {
        vUrl = `${vUrl}product-photo?productId=${(_d = (_c = this.shopifyProduct) === null || _c === void 0 ? void 0 : _c.product) === null || _d === void 0 ? void 0 : _d.id}&platform=shopify`;
      }
      else {
        console.log('no api to fetch from');
        return false;
      }
      // console.log(vUrl);
      const vidResponse = await fetch(vUrl, {
        method: "GET",
        headers: cheader,
      });
      if (vidResponse.status === 200) {
        const vidData = await vidResponse.json();
        finalphoto = vidData;
        this.photoUrl = this.getPhotoUrl(finalphoto);
      }
      else {
        return false;
      }
    }
    if (this.platform === 'shopify' && this.shopify) {
      if ((finalphoto === null || finalphoto === void 0 ? void 0 : finalphoto.shoppableType) === 'addtocart' &&
        ((_e = finalphoto.shoppableData) === null || _e === void 0 ? void 0 : _e.productId) !== this.shopifyProduct.product.id.toString()) {
        console.log('product id doesn\'t match');
        return false;
      }
    }
    this.photo = finalphoto;
    this.loading = false;
    if (this.tk && this.photo) {
      this.setJitsu(this);
    }
    //     const img: HTMLImageElement = 
    //     this.el.shadowRoot.querySelector('img');
    // ​
    //     if (img) {
    //       this.observer = new IntersectionObserver(this.onIntersection);
    //       this.observer.observe(img);
    //     }
    if ((_h = (_g = (_f = this.photo) === null || _f === void 0 ? void 0 : _f.channel) === null || _g === void 0 ? void 0 : _g.primaryColor) === null || _h === void 0 ? void 0 : _h.hex) {
      var style = document.createElement('style');
      style.innerHTML = `.photoWrapper { --as-player-btn-color: ${this.photo.channel.primaryColor.hex}; }`;
      this.el.shadowRoot.appendChild(style);
    }
    if (this.photo || this.placeholder) {
      // if(!this.sw) {
      //   this.sw = this.el.getBoundingClientRect().width;
      //   this.sh = this.el.getBoundingClientRect().height;
      // }
      var vidEl = this.el.shadowRoot.querySelector('.as-photo-wrapper');
      const s = this;
      // this.resetHeight(vidEl, s);
      if (!this.fullscreen && this.playclick && this.mode != 'pinned') {
        // not pinned and play click exists - can be carousel or grid
        this.playControlClick = () => this.widgetPlayClick(s);
      }
      //pip
      this.closePipClick = () => {
        s.hidden = true;
        s.trackEvent('closed', {
          category: 'floating_photo_viewer',
        });
      };
      if (this.mode === 'pinned') {
        this.playControlClick = () => this.pipFullScreen(vidEl, s);
        this.playclick = () => this.playControlClick();
      }
      this.enterPipClick = (clicked = true, click_type = 'icon') => {
        console.log('enter pip click');
        if (!s.handlerPipMode) {
          s.fullscreen = false;
          s.enablePip();
        }
        else {
          s.piphandler();
        }
        if (clicked) {
          s.trackEvent('closed_click', Object.assign({ click_type, category: s.getViewerCategory() }, s.getCtaAttributes(s)));
        }
      };
      this.backdropClick = () => {
        console.log('back drop click');
        if (this.mode === 'pinned') {
          this.enterPipClick(true, 'backdrop');
        }
        else {
          this.fullscreen = false;
        }
      };
    }
  }
  render() {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    if (this.loading) {
      return (h(Host, null, h("div", { class: { photoWrapper: true,
          'as-photo-wrapper': true,
          'pinned': (this.mode === 'pinned' && !this.fullscreen),
          'fullscreen': (this.fullscreen && this.mode === 'pinned' || this.widget === 'carousel_photo_viewer_fullscreen'),
          'br': (this.position === 'br'),
          'bl': (this.position === 'bl'),
          'tr': (this.position === 'tr'),
          'tl': (this.position === 'tl'),
          'hidden': (this.hidden),
          'sizemini': (this.size === 'mini'),
        }, id: `as-photo-viewer-${((_a = this.photo) === null || _a === void 0 ? void 0 : _a.id) || Date.now() * Math.random()}`, style: { width: `${this.w && !this.fullscreen ? this.w : '100%'}`, height: `${this.h ? this.h : (this.fullscreen || this.sw < 576 ? '100vh' : '75vh')}` } }, h("div", { class: "cards fullheight" }, h("div", { class: "card_image loading" }), h("div", { class: "card_title loading" })))));
    }
    else {
      return (h(Host, null, this.mode === 'pinned' && h("div", { class: { backdrop: (this.mode === 'pinned'),
          fullscreen: this.fullscreen
        }, onClick: this.backdropClick }), (!this.loading) && h("div", { class: { photoWrapper: true,
          'as-photo-wrapper': true,
          'pinned': (this.mode === 'pinned' && !this.fullscreen),
          'fullscreen': (this.fullscreen && this.mode === 'pinned' || this.widget === 'carousel_photo_viewer_fullscreen'),
          'br': (this.position === 'br'),
          'bl': (this.position === 'bl'),
          'tr': (this.position === 'tr'),
          'tl': (this.position === 'tl'),
          'hidden': (this.hidden),
          'sizemini': (this.size === 'mini'),
        }, id: `as-photo-viewer-${((_b = this.photo) === null || _b === void 0 ? void 0 : _b.id) || Date.now() * Math.random()}`, style: { width: `${this.w && !this.fullscreen ? this.w : '100%'}`, height: `${this.h ? this.h : (this.fullscreen || this.sw < 576 ? '100vh' : '75vh')}` } }, !this.productoverlay && h("as-product-overlay", { trackevent: this.trackEvent, env: this.env }), !this.photo && this.mode !== 'pinned' && (h("div", { class: "cards" }, h("div", { class: "card_image loading" }), h("div", { class: "card_title loading" }))), this.photo && (h("div", { style: { height: '100%', position: 'relative' } }, h("div", { class: "photoviewer", style: {
          aspectRatio: `(${this.w ? this.w.replace('px', '') : 9})/(${this.h ? this.h.replace('px', '') : 16})`
        } }, h("img", { class: "lazy", style: { objectFit: 'cover' }, alt: this.photo.title, "data-src": this.photo.finalUrls['576'] || "https://cdnv2.allstudio.live/video-poster-placeholder.png" })), h("div", { class: "flexWrapper" }, h("main", { class: "vmWrapper" }, this.showheader && h("div", { class: { topPlayerShow: true } }), h("div", { class: { bottomPlayerShow: true } }), (this.playclick && !this.fullscreen) ? (h("div", { class: "fullphotoviewerclick", onClick: this.playControlClick }, h("div", { style: { height: `${this.h}` } }))) : h("div", null), this.showheader ? (h("div", { class: "topRight controls" }, this.showheadertitle ? (h("div", { class: {
          photoTitle: true,
        } }, h("span", { class: { photoTitleText: true } }, this.photo.title))) : (h("div", null)), !this.fullscreen && this.mode != 'pinned' && h("div", null), this.mode === 'pinned' && !this.fullscreen && h("div", { class: "closeIcon control", onClick: this.closePipClick }, h("div", { class: "icon", role: "img", "aria-label": "Close" }, h("svg", { viewBox: "0 0 24 24", xmlns: "http://www.w3.org/2000/svg" }, h("path", { d: "M19 6.41L17.59 5L12 10.59L6.41 5L5 6.41L10.59 12L5 17.59L6.41 19L12 13.41L17.59 19L19 17.59L13.41 12L19 6.41Z" })))), this.fullscreen && (this.mode === 'pinned') && h("div", { class: "pipIconControl closeIcon", onClick: this.enterPipClick }, h("div", { class: "icon", role: "img", "aria-label": "Close" }, h("svg", { viewBox: "0 0 24 24", xmlns: "http://www.w3.org/2000/svg" }, h("path", { d: "M19 6.41L17.59 5L12 10.59L6.41 5L5 6.41L10.59 12L5 17.59L6.41 19L12 13.41L17.59 19L19 17.59L13.41 12L19 6.41Z" })))), this.fullscreen && (this.handlerPipMode) && h("div", { class: "pipHandlerIconControl", onClick: this.enterPipClick }, h("div", { class: "closeIcon control" }, h("div", { class: "icon", role: "img", "aria-label": "Close" }, h("svg", { viewBox: "0 0 24 24", xmlns: "http://www.w3.org/2000/svg" }, h("path", { d: "M19 6.41L17.59 5L12 10.59L6.41 5L5 6.41L10.59 12L5 17.59L6.41 19L12 13.41L17.59 19L19 17.59L13.41 12L19 6.41Z" }))))), this.fullscreen && this.mode !== 'pinned' && !this.handlerPipMode && (h("div", { style: { width: '30px', height: '28px' } })))) : (h("span", null)), this.showfootertitle ? (h("div", { class: "bottomLeft controls" }, h("div", { class: {
          footerTitle: true,
        } }, h("span", { class: { footerTitleText: true } }, this.photo.title)))) : (h("span", null))), !this.showfootertitle && this.showheadertitle && this.photo.shoppableType === 'cta'
        && ((_c = this.photo.shoppableData) === null || _c === void 0 ? void 0 : _c.ctaLink) !== '' && (h("footer", { class: "ctaLinkContainer" }, h("a", { class: {
          ctaLink: true,
          large: (this.photo.channel.ctaButtonSize === 'large'),
          small: (this.photo.channel.ctaButtonSize === 'small'),
        }, style: {
          "color": `${this.photo.channel.textColor.hex}`,
          "background-color": `${this.photo.channel.primaryColor.hex}`,
        }, href: (_d = this.photo.shoppableData) === null || _d === void 0 ? void 0 : _d.ctaLink, title: (_e = this.photo.shoppableData) === null || _e === void 0 ? void 0 : _e.ctaType }, (_f = this.photo.shoppableData) === null || _f === void 0 ? void 0 : _f.ctaType))), !this.showfootertitle && this.showheadertitle && this.platform === 'shopify' && this.photo.shoppableType === 'addtocart'
        && this.shopifyVariantId && (h("footer", { class: "ctaLinkContainer" }, this.addedToCart ? h("div", { class: "toastMessage" }, "Item added to cart.") :
        h("a", { class: {
            ctaLink: true,
            large: (this.photo.channel.ctaButtonSize === 'large'),
            small: (this.photo.channel.ctaButtonSize === 'small'),
          }, style: {
            "color": `${this.photo.channel.textColor.hex}`,
            "background-color": `${this.photo.channel.primaryColor.hex}`
          }, onClick: async (e) => {
            e.preventDefault();
            if (!this.addToCartLoading)
              await this.addShopifyItem();
          }, title: (_g = this.photo.shoppableData) === null || _g === void 0 ? void 0 : _g.ctaType }, this.addToCartLoading ? (h("div", { class: "lds-ring" }, h("div", null), h("div", null), h("div", null), h("div", null))) : (_h = this.photo.shoppableData) === null || _h === void 0 ? void 0 : _h.ctaType))), this.showproductchip && ((_j = this.photo.shoppableData) === null || _j === void 0 ? void 0 : _j.products) && !this.loading && this.playclick ? (h("footer", { class: "ctaLinkContainer" }, h("as-product-chip", { size: this.size, onClick: this.playControlClick, trackevent: this.trackEvent, products: (_k = this.photo.shoppableData) === null || _k === void 0 ? void 0 : _k.products }))) : (h("span", null)), this.showproductcard && ((_l = this.photo.shoppableData) === null || _l === void 0 ? void 0 : _l.products) && !this.loading ? (h("footer", { class: "ctaLinkContainer" }, h("as-product-card-slider", { products: (_m = this.photo.shoppableData) === null || _m === void 0 ? void 0 : _m.products, overlay: this.productoverlay ? this.productoverlay : this.el.shadowRoot.querySelector('as-product-overlay'), channel: this.photo.channel, photoviewer: this, trackevent: this.trackEvent }))) : (h("span", null))))))));
    }
  }
  getApiUrl(env) {
    let apiUrl = `https://apiv2.allstudio.live`;
    if (env === 'dev') {
      apiUrl = `${apiUrl}/dev`;
    }
    else if (env === 'qa') {
      apiUrl = `${apiUrl}/qa`;
    }
    return apiUrl;
  }
  getPhotoUrl(vid) {
    let finalUrl = vid.url;
    try {
      if (vid.finalUrls) {
        finalUrl = vid.finalUrls['576'];
      }
    }
    catch (e) {
      finalUrl = vid.url;
    }
    // console.log('finalUrl', finalUrl);
    return finalUrl;
  }
  resetHeight(vidEl, s) {
    // reset the body height to that of the inner browser
    // s.sh = window.innerHeight;
    // console.log('window inner height', s.sh);
    this.setPlayerHeight(vidEl, s);
  }
  setPlayerHeight(vidEl, s) {
    const ch = s.el.getBoundingClientRect();
    // console.log('ch final', ch, s.fullscreen);
    if (s.w || s.h) {
      // console.log('defined final', s.w, s.h, s.fullscreen);
      if (s.fullscreen) {
        s.h = `${s.sh}px`;
      }
    }
    else {
      // const cw = this.el.clientHeight;
      let vw = ch.width;
      let vh = s.sh || ch.height;
      // console.log('sw sh final', s.sw, s.sh);
      if (vw === 0 && vh === 0) {
        vw = s.sw || 0;
        vh = s.sh || 0;
      }
      if (vw === 0) {
        if (vh === 0) {
          vh = 320;
        }
        vw = vh * 9 / 16;
      }
      else if (vh > 0 && vh > vw * 16 / 9) {
        const tw = vh * 9 / 16;
        if (tw > vw && !this.fullscreen) {
          vh = vw * 16 / 9;
        }
        else if (vw === 0 && tw > 0 && !this.fullscreen) {
          vw = tw;
        }
      }
      else {
        if (vh === 0) {
          // console.log('setting photo height', vidEl);
          if (!s.fullscreen) {
            vidEl.setAttribute('style', 'height:75vh;');
          }
          else {
            vidEl.setAttribute('style', 'height:100vh;');
          }
          vh = vidEl.getBoundingClientRect().height;
          vw = vidEl.getBoundingClientRect().width;
        }
        else {
          if (vh < vw && vh > 100) {
            vw = vh * 9 / 16;
          }
          else {
            vh = vw * 16 / 9;
          }
        }
      }
      // if(vh > ch.height && ch.height> 100) {
      //   vh = ch.height;
      //   vw = vh*9/16;
      // }
      if (vw > 576) {
        vw = 576;
        vh = vw * 16 / 9;
      }
      // console.log('vw final', vw);
      s.w = `${vw}px`;
      s.h = `${vh}px`;
      // }
    }
    // console.log('final height', s.w, s.h, this.fullscreen);
  }
  enablePip() {
    this.w = '180px';
    this.h = '320px';
    this.showheader = true;
    this.showfootertitle = false;
    this.showheadertitle = false;
    this.showfooterplay = true;
  }
  pipFullScreen(vidEl, s) {
    console.log('full screen pip');
    s.trackEvent('full_screen', {
      category: 'floating_photo_viewer',
    });
    s.w = null;
    s.h = null;
    s.fullscreen = true;
    s.showheadertitle = true;
    s.showfooterplay = false;
    // s.w = '100%';
    // s.h = '100vh';
    s.setPlayerHeight(vidEl, s);
    // s.trackEvent('view', {
    //   category: 'fullscreen_photo_viewer',
    //   ...s.getCtaAttributes(s),
    // });
  }
  getCtaAttributes(s) {
    var _a, _b, _c, _d;
    if (s.fullscreen) {
      return {
        cta_type: (_a = s.photo) === null || _a === void 0 ? void 0 : _a.shoppableType,
        cta_title: (_c = (_b = s.photo) === null || _b === void 0 ? void 0 : _b.shoppableData) === null || _c === void 0 ? void 0 : _c.ctaType,
        products_count: (((_d = s.photo) === null || _d === void 0 ? void 0 : _d.shoppableType) === 'addtocart') ? 1 : 0,
      };
    }
    else {
      return {};
    }
  }
  async addShopifyItem() {
    this.addToCartLoading = true;
    this.trackEvent('addtocart_click', Object.assign(Object.assign({}, this.getCtaAttributes(this)), { category: 'fullscreen_photo_viewer', addtocart_id: this.shopifyVariantId, productid: this.shopifyProduct.product.id }));
    const result = await fetch("/cart/add.json", {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
        "Accept": "application/json"
      },
      body: JSON.stringify({
        id: this.shopifyVariantId,
        quantity: this.shopifyQty,
      })
    });
    this.addToCartLoading = false;
    if (result.status === 200) {
      this.addedToCart = true;
      this.trackEvent('addtocart_success', Object.assign(Object.assign({}, this.getCtaAttributes(this)), { category: 'fullscreen_photo_viewer', addtocart_id: this.shopifyVariantId, productid: this.shopifyProduct.product.id }));
      const data = await result.json();
      if (!result.redirected) {
        var s = this;
        setTimeout(function () {
          window.location.reload();
          s.enterPipClick(false);
        }, 600);
      }
      return data;
    }
    else {
      this.trackEvent('addtocart_failure', Object.assign(Object.assign({}, this.getCtaAttributes(this)), { category: 'fullscreen_photo_viewer', addtocart_id: this.shopifyVariantId, productid: this.shopifyProduct.product.id }));
      return false;
    }
  }
  async onShopifyProductPage() {
    var _a, _b, _c, _d, _e;
    const w = window;
    const path = w.location.pathname;
    // The pathname most likely looks like /collections/something/products/product-handle
    const potentialHandle = path.substring(path.lastIndexOf("/") + 1);
    if ((w === null || w === void 0 ? void 0 : w.meta) && ((_a = w.meta) === null || _a === void 0 ? void 0 : _a.product.id)) {
      console.log('returning p from meta');
      this.shopifyProduct = w.meta;
      this.shopifyVariantId = ((_c = (_b = this.shopifyProduct) === null || _b === void 0 ? void 0 : _b.product) === null || _c === void 0 ? void 0 : _c.variants[0].id) || null;
      return this.shopifyProduct;
    }
    const result = await fetch(`/products/${potentialHandle}.json`, {
      method: "GET",
      headers: {
        "Accept": "application/json"
      }
    });
    if (result.status === 200) {
      this.shopifyProduct = await result.json();
      this.shopifyVariantId = ((_e = (_d = this.shopifyProduct) === null || _d === void 0 ? void 0 : _d.product) === null || _e === void 0 ? void 0 : _e.variants[0].id) || null;
      return this.shopifyProduct;
    }
    else {
      return false;
    }
  }
  getViewerCategory() {
    if (this.fullscreen && this.mode === 'pinned') {
      return 'fullscreen_photo_viewer';
    }
    return this.widget;
  }
  widgetPlayClick(s) {
    console.log('widget play click', s.widget);
    s.trackEvent('full_screen', {
      category: s.getViewerCategory(),
    });
    s.playclick();
    // s.trackEvent('view', {
    //   category: `${s.widget}_fullscreen`,
    //   ...s.getCtaAttributes(s),
    // });
  }
  setJitsu(s) {
    var _a, _b;
    jitsu.set({
      channelid: s.photo.channelId,
      photoid: s.photo.id,
      width: s.photo.width,
      height: s.photo.height,
      category: s.widget,
      env: s.env === '' ? 'live' : s.env,
      appid: 'allstudio',
      accountid: (_b = (_a = s.photo) === null || _a === void 0 ? void 0 : _a.channel) === null || _b === void 0 ? void 0 : _b.accountId,
      playlistid: s.playlistId,
      index: s.index,
      type: 'photo',
      typeId: s.photo.id,
      videoid: null,
    });
    // posthog.group('accountid', `${s.env === 'live' || s.env === '' ? '': `${s.env}_`}${s.photo?.channel?.accountId}`, {
    //   env: s.env,
    //   channelid: s.photo.channelId,
    //   channel: s.photo?.channel?.title,
    // });
    try {
      // posthog.register_once({
      //   channelid : s.photo.channelId,
      //   photoid: s.photo.id,
      //   width: s.photo.width,
      //   height: s.photo.height,
      //   category: s.widget,
      //   env: s.env === '' ? 'live' : s.env,
      //   appid: 'allstudio',
      //   accountid: s.photo?.channel?.accountId,
      //   playlistid: s.playlistId,
      //   index: s.index,
      //   type: 'photo',
      //   typeId: s.photo.id,
      //   videoid: null,
      // }); 
    }
    catch (e) {
    }
  }
  async onIntersection(entries) {
    for (const entry of entries) {
      if (entry.isIntersecting) {
        if (this.observer) {
          this.observer.disconnect();
        }
        this.loadImg();
      }
    }
  }
  ;
  async loadImg() {
    var img = this.el.shadowRoot.querySelector('img');
    img.setAttribute('src', img.getAttribute('data-src'));
    this.imgloaded = true;
  }
  trackEvent(name, data, s = null) {
    if (!s) {
      s = this;
    }
    else {
      s.setJitsu(s);
    }
    if (s.tk || s.tk === undefined) {
      // console.log('tracking event', name, data);
      try {
        jitsu.track(name, data);
        // posthog.capture(name, data);
      }
      catch (e) {
        console.log('jitsu tracking error', e);
      }
    }
  }
  static get is() { return "as-photo-viewer"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["as-photo-viewer.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["as-photo-viewer.css"]
    };
  }
  static get assetsDirs() { return ["icons"]; }
  static get properties() {
    return {
      "photoId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "vid",
        "reflect": false
      },
      "fphoto": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "fphoto",
        "reflect": false
      },
      "channelId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "cid",
        "reflect": false,
        "defaultValue": "null"
      },
      "playlistId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "pid",
        "reflect": false,
        "defaultValue": "null"
      },
      "env": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "env",
        "reflect": false,
        "defaultValue": "''"
      },
      "showheader": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "showheader",
        "reflect": false,
        "defaultValue": "true"
      },
      "showheadertitle": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "showheadertitle",
        "reflect": false,
        "defaultValue": "true"
      },
      "showfooterplay": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "showfooterplay",
        "reflect": false,
        "defaultValue": "false"
      },
      "showfootertitle": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "showfootertitle",
        "reflect": false,
        "defaultValue": "false"
      },
      "showproductchip": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "showproductchip",
        "reflect": false,
        "defaultValue": "false"
      },
      "showproductcard": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "showproductcard",
        "reflect": false,
        "defaultValue": "false"
      },
      "w": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "w",
        "reflect": false,
        "defaultValue": "null"
      },
      "h": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "h",
        "reflect": false,
        "defaultValue": "null"
      },
      "sw": {
        "type": "number",
        "mutable": true,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "sw",
        "reflect": false
      },
      "sh": {
        "type": "number",
        "mutable": true,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "sh",
        "reflect": false
      },
      "fullscreen": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "fullscreen",
        "reflect": false,
        "defaultValue": "false"
      },
      "playclick": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "playclick",
        "reflect": false
      },
      "mode": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "mode",
        "reflect": false,
        "defaultValue": "'story'"
      },
      "position": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "position",
        "reflect": false,
        "defaultValue": "'br'"
      },
      "piphandler": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "piphandler",
        "reflect": false,
        "defaultValue": "null"
      },
      "platform": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "platform",
        "reflect": false,
        "defaultValue": "'web'"
      },
      "widget": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "widget",
        "reflect": false,
        "defaultValue": "'storyblok'"
      },
      "shopify": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "shopify",
        "reflect": false,
        "defaultValue": "false"
      },
      "tk": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "tk",
        "reflect": false,
        "defaultValue": "true"
      },
      "placeholder": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "placeholder",
        "reflect": false,
        "defaultValue": "true"
      },
      "productoverlay": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "productoverlay",
        "reflect": false,
        "defaultValue": "null"
      },
      "index": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "index",
        "reflect": false,
        "defaultValue": "null"
      },
      "size": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "'default'"
      }
    };
  }
  static get states() {
    return {
      "photo": {},
      "photoUrl": {},
      "hidden": {},
      "handlerPipMode": {},
      "addedToCart": {},
      "addToCartLoading": {},
      "loading": {}
    };
  }
  static get methods() {
    return {
      "load": {
        "complexType": {
          "signature": "() => Promise<void>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "closeoverlay": {
        "complexType": {
          "signature": "() => Promise<void>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      }
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "resize",
        "method": "windowResize",
        "target": "window",
        "capture": false,
        "passive": true
      }, {
        "name": "beforeunload",
        "method": "pageExit",
        "target": "window",
        "capture": false,
        "passive": true
      }];
  }
}
// const liftP = func => (...args) =>
//   Promise.all(args).then(values => func(...values))
// const getVideo = (photo) => photo
// const getVideoL = liftP(getVideo);
//# sourceMappingURL=as-photo-viewer.js.map
