/*!
 * All Studio Web Components
 * Copyright (c) Halfcute Internet Pvt Ltd
 */
import { Host, h } from '@stencil/core';
// import Flickity from 'flickity';
import Swiper, { Navigation } from 'swiper';
export class AsProductCardSlider {
  constructor() {
    this.products = undefined;
    this.overlay = undefined;
    this.channel = undefined;
    this.player = null;
    this.photoviewer = null;
    this.trackevent = null;
  }
  // private theme?: string = 'dark';
  // private quickcart?: number = 0;
  // private imagesize?: string = 'small';
  componentWillLoad() {
    if (this.channel) {
      // this.theme = this.channel.productTheme;
      // this.quickcart = this.channel.quickCart;
      // this.imagesize = this.channel.productImageSize;
    }
  }
  componentDidLoad() {
    // new Flickity(elem, { 
    //   cellAlign: "left",
    //   cellSelector: '.carousel-cell',
    //   percentPosition: true,
    //   pageDots: false,
    // });
    this.setupSwiper();
  }
  render() {
    var _a;
    if (this.products && this.products.length > 0) {
      return (h(Host, null, h("div", { class: 'product-card-carousel swiper' }, h("div", { class: "swiper-wrapper" }, (_a = this.products) === null || _a === void 0 ? void 0 : _a.map((p, index) => (h("div", { class: "swiper-slide" }, h("as-product-card", { index: index, overlay: this.overlay, player: this.player, photoviewer: this.photoviewer, key: `product-${index}`, product: p, channel: this.channel, trackevent: this.trackevent }))))), h("div", { class: "swiper-button-prev" }), h("div", { class: "swiper-button-next" }))));
    }
    else {
      return (h(Host, null));
    }
  }
  setupSwiper() {
    var _a, _b, _c;
    var elem = (_a = this.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelector('.product-card-carousel');
    if (elem) {
      const options = {};
      if (window.innerWidth > 576) {
        options.modules = [Navigation];
        const nextEl = (_b = this.el) === null || _b === void 0 ? void 0 : _b.shadowRoot.querySelector(`.swiper-button-next`);
        const prevEl = (_c = this.el) === null || _c === void 0 ? void 0 : _c.shadowRoot.querySelector(`.swiper-button-prev`);
        options.navigation = {
          nextEl,
          prevEl,
        };
      }
      try {
        new Swiper(elem, Object.assign({
          // configure Swiper to use modules
          loop: false, grabCursor: true, direction: 'horizontal', spaceBetween: 10, slidesPerView: 'auto', edgeSwipeDetection: 'prevent', setWrapperSize: true
        }, options));
      }
      catch (e) {
        setTimeout(() => this.setupSwiper(), 100);
      }
    }
    else {
      setTimeout(() => this.setupSwiper(), 100);
    }
  }
  static get is() { return "as-product-card-slider"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["as-product-card-slider.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["as-product-card-slider.css"]
    };
  }
  static get properties() {
    return {
      "products": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "products",
        "reflect": false
      },
      "overlay": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "overlay",
        "reflect": false
      },
      "channel": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "channel",
        "reflect": false
      },
      "player": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "player",
        "reflect": false,
        "defaultValue": "null"
      },
      "photoviewer": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "photoviewer",
        "reflect": false,
        "defaultValue": "null"
      },
      "trackevent": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "trackevent",
        "reflect": false,
        "defaultValue": "null"
      }
    };
  }
  static get elementRef() { return "el"; }
}
//# sourceMappingURL=as-product-card-slider.js.map
