/*!
 * All Studio Web Components
 * Copyright (c) Halfcute Internet Pvt Ltd
 */
import { Host, h } from '@stencil/core';
import Flickity from 'flickity';
// import Swiper from 'swiper';
export class AsProductOverlay {
  constructor() {
    this.theme = 'dark';
    this.quickcart = 0;
    this.imagesize = 'small';
    this.sizeGuide = null;
    this.toastMsg = '';
    this.product = undefined;
    this.channel = undefined;
    this.trackevent = null;
    this.env = 'live';
    this.player = null;
    this.photoviewer = null;
    this.visible = false;
    this.selectedOptions = [];
    this.addedToCart = false;
    this.addToCartLoading = false;
    this.selectedVariant = null;
    this.hasVariants = false;
    this.optionerrors = {};
    this.disabledoptions = {};
    this.sizeGuideVisible = false;
  }
  componentWillLoad() {
    this.product = this.setData(this.product);
    this.setupChannel();
    this.setupSf();
  }
  componentDidLoad() {
    // Then we set the value in the --vh custom property to the root of the document
    this.setVw();
    // console.log('product cart loaded', this.theme, this.quickcart, this.imagesize);
    this.setupFlkty();
  }
  async isVisible() {
    return this.visible;
  }
  async open(product, channel = null, player, photoviewer, trackevent) {
    var _a;
    this.player = player;
    // console.log('player', this.player);
    (_a = this.player) === null || _a === void 0 ? void 0 : _a.pause();
    this.photoviewer = photoviewer;
    this.product = this.setData(product);
    this.channel = channel;
    this.trackevent = trackevent;
    this.setupChannel();
    this.setupSf();
    this.setupFlkty();
    this.visible = true;
    // this.player?.player?.pause();
    // console.log(this.el.shadowRoot.querySelector('#product-details-popup'));
    // this.el.shadowRoot.getElementById('product-details-popup').style.height = "70%";
    this.triggerPushState(true);
    window.history.replaceState({
      fullscreen: true,
      overlay: {
        open: true,
        sizeGuideVisible: false,
      }
    }, null, "");
    this.trackevent("open_product_details_overlay", Object.assign({}, this.geteventattributes(this)), this.player || this.photoviewer);
  }
  async close(play = true) {
    var _a;
    // this.el.shadowRoot.getElementById('product-details-popup').style.height = "0%";
    if (this.visible) {
      this.trackevent("close_product_details_overlay", Object.assign({}, this.geteventattributes(this)), this.player || this.photoviewer);
      this.product = null;
      this.channel = null;
      if (play) {
        (_a = this.player) === null || _a === void 0 ? void 0 : _a.play();
      }
      this.visible = false;
      this.addedToCart = false;
      this.sizeGuideVisible = false;
      this.selectedOptions = [];
      this.selectedVariant = null;
      this.optionerrors = {};
      this.triggerPushState(false);
      window.history.replaceState({
        fullscreen: true,
      }, null, "");
    }
  }
  async handleOverlay(e) {
    var _a, _b;
    e.preventDefault();
    const state = e.state;
    if (!(state === null || state === void 0 ? void 0 : state.overlay)) {
      this.close();
    }
    else {
      const overlayprop = state === null || state === void 0 ? void 0 : state.overlay;
      if (!overlayprop.sizeGuide && overlayprop.open) {
        this.sizeGuideVisible = false;
      }
      else if (overlayprop.open) {
        (_a = this.player) === null || _a === void 0 ? void 0 : _a.pause();
        this.visible = true;
        window.history.replaceState({
          fullscreen: true,
          overlay: {
            open: true,
            sizeGuideVisible: false,
          }
        }, null, "");
      }
      else {
        (_b = this.player) === null || _b === void 0 ? void 0 : _b.play();
        this.visible = false;
        window.history.replaceState({
          fullscreen: true,
        }, null, "");
      }
    }
  }
  async windowResize() {
    // show a prompt
    this.setVw();
  }
  render() {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return (h(Host, null, h("div", { class: {
        overlay: this.visible,
        backdrop: this.visible,
        darkBackdrop: (this.theme === 'dark'),
        lightBackdrop: (this.theme === 'light'),
        quickCart: (this.quickcart ? true : false),
      }, onClick: () => {
        if (this.sizeGuideVisible) {
          this.sizeGuideVisible = false;
          this.triggerPushState(true);
        }
        else {
          this.close();
        }
      } }), h("div", { class: {
        overlay: true,
        dark: (this.theme === 'dark'),
        light: (this.theme === 'light'),
        overlayopen: this.visible,
      }, id: "product-details-popup" }, this.product && h("div", { class: "product-content" }, h("div", { class: "header" }, h("div", { class: {
        "product-card": true,
        "dark": (this.theme === 'dark'),
        "light": (this.theme === 'light'),
      } }, h("img", { class: "product", onClick: () => { window.location.href = this.getVariantUrl(); }, src: this.product.platformProduct.featuredImage.url, alt: this.product.platformProduct.title }), h("div", { class: "product-card-body", onClick: () => { window.location.href = this.getVariantUrl(); } }, h("div", { class: "product-card-item-name" }, this.product.platformProduct.title), this.product.price && h("div", { class: "product-card-item-price" }, h("span", { class: "unit-price-label" }, this.product.currencySymbol, this.product.price, this.product.discount ? (h("span", { class: "discount-price-container" }, " ", h("strike", null, this.product.currencySymbol, this.product.compareAtprice), " ", h("span", { class: "percentoff" }, "(", this.product.discount, "% Off)"))) : (h("span", null))))), h("div", { class: "close-overlay", onClick: () => { this.close(); } }, h("svg", { width: "14", height: "14", viewBox: "0 0 14 14", fill: "none", xmlns: "http://www.w3.org/2000/svg" }, h("path", { d: "M14 1.41L12.59 0L7 5.59L1.41 0L0 1.41L5.59 7L0 12.59L1.41 14L7 8.41L12.59 14L14 12.59L8.41 7L14 1.41Z", fill: this.theme === 'dark' ? '#424242' : '#B5B5B5' }))))), h("div", { class: "flexWrapper" }, h("main", { class: "vmWrapper" }, h("div", { class: {
        productImages: true,
        'large': (this.imagesize === 'large'),
        'small': (this.imagesize === 'small'),
        swiper: true,
      }, id: `product-overlay-carousel-${(_d = (_c = (_b = (_a = this.product) === null || _a === void 0 ? void 0 : _a.platformProduct) === null || _b === void 0 ? void 0 : _b.images) === null || _c === void 0 ? void 0 : _c.edges) === null || _d === void 0 ? void 0 : _d.length}` }, h("div", { class: "swiper-wrapper" }, (_h = (_g = (_f = (_e = this.product) === null || _e === void 0 ? void 0 : _e.platformProduct) === null || _f === void 0 ? void 0 : _f.images) === null || _g === void 0 ? void 0 : _g.edges) === null || _h === void 0 ? void 0 : _h.map(photo => (h("div", { class: {
        'carousel-cell': true,
        'swiper-slide': true,
        'large': (this.imagesize === 'large'),
        'small': (this.imagesize === 'small'),
        'hidden': true,
      } }, h("img", { src: photo.node.url })))))), this.hasVariants && this.product.platformProduct.options.map((option, index) => {
      var _a;
      return (h("div", { class: {
          option: true,
          border: (this.product.platformProduct.options.length - 1 !== index),
        }, id: `product-variant-option-${option.name}` }, h("div", { class: "label" }, option.name, ": ", option.selectedValue, h("span", { class: "error" }, (_a = this.optionerrors) === null || _a === void 0 ? void 0 : _a[option.name]), option.name.toLowerCase() === 'size' && this.sizeGuide && h("span", { class: "guide", onClick: () => {
          this.sizeGuideVisible = true;
          this.triggerPushState(true);
        } }, "Size Guide")), h("div", { class: "optionitems" }, option.values.map((v) => {
        var _a, _b;
        return (h("div", { class: `optionvalue ${option.optionType} ${((_b = (_a = this.disabledoptions) === null || _a === void 0 ? void 0 : _a[option.name]) === null || _b === void 0 ? void 0 : _b.includes(v)) ? 'disabled' : ''} ${option.selectedValue === v ? 'selected' : ''}`, onClick: () => { var _a, _b; return ((_b = (_a = this.disabledoptions) === null || _a === void 0 ? void 0 : _a[option.name]) === null || _b === void 0 ? void 0 : _b.includes(v)) ? false : this.selOption(v, option.name); } }, v));
      }))));
    }), this.product.platformProduct.description && h("div", { class: {
        productDetails: true,
        container: true,
        borderTop: this.product.platformProduct.options.length > 0
      } }, h("div", { class: "heading" }, "Product Details"), h("div", { class: "description" }, this.product.platformProduct.description)), h("div", { id: "snackbar" }, this.toastMsg)), h("footer", { class: "ctaLinkContainer" }, h("div", null, h("a", { href: this.getVariantUrl(), onClick: async (e) => {
        e.preventDefault();
        this.trackevent("view_product_details", Object.assign({}, this.geteventattributes(this)), this.player || this.photoviewer);
        window.location.href = this.getVariantUrl();
      }, class: "ctaLink viewDetails outlinebtn" }, "View Details"), h("a", { class: {
        ctaLink: true,
      }, onClick: async (e) => {
        e.preventDefault();
        if (!this.addToCartLoading)
          await this.addItemtoCart();
      }, title: 'Add to Cart' }, this.addToCartLoading ? (h("div", { class: "lds-ring" }, h("div", null), h("div", null), h("div", null), h("div", null))) : 'Add to Cart')))), this.sizeGuide && h("div", { class: {
        sizeGuideWrapper: true,
        sizeGuideVisible: this.sizeGuideVisible,
      } }, h("div", { class: "header" }, h("div", { class: {
        "dark": (this.theme === 'dark'),
        "light": (this.theme === 'light'),
      } }, h("div", { class: "heading" }, "Size Guide"), h("div", { class: "close-overlay", onClick: () => { this.sizeGuideVisible = false; this.triggerPushState(true); } }, h("svg", { width: "14", height: "14", viewBox: "0 0 14 14", fill: "none", xmlns: "http://www.w3.org/2000/svg" }, h("path", { d: "M14 1.41L12.59 0L7 5.59L1.41 0L0 1.41L5.59 7L0 12.59L1.41 14L7 8.41L12.59 14L14 12.59L8.41 7L14 1.41Z", fill: "#424242" }))))), h("img", { src: this.sizeGuide }))))));
  }
  getPrice(range) {
    let finalPrice = `${this.getCurrencySymbol(range.minVariantPrice.currencyCode)} ${range.minVariantPrice.amount}`;
    if (range.minVariantPrice.amount !== range.maxVariantPrice.amount) {
      finalPrice = `${this.getCurrencySymbol(range.minVariantPrice.currencyCode)} ${range.minVariantPrice.amount} - ${this.getCurrencySymbol(range.minVariantPrice.currencyCode)} ${range.maxVariantPrice.amount}`;
    }
    return finalPrice;
  }
  getVariantUrl() {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    const p = (_a = this.product) === null || _a === void 0 ? void 0 : _a.platformProduct;
    let url = (p === null || p === void 0 ? void 0 : p.onlineStoreUrl) || `${(_c = (_b = this.product) === null || _b === void 0 ? void 0 : _b.storefront) === null || _c === void 0 ? void 0 : _c.url}/products/${p.handle}`;
    const w = window;
    if (w === null || w === void 0 ? void 0 : w.Shopify) {
      url = `//${window.location.host}/products/${p.handle}`;
    }
    if ((_d = p === null || p === void 0 ? void 0 : p.custom_url) === null || _d === void 0 ? void 0 : _d.value) { // meta field
      url = (_e = p === null || p === void 0 ? void 0 : p.custom_url) === null || _e === void 0 ? void 0 : _e.value;
    }
    url = `${url}?utm_campaign=allstudio&utm_medium=view_details&utm_source=product_detail_overlay`;
    if (this.selectedVariant) {
      url = `${url}&variant=${(_h = (_g = (_f = this.selectedVariant.id) === null || _f === void 0 ? void 0 : _f.split('/')) === null || _g === void 0 ? void 0 : _g.reverse()) === null || _h === void 0 ? void 0 : _h[0]}`;
    }
    return url;
  }
  getCurrencySymbol(currency) {
    var currency_symbols = {
      'USD': '$',
      'EUR': '€',
      'CRC': '₡',
      'GBP': '£',
      'ILS': '₪',
      'INR': '₹',
      'JPY': '¥',
      'KRW': '₩',
      'NGN': '₦',
      'PHP': '₱',
      'PLN': 'zł',
      'PYG': '₲',
      'THB': '฿',
      'UAH': '₴',
      'VND': '₫', // Vietnamese Dong
    };
    if (currency_symbols[currency] !== undefined) {
      return currency_symbols[currency];
    }
  }
  setData(product) {
    var _a, _b, _c, _d, _e, _f;
    if (product) {
      let np = product;
      const variants = (_a = np.platformProduct.variants) === null || _a === void 0 ? void 0 : _a.edges;
      const availablevariants = variants.filter((va) => { var _a; return (((_a = va === null || va === void 0 ? void 0 : va.node) === null || _a === void 0 ? void 0 : _a.availableForSale) === true); });
      np.defaultVariant = (_b = availablevariants === null || availablevariants === void 0 ? void 0 : availablevariants[0]) === null || _b === void 0 ? void 0 : _b.node;
      if (!np.defaultVariant) {
        np.defaultVariant = (_c = variants === null || variants === void 0 ? void 0 : variants[0]) === null || _c === void 0 ? void 0 : _c.node;
      }
      np.selectedVariant = null;
      if (((_d = np.platformProduct) === null || _d === void 0 ? void 0 : _d.hasOnlyDefaultVariant) || ((_e = np.variants) === null || _e === void 0 ? void 0 : _e.length) === 1) {
        this.hasVariants = false;
        this.selectedVariant = (_f = variants === null || variants === void 0 ? void 0 : variants[0]) === null || _f === void 0 ? void 0 : _f.node;
      }
      else {
        this.hasVariants = true;
        variants.map((variant) => {
          var _a, _b;
          if ((variant === null || variant === void 0 ? void 0 : variant.node) && !((_a = variant === null || variant === void 0 ? void 0 : variant.node) === null || _a === void 0 ? void 0 : _a.availableForSale)) {
            const opts = (_b = variant === null || variant === void 0 ? void 0 : variant.node) === null || _b === void 0 ? void 0 : _b.selectedOptions;
            opts.map((opt) => {
              if (!this.disabledoptions[opt.name]) {
                this.disabledoptions[opt.name] = [];
              }
              this.disabledoptions[opt.name].push(opt.value);
            });
          }
        });
        np.platformProduct.options = np.platformProduct.options.map(o => {
          const no = o;
          no.optionType = 'circle';
          if (!no.selectedValue) {
            no.selectedValue = null;
          }
          const seloption = this.selectedOptions.find((s) => (s.name === o.name));
          if (!seloption) {
            this.selectedOptions.push({ name: o.name, value: null });
          }
          no.values.map((nv) => {
            if (nv.length > 2) {
              no.optionType = 'default';
            }
            return 1;
          });
          return no;
        });
      }
      np.currencySymbol = this.getCurrencySymbol(np.platformProduct.priceRangeV2.minVariantPrice.currencyCode);
      np = this.setPrice(np);
      return np;
    }
  }
  setPrice(product) {
    const np = product;
    const variant = this.selectedVariant ? this.selectedVariant : np.defaultVariant;
    np.price = parseFloat(variant === null || variant === void 0 ? void 0 : variant.price);
    // console.log(variant);
    if (variant.compareAtPrice) {
      np.compareAtprice = parseFloat(variant.compareAtPrice);
      np.discount = Math.round(((np.compareAtprice - np.price) / np.compareAtprice) * 100);
    }
    return np;
  }
  setupFlkty() {
    var _a, _b, _c, _d, _e, _f;
    const imagesLength = (_d = (_c = (_b = (_a = this.product) === null || _a === void 0 ? void 0 : _a.platformProduct) === null || _b === void 0 ? void 0 : _b.images) === null || _c === void 0 ? void 0 : _c.edges) === null || _d === void 0 ? void 0 : _d.length;
    const eleId = `product-overlay-carousel-${imagesLength}`;
    var elem = (_e = this.el) === null || _e === void 0 ? void 0 : _e.shadowRoot.querySelector(`#${eleId}`);
    // console.log(elem);
    if (this.flkcsl) {
      this.flkcsl.destroy();
    }
    if (elem) {
      const options = {
        cellSelector: '.carousel-cell',
        percentPosition: false,
        pageDots: true,
        prevNextButtons: false,
        contain: true,
        cellAlign: 'left',
        // wrapAround: true,
      };
      if (imagesLength >= 5) {
        // options['wrapAround'] = true;
      }
      this.flkcsl = new Flickity(elem, options);
      (_f = this.el) === null || _f === void 0 ? void 0 : _f.shadowRoot.querySelectorAll('.carousel-cell').forEach((ele) => ele.classList.remove('hidden'));
      // 
    }
    else if (this.product) {
      setTimeout(() => this.setupFlkty(), 100);
    }
  }
  checkVariantOptions(val1, val2) {
    let check = true;
    val1.forEach((v) => {
      const t = val2.find((v2) => (v2.name === v.name && v2.value === v.value));
      if (!t) {
        check = false;
      }
    });
    return check;
  }
  selOption(value, name) {
    var _a, _b, _c;
    if ((_a = this.optionerrors) === null || _a === void 0 ? void 0 : _a[name]) {
      delete this.optionerrors[name];
      const opt = this.el.shadowRoot.querySelector(`#product-variant-option-${name}`);
      opt === null || opt === void 0 ? void 0 : opt.classList.remove('hasError');
    }
    const ind = this.selectedOptions.findIndex((s) => (s.name === name));
    // console.log('find option index', ind);
    if (ind === -1) {
      this.selectedOptions.push({ name, value });
    }
    else {
      this.selectedOptions[ind].value = value;
    }
    this.product.platformProduct.options = this.product.platformProduct.options.map((o) => {
      const no = o;
      if (no.name === name) {
        no.selectedValue = value;
      }
      return no;
    });
    this.selectedOptions = [...this.selectedOptions];
    const variants = (_b = this.product.platformProduct.variants) === null || _b === void 0 ? void 0 : _b.edges;
    this.selectedVariant = (_c = variants === null || variants === void 0 ? void 0 : variants.find((v) => (this.checkVariantOptions(v.node.selectedOptions, this.selectedOptions)))) === null || _c === void 0 ? void 0 : _c.node;
    this.setPrice(this.product);
    // console.log('selected variant', this.selectedVariant);
    // console.log(this.product.platformProduct.options);
  }
  checkedSelectedOption(value, name) {
    const ind = this.selectedOptions.findIndex((s) => (s.name === name && s.value === value));
    if (ind === -1) {
      return false;
    }
    else {
      return true;
    }
  }
  setupChannel() {
    if (this.channel) {
      var style = document.createElement('style');
      style.innerHTML = `.overlay { --asplayer-btn-color: ${this.channel.primaryColor.hex}; --asplayer-btn-txt-color: ${this.channel.textColor.hex}; }`;
      this.el.shadowRoot.appendChild(style);
      this.theme = this.channel.productTheme;
      this.quickcart = this.channel.quickCart;
      this.imagesize = this.channel.productImageSize;
    }
  }
  setupSf() {
    var _a, _b, _c, _d;
    if ((_a = this.product) === null || _a === void 0 ? void 0 : _a.storefront) {
      this.sizeGuide = ((_d = (_c = (_b = this.product.storefront.sizeGuide) === null || _b === void 0 ? void 0 : _b.defaultImg) === null || _c === void 0 ? void 0 : _c.finalUrls) === null || _d === void 0 ? void 0 : _d['576']) || null;
    }
  }
  isMobile() {
    const nav = navigator.userAgent.toLowerCase();
    return (nav.match(/iphone/i) || nav.match(/ipod/i) || nav.match(/ipad/i) || nav.match(/android/i));
  }
  ;
  triggerPushState(open) {
    const st = {
      fullscreen: true,
    };
    if (open || this.sizeGuideVisible) {
      st['overlay'] = {
        open,
        sizeGuideVisible: this.sizeGuideVisible,
      };
    }
    window.history.pushState(st, null, "");
  }
  async addItemtoCart() {
    var _a, _b, _c, _d, _e;
    this.optionerrors = {};
    let errorcount = 0;
    const s = this;
    if (!this.selectedVariant) {
      if (this.product.platform === 'shopify' && this.hasVariants) {
        const options = (_a = this.product.platformProduct) === null || _a === void 0 ? void 0 : _a.options;
        if (options) {
          options.forEach((o) => {
            const so = this.selectedOptions.find((s) => (s.name === o.name));
            const opt = s.el.shadowRoot.querySelector(`#product-variant-option-${o.name}`);
            opt.classList.remove('hasError');
            if (!so || !so.value) {
              this.optionerrors[so.name] = `Please select ${so.name.toLowerCase()}`;
              setTimeout(() => {
                opt.classList.add('hasError');
                errorcount++;
                if (errorcount <= 1) {
                  // opt.scrollIntoView({  behavior: 'smooth', block: 'nearest', inline: 'start'  });
                }
              }, 0);
            }
          });
        }
        try {
          this.isMobile() && window.navigator.vibrate(100);
        }
        catch (e) {
          // console.log('vibrate failed');
        }
        this.trackevent('addtocart_option_error', Object.assign({ category: 'product_details_overlay', errors: this.optionerrors }, this.geteventattributes(this)), this.player || this.photoviewer);
      }
      else {
        this.selectedVariant = (_e = (_d = (_c = (_b = this.product.platformProduct) === null || _b === void 0 ? void 0 : _b.variants) === null || _c === void 0 ? void 0 : _c.edges) === null || _d === void 0 ? void 0 : _d[0]) === null || _e === void 0 ? void 0 : _e.node;
        await this.addItemtoCart();
      }
    }
    else {
      this.addToCartLoading = true;
      this.trackevent('addtocart_click', Object.assign({ category: 'product_details_overlay' }, this.geteventattributes(this)), this.player || this.photoviewer);
      if (this.product.platform === 'shopify') {
        const result = await this.addShopifyItem();
        if (result.status === 200) {
          this.addedToCart = true;
          this.showSnackbar("Item added to cart.");
          this.trackevent('addtocart_success', Object.assign({ category: 'product_details_overlay' }, this.geteventattributes(this)), this.player || this.photoviewer);
          const data = (result === null || result === void 0 ? void 0 : result.data) || {};
          if (!result.redirected) {
            // console.log(result);
            this.refreshShopifyCart(result);
            this.openCart();
          }
          else {
            this.addToCartLoading = false;
          }
          return data;
        }
        else {
          this.addToCartLoading = false;
          this.trackevent('addtocart_failure', Object.assign({ category: 'product_details_overlay' }, this.geteventattributes(this)), this.player || this.photoviewer);
          return false;
        }
      }
    }
  }
  async addShopifyItem() {
    const variantid = this.selectedVariant.id.split("/").reverse()[0];
    const w = window;
    if (w === null || w === void 0 ? void 0 : w.allstudioAddtoCart) {
      const result = await w.allstudioAddtoCart(variantid);
      return result;
    }
    else {
      const result = await fetch(`/cart/add.json`, {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
          "Accept": "application/json"
        },
        body: JSON.stringify({
          id: variantid,
          quantity: 1,
        })
      });
      result.data = await result.json();
      return result;
    }
  }
  showSnackbar(msg) {
    this.toastMsg = msg;
    var x = this.el.shadowRoot.getElementById("snackbar");
    // Add the "show" class to DIV
    x.className = "show";
    // After 3 seconds, remove the show class from DIV
    setTimeout(function () { x.className = x.className.replace("show", ""); }, 3000);
  }
  openCart() {
    var _a;
    this.trackevent('open_cart', Object.assign({ category: 'product_details_overlay', forceredirect: this.channel.cartRedirect }, this.geteventattributes(this)), this.player || this.photoviewer);
    const w = window;
    if (w === null || w === void 0 ? void 0 : w.allstudioOpenCart) {
      w.allstudioOpenCart();
      this.addToCartLoading = false;
    }
    else {
      if (this.channel.cartRedirect) {
        window.location.href = "/cart?utm_campaign=opencart&utm_source=allstudio&utm_medium=product_details_overlay";
      }
      else if ((_a = this.channel) === null || _a === void 0 ? void 0 : _a.continueVideoAddtocart) {
        this.addToCartLoading = false;
      }
      else {
        var cartel = document.querySelector('a[href="/cart"]');
        cartel.click();
        this.addToCartLoading = false;
      }
    }
  }
  refreshShopifyCart(cart) {
    /*
            setTimeout(function() {
              window.location.reload();
            }, 600);*/
    document.documentElement.dispatchEvent(new CustomEvent("cart:refresh", {
      bubbles: true,
    }));
    document.documentElement.dispatchEvent(new CustomEvent("cart:updated", {
      bubbles: true,
      detail: {
        cart,
      }
    }));
  }
  setVw() {
    let vh = window.innerHeight * 0.01;
    let vw = window.innerWidth * 0.01;
    var style = document.createElement('style');
    style.innerHTML = `:host { --vh: ${vh}px; --vw: ${vw}px;  } .overlay{ --vh: ${vh}px;  --vw: ${vw}px;  }`;
    this.el.shadowRoot.appendChild(style);
  }
  geteventattributes(s) {
    var _a, _b;
    return {
      selectedOptions: s.selectedOptions,
      variantid: (_a = s.selectedVariant) === null || _a === void 0 ? void 0 : _a.id,
      productid: (_b = s.product) === null || _b === void 0 ? void 0 : _b.id,
      hasErrors: s.optionerrors.length > 0 ? true : false,
    };
  }
  static get is() { return "as-product-overlay"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["as-product-overlay.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["as-product-overlay.css"]
    };
  }
  static get properties() {
    return {
      "product": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "product",
        "reflect": false
      },
      "channel": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "channel",
        "reflect": false
      },
      "trackevent": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "trackevent",
        "reflect": false,
        "defaultValue": "null"
      },
      "env": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "env",
        "reflect": false,
        "defaultValue": "'live'"
      },
      "player": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "player",
        "reflect": false,
        "defaultValue": "null"
      },
      "photoviewer": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "photoviewer",
        "reflect": false,
        "defaultValue": "null"
      }
    };
  }
  static get states() {
    return {
      "visible": {},
      "selectedOptions": {},
      "addedToCart": {},
      "addToCartLoading": {},
      "selectedVariant": {},
      "hasVariants": {},
      "optionerrors": {},
      "disabledoptions": {},
      "sizeGuideVisible": {}
    };
  }
  static get methods() {
    return {
      "isVisible": {
        "complexType": {
          "signature": "() => Promise<boolean>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<boolean>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "open": {
        "complexType": {
          "signature": "(product: any, channel: any, player: any, photoviewer: any, trackevent: any) => Promise<void>",
          "parameters": [{
              "tags": [],
              "text": ""
            }, {
              "tags": [],
              "text": ""
            }, {
              "tags": [],
              "text": ""
            }, {
              "tags": [],
              "text": ""
            }, {
              "tags": [],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "close": {
        "complexType": {
          "signature": "(play?: boolean) => Promise<void>",
          "parameters": [{
              "tags": [],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "handleOverlay": {
        "complexType": {
          "signature": "(e: any) => Promise<void>",
          "parameters": [{
              "tags": [],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      }
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "resize",
        "method": "windowResize",
        "target": "window",
        "capture": false,
        "passive": true
      }];
  }
}
//# sourceMappingURL=as-product-overlay.js.map
