/*!
 * All Studio Web Components
 * Copyright (c) Halfcute Internet Pvt Ltd
 */
import { Host, h } from '@stencil/core';
import Swiper, { Navigation, EffectCoverflow } from 'swiper';
import { jitsuClient } from '@jitsu/sdk-js';
// import posthog from 'posthog-js'
// if (!window.location.host.includes('127.0.0.1') && !window.location.host.includes('localhost')) {
//   posthog.init('phc_PFn3ipf7jR88MXFX73PMM6l7A0G5EeZf0llC0u5FVKv', { api_host: 'https://app.posthog.com', autocapture: false, capture_pageview: false})
// }
// //init
const jitsu = jitsuClient({
  key: "js.ku52f0vferwtf16hunn8p6.s4zhwpli8w7pwz9k0y1kc",
  tracking_host: "https://t.jitsu.com"
});
export class AsReels {
  constructor() {
    this.showfootertitle = true;
    this.showProductChip = false;
    this.showProductCard = false;
    this.items = [];
    this.fullscreenPlayer = null;
    this.playlistId = undefined;
    this.channelId = null;
    this.fsplaylist = undefined;
    this.env = '';
    this.mode = 'default';
    this.fullscreen = true;
    this.platform = 'web';
    this.selectedVid = 0;
    this.tk = true;
    this.variant = "title";
    this.ch = 400;
    this.size = 'default';
    this.open = false;
    this.startindex = 0;
    this.playlist = null;
    this.loading = true;
    this.forcemute = false;
    this.cslready = false;
    this.curIndex = 0;
    this.rh = 0;
  }
  async enter(index = 0) {
    var _a, _b, _c;
    if (!this.open) {
      this.swiper.slideTo(index);
      this.open = true;
      this.startindex = index;
      if (index === 0) {
        const aplayers = (_a = this.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelectorAll('.swiper-slide');
        this.fullscreenPlayer = (_b = aplayers[0]) === null || _b === void 0 ? void 0 : _b.querySelector('as-player');
        (_c = this.fullscreenPlayer) === null || _c === void 0 ? void 0 : _c.play();
        this.curIndex = 0;
      }
      // this.curIndex = index;
      setTimeout(() => {
        const anim = this.el.shadowRoot.querySelector('.swipeup-animation');
        anim.style.display = 'none';
      }, 5000);
    }
  }
  async exit() {
    if (this.open) {
      this.open = false;
      this.closeReels();
      var uri = window.location.toString();
      if (uri.indexOf("#") > 0) {
        var clean_uri = uri.substring(0, uri.indexOf("#"));
        window.history.replaceState({}, document.title, clean_uri);
      }
    }
  }
  async windowResize() {
    let rh = window.innerHeight - 40;
    if (window.innerWidth > 576) {
      this.swiper.params.effect = 'coverflow';
      this.swiper.params.coverflowEffect = {
        rotate: 0,
        stretch: 240,
        depth: 100,
        modifier: 1,
        scale: 0.8,
        slideShadows: true,
      };
      this.swiper.params.slidesPerView = 'auto';
      this.swiper.params.centeredSlides = true;
      this.swiper.changeDirection('horizontal', true);
    }
    else {
      rh = window.innerHeight;
      this.swiper.params.effect = 'slide';
      this.swiper.params.slidesPerView = 1;
      this.swiper.params.centeredSlides = false;
      this.swiper.changeDirection('vertical', true);
    }
    this.rh = (rh < 1024) ? rh : 1024;
    this.swiper.update();
  }
  componentWillLoad() {
    var _a;
    if (this.tk === undefined) {
      this.tk = true;
    }
    if (this.variant != 'title') {
      this.showfootertitle = false;
    }
    if (this.variant === 'chip') {
      this.showProductChip = true;
    }
    if (this.fullscreen) {
      this.showfootertitle = false;
      this.showProductCard = true;
      this.showProductChip = false;
    }
    this.playlist = this.fsplaylist || null;
    this.items = ((_a = this.playlist) === null || _a === void 0 ? void 0 : _a.itemsdata) || [];
    if (!this.fsplaylist) {
      for (var i = 0; i < 10; i++) {
        this.items.push({
          title: '',
          url: null,
          loading: true,
        });
      }
    }
    else {
      this.loading = false;
    }
  }
  async componentDidLoad() {
    var _a;
    // this.setupLoadingFlkty();
    let rh = window.innerHeight - 40;
    if (window.innerWidth <= 576) {
      rh = window.innerHeight;
    }
    this.rh = (rh > 1024) ? 1024 : rh;
    if (!this.fsplaylist) {
      let cheader = {
        "Content-type": "application/json;charset=UTF-8",
      };
      if (this.channelId) {
        cheader["channel_id"] = this.channelId;
      }
      const playlistResponse = await fetch(`${this.getApiUrl(this.env)}/web/playlists/${this.playlistId}`, {
        method: "GET",
        headers: cheader,
      });
      if (playlistResponse.status === 200) {
        this.playlist = await playlistResponse.json();
        this.items = this.playlist.itemsdata;
        this.loading = false;
      }
      else {
        return false;
      }
    }
    if (window.location.hash.indexOf('as-reel-item-true') !== -1) {
      this.open = true;
    }
    if (this.items.length > 0) {
      this.channelId = this.playlist.channelId;
      if (this.fullscreen) {
        // console.log('videos', this.items);
      }
      if (this.tk) {
        jitsu.set({
          channelid: this.channelId,
          playlistid: this.playlistId,
          env: this.env === '' ? 'live' : this.env,
          appid: 'allstudio',
          accountid: (_a = this.playlist.channel) === null || _a === void 0 ? void 0 : _a.accountId,
          mode: this.mode,
        });
        //group posthog
        // posthog.group('accountid', `${this.env === 'live' || this.env === '' ? '': `${this.env}_`}${this.playlist.channel?.accountId}`, {
        //   env: this.env,
        //   channelid: this.channelId,
        //   channel: this.playlist.channel?.title,
        // });
      }
    }
    else {
      return false;
    }
    if (this.items) {
      if (window.location.hash.includes("#as-playlist-item-true")) {
        this.forcemute = true;
      }
      const s = this;
      s.checkSetup(s);
      // window.history.pushState({
      //   fullscreen: false,
      //   firststate: true,
      // }, null, "");
    }
    // final
  }
  render() {
    var _a, _b;
    return (h(Host, null, h("div", { class: { reelsWrapper: true, isOpen: this.open, sizemini: (this.size === 'mini') } }, this.loading && (h("div", { id: `as-reels-${this.playlistId}-${this.fullscreen}-loading`, class: this.fullscreen ? 'fs-as-reels-loading' : 'as-reels-loading' }, (_a = this.items) === null || _a === void 0 ? void 0 : _a.map(() => (h("div", { class: "carousel-cell swiper-slide", "data-hash": `as-reels-video-${this.fullscreen}-${this.playlistId}-${Date.now() * Math.random()}-loading` }, h("div", { class: "cards" }, h("div", { class: "card_image loading" }))))))), !this.loading && this.items && h("div", { id: `as-reels-${this.playlistId}-${this.fullscreen}-loaded`, class: "fs-as-reels swiper" }, h("div", { class: "swiper-wrapper" }, (_b = this.items) === null || _b === void 0 ? void 0 : _b.map((item, index) => (h("div", { class: "swiper-slide", id: `as-playlist-item-${this.fullscreen}-${this.playlistId}-${item.type}-${item.typeId}`, "data-hash": `as-reel-item-${this.fullscreen}-${this.playlistId}-${item.type}-${item.typeId}` }, item.type === 'video' ? (h("as-player", { index: index,
      // productoverlay={this.el.shadowRoot.querySelector('as-product-overlay')}
      tk: this.tk, playlistId: this.playlistId, videoId: item.typeId, env: this.env, autoplay: this.mode === 'autoplay' ? true : false, fullscreen: this.fullscreen, fvideo: item.data, platform: this.platform, showheader: this.fullscreen, showfootertitle: this.showfootertitle, showproductchip: this.showProductChip, showproductcard: this.showProductCard, forcemute: this.fullscreen ? this.forcemute : null, widget: `reels_player${this.fullscreen ? '_fullscreen' : ''}`, playclick: false, preload: true, h: `${this.rh}px`, piphandler: (() => {
        this.exit();
      }), mutehandler: !this.fullscreen ? false : ((val) => {
        var _a;
        this.forcemute = val;
        // console.log('mute handler', this.forcemute);
        const aplayers = (_a = this.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelectorAll(".fs-as-reels as-player");
        aplayers === null || aplayers === void 0 ? void 0 : aplayers.forEach((item) => {
          item === null || item === void 0 ? void 0 : item.muted(this.forcemute);
        });
      }) })) : h("div", null), item.type === 'photo' ? (h("as-photo-viewer", { index: index,
      // productoverlay={this.el.shadowRoot.querySelector('as-product-overlay')}
      tk: this.tk, playlistId: this.playlistId, photoId: item.typeId, env: this.env, fullscreen: this.fullscreen, fphoto: item.data, platform: this.platform, showheader: this.fullscreen, showfootertitle: this.showfootertitle, showproductchip: this.showProductChip, showproductcard: this.showProductCard, widget: `reels_photo_viewer${this.fullscreen ? '_fullscreen' : ''}`, playclick: false, h: `${this.rh}px`, piphandler: (() => {
        this.exit();
      }) })) : h("div", null), h("div", { class: "bgoverlay" })))))), h("div", { class: "swiper-button-prev" }), h("div", { class: "swiper-button-next" }), h("div", { class: "swipeup-animation vert-move" }, h("div", null, h("i", { class: "gg-chevron-double-up-o" })), h("p", null, "SWIPE UP")))));
  }
  getApiUrl(env) {
    let apiUrl = `https://apiv2.allstudio.live`;
    if (env === 'dev') {
      apiUrl = `${apiUrl}/dev`;
    }
    else if (env === 'qa') {
      apiUrl = `${apiUrl}/qa`;
    }
    else if (env === 'local') {
      apiUrl = 'http://localhost:4011';
    }
    return apiUrl;
  }
  setup(s = this) {
    var _a, _b, _c;
    // console.log('setting up flkty', this.items, this.fullscreen);
    var selector = '.fs-as-reels';
    var elem = (_a = s.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelector(selector);
    if (elem) {
      try {
        const nextEl = (_b = s.el) === null || _b === void 0 ? void 0 : _b.shadowRoot.querySelector(`.swiper-button-next`);
        const prevEl = (_c = s.el) === null || _c === void 0 ? void 0 : _c.shadowRoot.querySelector(`.swiper-button-prev`);
        // const scrollbarElem: any = this.el?.shadowRoot.querySelector(`${selector} .swiper-scrollbar`);
        let settings = {
          direction: 'horizontal',
          effect: 'coverflow',
          coverflowEffect: {
            rotate: 0,
            stretch: 240,
            depth: 100,
            modifier: 1,
            scale: 0.8,
            slideShadows: true,
          },
          slidesPerView: 'auto',
          spaceBetween: 0,
          autoHeight: true,
          centeredSlides: true,
          allowTouchMove: false,
        };
        if (window.innerWidth <= 576) {
          settings = {
            direction: 'vertical',
            slidersPerView: 1,
          };
        }
        const swiper = new Swiper(elem, Object.assign(Object.assign({
          // configure Swiper to use modules
          modules: [Navigation, EffectCoverflow], loop: false, initialSlide: this.startindex,
          // hashNavigation: {
          //   replaceState: true,
          //   watchState: true,
          // },
          navigation: {
            nextEl,
            prevEl,
          }
        }, settings), {
          // slideToClickedSlide: true,
          // scrollbar: {
          //   el: scrollbarElem,
          // },
          // slidesPerGroupAuto: true,
          grabCursor: true, on: {
            // ready: function () {
            //   // console.log('flk ready', elem, s.autofullscreen, s.fullscreen, s.loading);
            //     s.carouselReady = true;
            // },
            afterInit: function (swiper) {
              var _a, _b, _c, _d;
              // s.changePlayer(swiper.activeIndex);
              if (s.open) {
                if (!s.fullscreenPlayer || s.curIndex === 0) {
                  const aplayers = (_a = s.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelectorAll('.swiper-slide');
                  // aplayers[s.startindex]?.querySelector('as-player')?.pause();
                  s.fullscreenPlayer = (_b = aplayers[swiper.realIndex]) === null || _b === void 0 ? void 0 : _b.querySelector('as-player');
                  (_c = s.fullscreenPlayer) === null || _c === void 0 ? void 0 : _c.muted(true);
                  (_d = s.fullscreenPlayer) === null || _d === void 0 ? void 0 : _d.play();
                  setTimeout(() => {
                    const anim = s.el.shadowRoot.querySelector('.swipeup-animation');
                    anim.style.display = 'none';
                  }, 5000);
                }
              }
            },
            slideChange: async function (swiper) {
              // console.log('change', swiper.activeIndex, s.loading);
              if (!s.loading) {
                // await s.checkVisibleItems(s, swiper.activeIndex);
                s.changePlayer(swiper.activeIndex);
              }
            },
            hashChange: function () {
              var _a;
              (_a = s.fullscreenPlayer) === null || _a === void 0 ? void 0 : _a.pause();
            }
            // transitionStart: function() {
            //   const aplayers: any = s.el?.shadowRoot.querySelectorAll('.swiper-slide as-player');
            //   aplayers.forEach((p) => p.pause());
            //   this.fullscreenPlayer = null;
            // },
            // transitionEnd: function () {
            //   var index = this.realIndex;
            //   if(s.items[index].type === 'video') {
            //     const aplayers: any = s.el?.shadowRoot.querySelectorAll('.swiper-slide as-player');
            //     this.fullscreenPlayer = aplayers[index];
            //     this.fullscreenPlayer?.play();
            //   }
            // }
          }
        }));
        s.swiper = swiper;
      }
      catch (e) {
        setTimeout(() => s.setup(s), 100);
      }
    }
    else {
      setTimeout(() => s.setup(s), 200);
    }
  }
  changePlayer(activeIndex) {
    var _a, _b, _c, _d, _e, _f;
    if (this.fullscreenPlayer) {
      (_a = this.fullscreenPlayer) === null || _a === void 0 ? void 0 : _a.pause();
      this.fullscreenPlayer = null;
    }
    const aplayers = (_b = this.el) === null || _b === void 0 ? void 0 : _b.shadowRoot.querySelectorAll('.swiper-slide');
    if (this.items[this.curIndex].type === 'video' && this.curIndex !== activeIndex) {
      (_c = aplayers[this.curIndex].querySelector('as-player')) === null || _c === void 0 ? void 0 : _c.pause();
      (_d = aplayers[this.curIndex].querySelector('as-player')) === null || _d === void 0 ? void 0 : _d.closeoverlay();
      (_e = aplayers[this.curIndex].querySelector('as-photo-viewer')) === null || _e === void 0 ? void 0 : _e.closeoverlay();
    }
    if (this.items[activeIndex].type === 'video') {
      this.fullscreenPlayer = aplayers[activeIndex].querySelector('as-player');
      // console.log('playing from change', this.fullscreenPlayer);
      (_f = this.fullscreenPlayer) === null || _f === void 0 ? void 0 : _f.play();
    }
    this.curIndex = activeIndex;
  }
  checkSetup(s) {
    var _a;
    const videonodes = (_a = s.el) === null || _a === void 0 ? void 0 : _a.shadowRoot.querySelectorAll('.fs-as-reels .swiper-slide');
    if ((videonodes === null || videonodes === void 0 ? void 0 : videonodes.length) === s.items.length) {
      s.setup(s);
      const csl = s.el.shadowRoot.querySelector('.fs-as-reels');
      if (csl) {
        this.observer = new IntersectionObserver(async (entries) => {
          for (const entry of entries) {
            if (entry.isIntersecting) {
              if (this.observer) {
                this.observer.disconnect();
              }
              // const aplayers: any = entry.target.querySelectorAll('.swiper-slide as-player');
              // aplayers.forEach((ap) => {
              //   ap.load();
              // });
              const aviewers = entry.target.querySelectorAll('.swiper-slide as-photo-viewer');
              aviewers.forEach((av) => {
                av.load();
              });
              s.cslready = true;
            }
          }
        });
        this.observer.observe(csl);
      }
    }
    else {
      setTimeout(() => s.checkSetup(s), 100);
    }
  }
  openReels() {
    this.changePlayer(this.swiper.realIndex);
  }
  closeReels() {
    var _a;
    (_a = this.fullscreenPlayer) === null || _a === void 0 ? void 0 : _a.pause();
    this.fullscreenPlayer = null;
  }
  trackEvent(name, data) {
    var _a;
    if (this.tk || this.tk === undefined) {
      // console.log('tracking event', name, data);
      jitsu.set({
        channelid: this.channelId,
        playlistid: this.playlistId,
        env: this.env === '' ? 'live' : this.env,
        appid: 'allstudio',
        accountid: (_a = this.playlist.channel) === null || _a === void 0 ? void 0 : _a.accountId,
        mode: this.mode,
        category: 'reels'
      });
      // posthog.register_once({
      //   channelid : this.channelId,
      //   playlistid: this.playlistId,
      //   env: this.env === '' ? 'live' : this.env,
      //   appid: 'allstudio',
      //   accountid: this.playlist.channel?.accountId,
      //   mode: this.mode,
      //   category: 'reels'
      // })
      try {
        jitsu.track(name, data);
        // posthog.capture(name, data);
      }
      catch (e) {
        console.log('jitsu tracking error', e);
      }
    }
  }
  static get is() { return "as-reels"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["as-reels.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["as-reels.css"]
    };
  }
  static get properties() {
    return {
      "playlistId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "pid",
        "reflect": false
      },
      "channelId": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "cid",
        "reflect": false,
        "defaultValue": "null"
      },
      "fsplaylist": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "fsplaylist",
        "reflect": false
      },
      "env": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "env",
        "reflect": false,
        "defaultValue": "''"
      },
      "mode": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "mode",
        "reflect": false,
        "defaultValue": "'default'"
      },
      "fullscreen": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "fullscreen",
        "reflect": false,
        "defaultValue": "true"
      },
      "platform": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "platform",
        "reflect": false,
        "defaultValue": "'web'"
      },
      "selectedVid": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "selected-vid",
        "reflect": false,
        "defaultValue": "0"
      },
      "tk": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "tk",
        "reflect": false,
        "defaultValue": "true"
      },
      "variant": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "variant",
        "reflect": false,
        "defaultValue": "\"title\""
      },
      "ch": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "ch",
        "reflect": false,
        "defaultValue": "400"
      },
      "size": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "'default'"
      },
      "open": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "open",
        "reflect": false,
        "defaultValue": "false"
      },
      "startindex": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "startindex",
        "reflect": false,
        "defaultValue": "0"
      }
    };
  }
  static get states() {
    return {
      "playlist": {},
      "loading": {},
      "forcemute": {},
      "cslready": {},
      "curIndex": {},
      "rh": {}
    };
  }
  static get methods() {
    return {
      "enter": {
        "complexType": {
          "signature": "(index?: number) => Promise<void>",
          "parameters": [{
              "tags": [],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "exit": {
        "complexType": {
          "signature": "() => Promise<void>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      }
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "resize",
        "method": "windowResize",
        "target": "window",
        "capture": false,
        "passive": true
      }];
  }
}
//# sourceMappingURL=as-reels.js.map
