/*!
 * All Studio Web Components
 * Copyright (c) Halfcute Internet Pvt Ltd
 */
import { Host, h } from '@stencil/core';
import Plyr from 'plyr';
import { jitsuClient } from '@jitsu/sdk-js';
// import posthog from 'posthog-js'
// if (!window.location.host.includes('127.0.0.1') && !window.location.host.includes('localhost')) {
//   posthog.init('phc_PFn3ipf7jR88MXFX73PMM6l7A0G5EeZf0llC0u5FVKv', { api_host: 'https://app.posthog.com', autocapture: false, capture_pageview: false})
// }
const jitsu = jitsuClient({
  key: "js.t9oemqbo9awzn5ks4q49jg.rkdlcjmvswo2v2l1t8iqv1",
  tracking_host: "https://t.allstudio.live"
});
export class AsVideoBanner {
  constructor() {
    this.playingTime = 0;
    this.finalposter = null;
    this.pload = 'metadata';
    this.videoId = undefined;
    this.fvideo = undefined;
    this.channelId = null;
    this.env = '';
    this.w = null;
    this.h = null;
    this.poster = null;
    this.ar = 2 / 5;
    this.video = null;
    this.hiddenControls = true;
    this.loopCount = 0;
    this.bannerPlayerReady = false;
    this.bannerPlayerFinalReady = false;
    this.ssh = undefined;
    this.playerready = false;
  }
  async play() {
    // show a prompt
    // console.log(`play triggered banner`, this.player.playing);
    try {
      if (this.videoUrl && this.playerready) {
        if (!this.player.playing) {
          this.player.play();
        }
        setTimeout(() => {
          const isPlaying = this.player.playing;
          // console.log('playing', isPlaying);
          if (!isPlaying) {
            this.play();
          }
        }, 100);
      }
      else {
        setTimeout(() => this.play(), 200);
      }
    }
    catch (e) {
      // console.log('play error', e);
      this.player.muted = true;
      this.play();
    }
  }
  async windowResize() {
    // show a prompt
    var s = this;
    const vidEl = this.el.shadowRoot.querySelector('.as-video-banner-wrapper');
    this.resetHeight(vidEl, s);
    this.setupPlyr();
  }
  async pageExit() {
    // show a prompt
    if (this.video) {
      this.trackEvent("end_watch_video", Object.assign({ category: 'banner_player', loop_count: this.loopCount, playing_time: this.playingTime, watch_time: this.loopCount * this.video.duration + this.playingTime, mute: false }, this.getCtaAttributes(this)));
    }
  }
  async pageBlur() {
    // show a prompt
    if (this.video) {
      // if(this.player.playing) {
      //   this.player.pause();
      // }
      // jitsu.track("page_blur", {
      //   category: 'banner_player',
      //   loop_count: this.loopCount,
      //   playing_time: this.playingTime,
      //   mute: false,
      //   ...this.getCtaAttributes(this),
      // });
    }
  }
  async pageFocus() {
    // show a prompt
    if (this.video) {
      // this.player.play();
      // jitsu.track("page_focus", {
      //   category: 'banner_player',
      //   loop_count: this.loopCount,
      //   playing_time: this.playingTime,
      //   mute: false,
      //   ...this.getCtaAttributes(this),
      // });
    }
  }
  componentWillLoad() {
    // console.log(this.poster);
  }
  componentDidLoad() {
    // var isSafari = /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
    // if(isSafari) {
    //   this.pload = 'auto';
    // }
    if (!this.sw) {
      this.sw = this.el.getBoundingClientRect().width;
      this.ssh = this.el.getBoundingClientRect().height;
    }
    const vidEl = this.el.shadowRoot.querySelector('.as-video-banner-wrapper');
    const s = this;
    this.resetHeight(vidEl, s);
    let finalvideo = null;
    if (this.fvideo) {
      finalvideo = this.fvideo;
      this.videoUrl = this.getVideoUrl(finalvideo);
      this.video = finalvideo;
      this.videoLoaded();
    }
    else {
      let cheader = {
        "Content-type": "application/json;charset=UTF-8",
      };
      if (this.channelId) {
        cheader["channel_id"] = this.channelId;
      }
      let vUrl = `${this.getApiUrl(this.env)}/web/videos/`;
      if (this.videoId) {
        vUrl = `${vUrl}${this.videoId}`;
      }
      else {
        // console.log('no api to fetch from');
        return false;
      }
      return fetch(vUrl, {
        method: "GET",
        headers: cheader,
      }).then(response => {
        if (response.ok) {
          return response.json();
        }
        throw new Error('Something went wrong');
      })
        .then(data => {
        const vidData = data;
        finalvideo = vidData;
        this.videoUrl = this.getVideoUrl(finalvideo);
        this.video = finalvideo;
        this.videoLoaded();
      }).catch(() => {
        return false;
      });
    }
    // if(this.video.shoppableData?.platform && this.platform === 'web') {
    //   this.platform = this.video.shoppableData?.platform;
    //   console.log('platform set', this.platform);
    // }
    return true;
  }
  render() {
    var _a, _b, _c;
    return (h(Host, null, h("div", { class: { bannerWrapper: true,
        'as-video-banner-wrapper': true,
      }, id: `as-video-banner-${((_a = this.video) === null || _a === void 0 ? void 0 : _a.id) || 'loading'}`, style: { width: `${this.w ? this.w : '100%'}`, height: `${this.h ? this.h : (this.sw < 576 ? '45vh' : '60vh')}` } }, h("video", { id: "player", preload: this.pload, playsinline: true, poster: this.finalposter }, h("source", { src: this.videoUrl, type: "video/mp4" })), this.video && this.video.shoppableType === 'link'
      && ((_b = this.video.shoppableData) === null || _b === void 0 ? void 0 : _b.ctaLink) !== '' && (h("div", { class: "flexWrapper" }, h("a", { class: "vmWrapper", target: this.video.shoppableData.newTab === 1 ? '_blank' : 'none', href: (_c = this.video.shoppableData) === null || _c === void 0 ? void 0 : _c.ctaLink, onClick: (e) => {
        var _a, _b;
        e.preventDefault();
        this.trackEvent('full_click', {
          ctaLink: (_a = this.video.shoppableData) === null || _a === void 0 ? void 0 : _a.ctaLink,
          category: 'banner_player',
          loop_count: this.loopCount,
          playing_time: this.playingTime,
        });
        window.location.href = (_b = this.video.shoppableData) === null || _b === void 0 ? void 0 : _b.ctaLink;
      } }, "\u00A0"))))));
  }
  onVmReady() {
    // ...
    // console.log('vm ready banner');
    // this.bannerPlayerReady = true;
    if (!this.player.playing) {
      this.playerready = true;
      var s = this;
      setTimeout(() => {
        if (!s.player.playing) {
          console.log('not playing');
          // this.player.play();
          // s.player.querySelector('video').setAttribute('playsinline', '')
          // s.player.querySelector('video').setAttribute('muted', '')
          // s.player.querySelector('video').play();
          s.play();
        }
      }, 2500);
    }
    // var s = this;
    // setTimeout(()=> {
    //   if(!s.player.playing) {
    //     console.log('not playing');
    //     // this.player.play();
    //     // s.player.querySelector('video').setAttribute('playsinline', '')
    //     // s.player.querySelector('video').setAttribute('muted', '')
    //     // s.player.querySelector('video').play();
    //     s.play();
    //   }
    // }, 3000);
    // this.trackEvent('impression', {
    //   mute: false,
    //   loopCount: this.loopCount,
    // });
    // this.player.play();
  }
  onPlaybackReady() {
    // ...
    // console.log('player ready banner');
    // alert('player ready');
    this.playerready = true;
    // this.player.play();
    // var style = document.createElement( 'style' )
    // style.innerHTML = '.player { visibility: visible; min-width: 100px !important; height: 100% !important; }'
    // this.player.shadowRoot.appendChild( style );
    // var style2 = document.createElement( 'style' )
    // style2.innerHTML = 'video.sc-vm-file { object-fit: cover; }'
    // this.el.shadowRoot.appendChild( style2 );
    setTimeout(() => this.bannerPlayerFinalReady = true, 100);
    var s = this;
    setTimeout(() => {
      if (!s.player.playing) {
        // console.log('not playing');
        // this.player.play();
        // s.player.querySelector('video').setAttribute('playsinline', '')
        // s.player.querySelector('video').setAttribute('muted', '')
        // s.player.querySelector('video').play();
        s.play();
      }
    }, 1000);
  }
  onPlaybackStarted(s) {
    this.bannerPlayerFinalReady = true;
    s.loopCount += 1;
    // console.log('playback started', s.loopCount);
    // jitsu.track('loop', {
    //   category: 'banner_player',
    //   mute: s.isMute,
    //   loop_count: s.loopCount,
    //   ...s.getCtaAttributes(s),
    // });
  }
  onVmLoadStart() {
    // ...
    // console.log('vm load start banner');
    // this.player.play();
  }
  onPlayingChange() {
    // console.log('playing changed', event.detail);
    // jitsu.track((event.detail) ? 'play' : 'pause', {
    //   category: 'banner_player',
    //   mute: false,
    //   loopCount: this.loopCount,
    //   ...this.getCtaAttributes(this),
    // });
  }
  onCurrentTimeChange(event) {
    this.playingTime = event.detail;
    if (this.playingTime === 0) {
      this.onPlaybackStarted(this);
    }
  }
  getApiUrl(env) {
    let apiUrl = `https://apiv2.allstudio.live`;
    if (env === 'dev') {
      apiUrl = `${apiUrl}/dev`;
    }
    else if (env === 'qa') {
      apiUrl = `${apiUrl}/qa`;
    }
    return apiUrl;
  }
  getVideoUrl(vid) {
    let finalUrl = vid.url;
    try {
      if (vid.isProcessed && vid.processedUrls['op']) {
        finalUrl = vid.processedUrls['op'];
      }
      if (vid.processedUrls['mop'] && (window === null || window === void 0 ? void 0 : window.innerWidth) <= 576) {
        finalUrl = vid.processedUrls['mop'];
      }
    }
    catch (e) {
      finalUrl = vid.url;
    }
    // console.log('finalUrl', finalUrl);
    return finalUrl;
  }
  resetHeight(vidEl, s) {
    // reset the body height to that of the inner browser
    s.ssh = window.innerHeight;
    s.sw = window.innerWidth;
    // console.log('window inner height', s.sw, s.ssh);
    this.setPlayerHeight(vidEl, s, true);
  }
  setPlayerHeight(vidEl, s, force = false) {
    const ch = s.el.getBoundingClientRect();
    // console.log('ch final', ch);
    let ratio = this.ar;
    if (this.video) {
      ratio = this.video.height / this.video.width;
    }
    if ((s.w || s.h) && !force) {
      // console.log('defined final', s.w, s.h);
    }
    else {
      // const cw = this.el.clientHeight;
      let vw = ch.width;
      let vh = ch.height;
      if (vw === 0 || vh < 100) {
        vw = s.sw - ch.left - ch.right;
        vh = s.sw * 0.6;
      }
      if (s.sw > 0 && s.sw < vw) {
        vw = s.sw - ch.left - ch.right;
      }
      if (s.ssh > 0 && s.ssh * 0.6 < vh) {
        vh = s.ssh * 0.6;
      }
      // console.log('sw sh final', s.sw, s.ssh);
      if (vw === 0 && vh === 0) {
        vw = (s.sw - ch.left - ch.right) || 0;
        vh = s.ssh || 0;
        if (vh > s.ssh * 0.6) {
          vh = s.ssh * 0.6;
        }
      }
      if (vh === 0) {
        // console.log('setting video height', vidEl);
        vidEl.setAttribute('style', `height:(${0.6 * s.ssh}px);`);
        vh = vidEl.getBoundingClientRect().height;
        vw = vidEl.getBoundingClientRect().width - vidEl.getBoundingClientRect().left - vidEl.getBoundingClientRect().right;
      }
      if (this.video) {
        if (vw <= 576) {
          this.finalposter = this.video.posterUrls['576'];
        }
        else {
          this.finalposter = this.video.posterUrls['1600'];
        }
      }
      else if (this.poster) {
        if (vw <= 576) {
          this.finalposter = this.getFinalImgUrl(this.poster, '576w');
        }
        else {
          this.finalposter = this.getFinalImgUrl(this.poster, '1600w');
        }
        // console.log('poster', this.poster, this.finalposter);
      }
      // if((vw * ratio) < vh) {
      vh = vw * ratio;
      // }
      // console.log('vw final', vw);
      s.w = `${vw}px`;
      s.h = `${vh}px`;
      // }
    }
    // console.log('final height', s.w, s.h);
    s.bannerPlayerReady = true;
    // console.log('player ready from video loaded');
  }
  getFinalImgUrl(s3Key, wh) {
    const keyComponents = s3Key.split('/');
    let file = keyComponents.slice(-1);
    keyComponents.pop();
    keyComponents.pop();
    keyComponents.push(wh);
    keyComponents.push(file);
    file = keyComponents.join('/');
    const url = `${file}`;
    return url;
  }
  ;
  getCtaAttributes(s) {
    var _a, _b, _c;
    if (s.fullscreen) {
      return {
        cta_type: (_a = s.video) === null || _a === void 0 ? void 0 : _a.shoppableType,
        cta_link: (_c = (_b = s.video) === null || _b === void 0 ? void 0 : _b.shoppableData) === null || _c === void 0 ? void 0 : _c.ctaLink,
      };
    }
    else {
      return {};
    }
  }
  videoLoaded() {
    var _a, _b;
    var style = document.createElement('style');
    style.innerHTML = `.bannerWrapper {  --asplayer-btn-color: ${this.video.channel.primaryColor.hex}; }`;
    this.el.shadowRoot.appendChild(style);
    if (this.video && !this.finalposter) {
      if (this.sw <= 576) {
        this.finalposter = this.video.posterUrls['576'];
      }
      else {
        this.finalposter = this.video.posterUrls['1600'];
      }
    }
    setTimeout(() => this.setupPlyr(), 100);
    jitsu.set({
      channelid: this.video.channelId,
      videoid: this.video.id,
      duration: this.video.duration,
      category: 'banner_player',
      env: this.env === '' ? 'live' : this.env,
      appid: 'allstudio',
      accountid: (_b = (_a = this.video) === null || _a === void 0 ? void 0 : _a.channel) === null || _b === void 0 ? void 0 : _b.accountId,
      playlistid: null,
    });
    // posthog.group('accountid', `${this.env === 'live' || this.env === '' ? '': `${this.env}_`}${this.video.channel?.accountId}`, {
    //   env: this.env,
    //   channelid: this.channelId,
    //   channel: this.video.channel?.title,
    // });
  }
  setupPlyr() {
    const nel = this.el.shadowRoot.querySelector('#player');
    if (!nel) {
      setTimeout(() => this.setupPlyr(), 100);
      return;
    }
    this.player = new Plyr(nel, {
      autoplay: false,
      autopause: false,
      muted: true,
      loop: { active: true },
      disableContextMenu: true,
      hideControls: true,
      resetOnEnd: true,
      ratio: `${this.w ? this.w.replace('px', '') : 5}:${this.h ? this.h.replace('px', '') : 2}`,
      storage: { enabled: true, key: 'allstudio-plyr-banner' },
      mediaMetadata: { title: this.video.title },
      displayDuration: false,
      loadSprite: false,
      fullscreen: { enabled: false },
      controls: '',
    });
    this.player.muted = true;
    // console.log('plyr banner', this.player);
    this.player.on('loadstart', this.onVmLoadStart.bind(this));
    this.player.on('canplay', this.onPlaybackReady.bind(this));
    this.player.on('ready', this.onVmReady.bind(this));
    this.player.on('timeupdate', this.onCurrentTimeChange.bind(this));
    this.player.on('playing', this.onPlayingChange.bind(this));
  }
  getThumbUrl(urls, sw) {
    // console.log('sw', sw);
    if (!urls[576]) {
      return "https://cdnv2.allstudio.live/video-poster-placeholder.png";
    }
    if (sw <= 576) {
      return urls[576];
    }
    else if (sw <= 1280) {
      return urls[1280];
    }
    else {
      return urls[1920];
    }
  }
  trackEvent(name, data) {
    // posthog.register_once({
    //   channelid : this.video.channelId,
    //   videoid: this.video.id,
    //   duration: this.video.duration,
    //   category: 'video_banner',
    //   env: this.env === '' ? 'live' : this.env,
    //   appid: 'allstudio',
    //   accountid: this.video?.channel?.accountId,
    //   playlistid: null,
    // });
    jitsu.track(name, data);
    // posthog.capture(name, data);
  }
  static get is() { return "as-video-banner"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["as-video-banner.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["as-video-banner.css"]
    };
  }
  static get properties() {
    return {
      "videoId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "vid",
        "reflect": false
      },
      "fvideo": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "fvideo",
        "reflect": false
      },
      "channelId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "cid",
        "reflect": false,
        "defaultValue": "null"
      },
      "env": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "env",
        "reflect": false,
        "defaultValue": "''"
      },
      "w": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "w",
        "reflect": false,
        "defaultValue": "null"
      },
      "h": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "h",
        "reflect": false,
        "defaultValue": "null"
      },
      "poster": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "poster",
        "reflect": false,
        "defaultValue": "null"
      },
      "ar": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "ar",
        "reflect": false,
        "defaultValue": "2/5"
      }
    };
  }
  static get states() {
    return {
      "video": {},
      "hiddenControls": {},
      "loopCount": {},
      "bannerPlayerReady": {},
      "bannerPlayerFinalReady": {},
      "ssh": {},
      "playerready": {}
    };
  }
  static get methods() {
    return {
      "play": {
        "complexType": {
          "signature": "() => Promise<void>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      }
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "resize",
        "method": "windowResize",
        "target": "window",
        "capture": false,
        "passive": true
      }, {
        "name": "beforeunload",
        "method": "pageExit",
        "target": "window",
        "capture": false,
        "passive": false
      }, {
        "name": "blur",
        "method": "pageBlur",
        "target": "window",
        "capture": false,
        "passive": false
      }, {
        "name": "focus",
        "method": "pageFocus",
        "target": "window",
        "capture": false,
        "passive": false
      }];
  }
}
//# sourceMappingURL=as-video-banner.js.map
