/*!
 * All Studio Web Components
 * Copyright (c) Halfcute Internet Pvt Ltd
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { j as jitsuClient } from './jitsu.es.js';
import { d as defineCustomElement$4 } from './as-product-card2.js';
import { d as defineCustomElement$3 } from './as-product-card-slider2.js';
import { d as defineCustomElement$2 } from './as-product-chip2.js';
import { d as defineCustomElement$1 } from './as-product-overlay2.js';

const asPhotoViewerCss = ":host{display:block;padding:0;margin:0;width:100%;height:100%;max-height:100%;font-family:inherit !important;--vm-control-icon-size:24px;--vm-control-spacing:12px;--vm-fade-transition:opacity 0.3s ease-in-out;--vm-player-font-family:'Helvetica Neue','Segoe UI',Helvetica,Arial,sans-serif;--vm-player-border-radius:0px;--vm-control-padding:7px;--vm-controls-spacing:12px;--vm-control-bg:rgba(45, 45, 45, 0.7);--vm-control-focus-bg:rgba(45, 45, 45, 0.7);--vm-control-border-radius:50%;--vm-control-color:#fff}.photoWrapper{-moz-osx-font-smoothing:auto;-webkit-font-smoothing:subpixel-antialiased;-webkit-tap-highlight-color:transparent;font-variant-numeric:tabular-nums;font-weight:500;line-height:1.7;width:100%;display:block;max-width:100%;position:relative;text-shadow:none;outline:0;-webkit-transition:-webkit-box-shadow 0.3s ease;transition:-webkit-box-shadow 0.3s ease;transition:box-shadow 0.3s ease;transition:box-shadow 0.3s ease, -webkit-box-shadow 0.3s ease;-webkit-box-shadow:var(--vm-player-box-shadow);box-shadow:var(--vm-player-box-shadow);border-radius:var(--vm-player-border-radius);background:#000}.photoviewer{min-width:90px !important;min-height:160px !important;width:100%;height:100%}.photoWrapper .controls{display:-ms-flexbox;display:flex;width:100%;position:absolute;-ms-flex-wrap:wrap;flex-wrap:wrap;pointer-events:auto;-webkit-box-sizing:border-box;box-sizing:border-box;padding:var(--vm-controls-spacing);-webkit-transition:var(--vm-fade-transition);transition:var(--vm-fade-transition)}.photoWrapper .controls.topRight{top:0px;right:0px;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;-ms-flex-pack:start;justify-content:start}.photoWrapper .controls.topLeft{top:0px;left:0px;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;-ms-flex-pack:start;justify-content:start}.photoWrapper .controls.bottomLeft{bottom:0px;left:0px;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;-ms-flex-pack:start;justify-content:start}.photoWrapper .controls.bottomRight{bottom:0px;right:0px;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;-ms-flex-pack:start;justify-content:start}.photoWrapper.fullscreen .photoviewer{--vm-control-icon-size:28px;--vm-player-border-radius:0px;--vm-control-bg:transparent}.photoWrapper{padding:0;margin:0;width:100%;max-height:100vh;max-width:calc(100vh * 9/16);margin:auto;border-radius:6px;-webkit-border-radius:6px;-moz-border-radius:6px;background-color:#000;overflow:hidden;z-index:1;-webkit-background-clip:padding-box;-moz-background-clip:padding;background-clip:padding-box}@media (min-width: 576px){.photoWrapper{aspect-ratio:9/16;width:auto !important}}.photoWrapper img{-o-object-fit:cover;object-fit:cover;width:100%;height:100%;cursor:pointer;aspect-ratio:9/16}.photoWrapper.pinned .photoviewer{--vm-player-border-radius:0px;--vm-control-bg:transparent}.photoWrapper.pinned{background-color:transparent;border-radius:6px;-webkit-boder-radius:6px;-moz-border-radius:6px;width:180px;height:320px;position:fixed;z-index:9;-ms-touch-action:manipulation;touch-action:manipulation;outline:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-webkit-transform-origin:center;transform-origin:center;-webkit-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );-moz-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );-ms-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );margin:var( --asplayer-margin, 8px );top:var(--asplayer-pip-top, 0);right:var(--asplayer-pip-right, auto);bottom:var(--asplayer-pip-bottom, auto);left:var(--asplayer-pip-left, 0);}.backdrop{display:none;background:rgba(0,0,0,0.7);-webkit-backdrop-filter:blur(5px);backdrop-filter:blur(5px);position:fixed;top:0;bottom:0;left:0;right:0;width:100vw;height:100vh;z-index:9998;cursor:pointer}.backdrop.fullscreen{display:block}.photoWrapper.fullscreen{background-color:transparent;position:fixed;-ms-touch-action:manipulation;touch-action:manipulation;outline:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-webkit-transform-origin:center;transform-origin:center;-webkit-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );-moz-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );-ms-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );margin:0px auto;top:0;right:0;bottom:0;left:0;z-index:2147483647;}@media (max-width: 576px){.photoWrapper.fullscreen{border-radius:0px;-webkit-border-radius:0px;-moz-border-radius:0px}}.photoWrapper.pinned.hidden{visibility:hidden;height:0px;opacity:0}.photoWrapper.pinned.br{--asplayer-pip-top:auto;--asplayer-pip-right:0;--asplayer-pip-bottom:0;--asplayer-pip-left:auto}.photoWrapper.pinned.bl{--asplayer-pip-top:auto;--asplayer-pip-right:auto;--asplayer-pip-bottom:0;--asplayer-pip-left:0}.photoWrapper.pinned.tr{--asplayer-pip-top:0;--asplayer-pip-right:0;--asplayer-pip-bottom:auto;--asplayer-pip-left:auto}.photoWrapper.pinned.tl{--asplayer-pip-top:0;--asplayer-pip-right:auto;--asplayer-pip-bottom:auto;--asplayer-pip-left:0}.photoTitle{display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;-ms-flex:1;flex:1;text-overflow:ellipsis;overflow:hidden;height:24px;line-height:24px;white-space:nowrap;font-weight:500;font-size:14px}.photoTitleText{color:#fff;overflow:hidden;display:block;height:28px;text-overflow:ellipsis}.footerTitle .footerTitleText{font-size:18px;line-height:24px !important;font-weight:400;text-shadow:0 0 1px rgb(0 0 0 / 50%);-webkit-transition:opacity 0.3s;transition:opacity 0.3s;display:-webkit-box;line-clamp:2;-webkit-line-clamp:2;box-orient:vertical;-webkit-box-orient:vertical;display:block;text-overflow:ellipsis;overflow:hidden;color:#fff !important;word-wrap:break-word;word-break:break-all}.topPlayerShow{position:absolute;top:0px;left:0px;right:0px;height:33.33%;max-height:80px;background-image:-webkit-gradient(linear, left top, left bottom, from(rgba(43, 43, 43, 0.3)), to(rgba(43, 43, 43, 0)));background-image:linear-gradient(rgba(43, 43, 43, 0.3), rgba(43, 43, 43, 0));background-image:-webkit-gradient(linear, left top, left bottom, from(#272727), to(rgba(45, 45, 45, 0)));background-image:linear-gradient(180deg, #272727 0%, rgba(45, 45, 45, 0) 100%);width:100%}.bottomPlayerShow{position:absolute;bottom:0px;left:0px;right:0px;height:33.33%;background-image:-webkit-gradient(linear, left bottom, left top, from(rgba(43, 43, 43, 0.5)), to(rgba(43, 43, 43, 0)));background-image:linear-gradient(to top, rgba(43, 43, 43, 0.5), rgba(43, 43, 43, 0));width:100%}.fullphotoviewerclick{position:absolute;top:0;left:0;width:100%;height:100%;display:inline-block}.control{display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-direction:row;flex-direction:row;border:var(--vm-control-border);cursor:pointer;-ms-flex-negative:0;flex-shrink:0;font-size:var(--vm-control-icon-size);color:var(--vm-control-color);background:var(--vm-control-bg, transparent);border-radius:var(--vm-control-border-radius);padding:var(--vm-control-padding);position:relative;pointer-events:auto;-webkit-transition:all 0.3s ease;transition:all 0.3s ease;-webkit-transform:scale(var(--vm-control-scale, 1));transform:scale(var(--vm-control-scale, 1));-ms-touch-action:manipulation;touch-action:manipulation;-webkit-box-sizing:border-box;box-sizing:border-box;width:40px;height:40px;border:1px solid #fff}.control .icon,.control svg{display:block;height:100%;width:100%;-webkit-transition:var(--vm-icon-transition);transition:var(--vm-icon-transition);-webkit-transform:var(--vm-icon-transform);transform:var(--vm-icon-transform);fill:var(--vm-icon-fill, currentColor);stroke:var(--vm-icon-stroke)}.flexWrapper{-webkit-box-sizing:border-box;box-sizing:border-box;min-height:100%;display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;position:absolute;width:100%;left:0;top:0}.vmWrapper{-ms-flex-positive:1;flex-grow:1;-ms-flex-align:stretch;align-items:stretch;display:-ms-flexbox;display:flex}.ctaLinkContainer{-ms-flex-positive:0;flex-grow:0;-ms-flex-negative:0;flex-shrink:0;margin:0;padding:0px calc(min(12px, 3%));z-index:10000;position:relative;bottom:16px}.sizemini .ctaLinkContainer{bottom:4px}.photoWrapper.fullscreen .ctaLinkContainer{bottom:40px}.ctaLink{display:inline-block;outline:none;cursor:pointer;text-decoration:none;text-align:center;z-index:100;padding:8px 16px;height:auto;font-size:18px;font-weight:500;line-height:36px;vertical-align:middle;border-radius:4px;-webkit-border-radius:4px;-moz-border-radius:4px;margin-bottom:0px;box-shadow:2px 7px 96px -2px rgba(255, 255, 255,0.5);-webkit-box-shadow:2px 7px 96px -2px rgba(255, 255, 255,0.5);-moz-box-shadow:2px 7px 96px -2px rgba(255, 255, 255,0.5)}.ctaLink.large{display:block}.ctaLink.small{float:right}.lds-ring{display:inline-block;position:relative;width:40px;height:40px}.lds-ring div{-webkit-box-sizing:border-box;box-sizing:border-box;display:block;position:absolute;width:32px;height:32px;margin:4px;border:4px solid #fff;border-radius:50%;-webkit-border-radius:50%;-moz-border-radius:50%;-webkit-animation:lds-ring 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;animation:lds-ring 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;border-color:#fff transparent transparent transparent}.lds-ring div:nth-child(1){-webkit-animation-delay:-0.45s;animation-delay:-0.45s}.lds-ring div:nth-child(2){-webkit-animation-delay:-0.3s;animation-delay:-0.3s}.lds-ring div:nth-child(3){-webkit-animation-delay:-0.15s;animation-delay:-0.15s}@-webkit-keyframes lds-ring{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes lds-ring{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}.toastMessage{background-color:rgba(0,0,0,0.7);color:#fff;display:inline-block;padding:8px 16px;text-align:left;width:100%;font-size:14px;line-height:1.2}.ctaLink::after{opacity:0;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;-webkit-box-pack:center;-ms-flex-pack:center;-webkit-justify-content:center;justify-content:center;-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;position:absolute;top:0;left:0;right:0;bottom:0;content:'';height:100%;width:100%;background:var(--asplayer-btn-color, var(--gradient));-webkit-animation-name:animation-cta;animation-name:animation-cta;-webkit-animation-duration:2s;animation-duration:2s;-webkit-animation-delay:0;animation-delay:0;-webkit-animation-iteration-count:infinite;animation-iteration-count:infinite;-webkit-animation-timing-function:cubic-bezier(0.65, 0, 0.34, 1);animation-timing-function:cubic-bezier(0.65, 0, 0.34, 1);z-index:-1;border-radius:4px}@keyframes animation-cta{from{opacity:0.7;-webkit-transform:scale3d(1, 1, 1);-moz-transform:scale3d(1, 1, 1);-ms-transform:scale3d(1, 1, 1);transform:scale3d(1, 1, 1)}to{opacity:0;-webkit-transform:scale3d(1.2, 1.2, 1);-moz-transform:scale3d(1.2, 1.2, 1);-ms-transform:scale3d(1.2, 1.2, 1);transform:scale3d(1.2, 1.2, 1)}}@-webkit-keyframes animation-cta{from{opacity:0.7;-webkit-transform:scale3d(1, 1, 1);-moz-transform:scale3d(1, 1, 1);-ms-transform:scale3d(1, 1, 1);transform:scale3d(1, 1, 1)}to{opacity:0;-webkit-transform:scale3d(1.2, 1.2, 1);-moz-transform:scale3d(1.2, 1.2, 1);-ms-transform:scale3d(1.2, 1.2, 1);transform:scale3d(1.2, 1.2, 1)}}.as-photo-wrapper{max-height:100%;overflow:hidden}.cards{background:#fff;height:100%;width:100%;overflow:hidden;-webkit-box-shadow:5px 8px 15px -10px rgba(0,0,0,0.25);box-shadow:5px 8px 15px -10px rgba(0,0,0,0.25);position:relative}.cards.fullheight{position:absolute;top:0px;left:0px}.card_image{width:100%;height:100%}.card_image.loading{width:100%;height:100%}.card_title{padding:8px;font-size:22px;font-weight:700;position:absolute;bottom:0px;left:0px}.card_title.loading{width:50%;height:1rem;margin:1rem;border-radius:3px;position:relative}.card_description{padding:8px;font-size:16px}.card_description.loading{height:3rem;margin:1rem;border-radius:3px}.loading{position:relative;background:#cccccc}.photoWrapper.fullscreen .loading{background:#3a3a3a}.loading:after{content:\"\";display:block;position:absolute;top:0;width:100%;height:100%;-webkit-transform:translateX(-100px);transform:translateX(-100px);background:-webkit-gradient(linear, left top, right top, from(transparent), color-stop(rgba(255,255,255,0.2)), to(transparent));background:linear-gradient(90deg, transparent, rgba(255,255,255,0.2), transparent);-webkit-animation:loading 0.8s infinite;animation:loading 0.8s infinite}.photoWrapper.fullscreen .loading:after{background:-webkit-gradient(linear, left top, right top, from(#3a3a3a), color-stop(10%, #3f3f3f), color-stop(20%, #4a4a4a), color-stop(30%, #3f3f3f), color-stop(50%, #3a3a3a), to(#3a3a3a));background:linear-gradient(to right, #3a3a3a 0%, #3f3f3f 10%, #4a4a4a 20%, #3f3f3f 30%, #3a3a3a 50%, #3a3a3a 100%)}@-webkit-keyframes loading{100%{-webkit-transform:translateX(100%);transform:translateX(100%)}}@keyframes loading{100%{-webkit-transform:translateX(100%);transform:translateX(100%)}}";

// import posthog from 'posthog-js'
// if (!window.location.host.includes('127.0.0.1') && !window.location.host.includes('localhost')) {
//   posthog.init('phc_PFn3ipf7jR88MXFX73PMM6l7A0G5EeZf0llC0u5FVKv', { api_host: 'https://app.posthog.com', autocapture: false, capture_pageview: false})
// }
// import LazyLoad from "vanilla-lazyload";
// //init
const jitsu = jitsuClient({
  key: "js.ku52f0vferwtf16hunn8p6.s4zhwpli8w7pwz9k0y1kc",
  tracking_host: "https://t.jitsu.com"
});
const AsPhotoViewer = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.shopifyProduct = null;
    this.shopifyVariantId = null;
    this.shopifyQty = 1;
    this.imgloaded = false;
    this.photoId = undefined;
    this.fphoto = undefined;
    this.channelId = null;
    this.playlistId = null;
    this.env = '';
    this.showheader = true;
    this.showheadertitle = true;
    this.showfooterplay = false;
    this.showfootertitle = false;
    this.showproductchip = false;
    this.showproductcard = false;
    this.w = null;
    this.h = null;
    this.sw = undefined;
    this.sh = undefined;
    this.fullscreen = false;
    this.playclick = undefined;
    this.mode = 'story';
    this.position = 'br';
    this.piphandler = null;
    this.platform = 'web';
    this.widget = 'storyblok';
    this.shopify = false;
    this.tk = true;
    this.placeholder = true;
    this.productoverlay = null;
    this.index = null;
    this.size = 'default';
    this.photo = null;
    this.photoUrl = undefined;
    this.hidden = false;
    this.handlerPipMode = false;
    this.addedToCart = false;
    this.addToCartLoading = false;
    this.loading = true;
  }
  async windowResize() {
    // show a prompt
    var s = this;
    const vidEl = this.el.shadowRoot.querySelector('.as-photo-wrapper');
    this.resetHeight(vidEl, s);
  }
  async pageExit() {
  }
  async load() {
    if (this.loading) {
      setTimeout(this.load, 100);
    }
    else if (!this.imgloaded) {
      try {
        this.loadImg();
      }
      catch (e) {
        setTimeout(this.load, 100);
      }
    }
  }
  async closeoverlay() {
    const overlay = this.productoverlay ? this.productoverlay : this.el.shadowRoot.querySelector('as-product-overlay');
    overlay === null || overlay === void 0 ? void 0 : overlay.close(false);
  }
  componentWillLoad() {
    if (this.mode === 'pinned') {
      this.enablePip();
      if (this.widget === 'storyblok') {
        this.widget = 'floating_photo_viewer';
      }
    }
    if (this.piphandler) {
      // console.log('handler pip mode fls', this.fullscreen);
      this.handlerPipMode = true;
    }
  }
  async componentDidLoad() {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    var win = window;
    if (!this.sw) {
      this.sw = this.el.getBoundingClientRect().width;
      this.sh = this.el.getBoundingClientRect().height;
      if (this.h) {
        this.sh = parseInt(this.h.replace('px', ''));
      }
    }
    vidEl = this.el.shadowRoot.querySelector('.as-photo-wrapper');
    const s = this;
    this.resetHeight(vidEl, s);
    if ((win === null || win === void 0 ? void 0 : win.Shopify) && this.platform === 'shopify') {
      this.shopify = true;
      if (this.mode === 'pinned') {
        const sp = await this.onShopifyProductPage();
        if (!sp) {
          console.log('not product page - photo viewer wont load');
          return false;
        }
      }
      console.log('shopify product', this.shopifyProduct);
    }
    if (this.fphoto) {
      const finalphoto = this.fphoto;
      this.photoUrl = this.getPhotoUrl(finalphoto);
      this.photo = finalphoto;
    }
    let finalphoto = this.photo || null;
    if (!this.photo) {
      let cheader = {
        "Content-type": "application/json;charset=UTF-8",
      };
      if (this.channelId) {
        cheader["channel_id"] = this.channelId;
      }
      let vUrl = `${this.getApiUrl(this.env)}/web/photos/`;
      if (this.photoId) {
        vUrl = `${vUrl}${this.photoId}`;
      }
      else if (this.platform === 'shopify' && ((_b = (_a = this.shopifyProduct) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id)) {
        vUrl = `${vUrl}product-photo?productId=${(_d = (_c = this.shopifyProduct) === null || _c === void 0 ? void 0 : _c.product) === null || _d === void 0 ? void 0 : _d.id}&platform=shopify`;
      }
      else {
        console.log('no api to fetch from');
        return false;
      }
      // console.log(vUrl);
      const vidResponse = await fetch(vUrl, {
        method: "GET",
        headers: cheader,
      });
      if (vidResponse.status === 200) {
        const vidData = await vidResponse.json();
        finalphoto = vidData;
        this.photoUrl = this.getPhotoUrl(finalphoto);
      }
      else {
        return false;
      }
    }
    if (this.platform === 'shopify' && this.shopify) {
      if ((finalphoto === null || finalphoto === void 0 ? void 0 : finalphoto.shoppableType) === 'addtocart' &&
        ((_e = finalphoto.shoppableData) === null || _e === void 0 ? void 0 : _e.productId) !== this.shopifyProduct.product.id.toString()) {
        console.log('product id doesn\'t match');
        return false;
      }
    }
    this.photo = finalphoto;
    this.loading = false;
    if (this.tk && this.photo) {
      this.setJitsu(this);
    }
    //     const img: HTMLImageElement = 
    //     this.el.shadowRoot.querySelector('img');
    // ​
    //     if (img) {
    //       this.observer = new IntersectionObserver(this.onIntersection);
    //       this.observer.observe(img);
    //     }
    if ((_h = (_g = (_f = this.photo) === null || _f === void 0 ? void 0 : _f.channel) === null || _g === void 0 ? void 0 : _g.primaryColor) === null || _h === void 0 ? void 0 : _h.hex) {
      var style = document.createElement('style');
      style.innerHTML = `.photoWrapper { --as-player-btn-color: ${this.photo.channel.primaryColor.hex}; }`;
      this.el.shadowRoot.appendChild(style);
    }
    if (this.photo || this.placeholder) {
      // if(!this.sw) {
      //   this.sw = this.el.getBoundingClientRect().width;
      //   this.sh = this.el.getBoundingClientRect().height;
      // }
      var vidEl = this.el.shadowRoot.querySelector('.as-photo-wrapper');
      const s = this;
      // this.resetHeight(vidEl, s);
      if (!this.fullscreen && this.playclick && this.mode != 'pinned') {
        // not pinned and play click exists - can be carousel or grid
        this.playControlClick = () => this.widgetPlayClick(s);
      }
      //pip
      this.closePipClick = () => {
        s.hidden = true;
        s.trackEvent('closed', {
          category: 'floating_photo_viewer',
        });
      };
      if (this.mode === 'pinned') {
        this.playControlClick = () => this.pipFullScreen(vidEl, s);
        this.playclick = () => this.playControlClick();
      }
      this.enterPipClick = (clicked = true, click_type = 'icon') => {
        console.log('enter pip click');
        if (!s.handlerPipMode) {
          s.fullscreen = false;
          s.enablePip();
        }
        else {
          s.piphandler();
        }
        if (clicked) {
          s.trackEvent('closed_click', Object.assign({ click_type, category: s.getViewerCategory() }, s.getCtaAttributes(s)));
        }
      };
      this.backdropClick = () => {
        console.log('back drop click');
        if (this.mode === 'pinned') {
          this.enterPipClick(true, 'backdrop');
        }
        else {
          this.fullscreen = false;
        }
      };
    }
  }
  render() {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    if (this.loading) {
      return (h(Host, null, h("div", { class: { photoWrapper: true,
          'as-photo-wrapper': true,
          'pinned': (this.mode === 'pinned' && !this.fullscreen),
          'fullscreen': (this.fullscreen && this.mode === 'pinned' || this.widget === 'carousel_photo_viewer_fullscreen'),
          'br': (this.position === 'br'),
          'bl': (this.position === 'bl'),
          'tr': (this.position === 'tr'),
          'tl': (this.position === 'tl'),
          'hidden': (this.hidden),
          'sizemini': (this.size === 'mini'),
        }, id: `as-photo-viewer-${((_a = this.photo) === null || _a === void 0 ? void 0 : _a.id) || Date.now() * Math.random()}`, style: { width: `${this.w && !this.fullscreen ? this.w : '100%'}`, height: `${this.h ? this.h : (this.fullscreen || this.sw < 576 ? '100vh' : '75vh')}` } }, h("div", { class: "cards fullheight" }, h("div", { class: "card_image loading" }), h("div", { class: "card_title loading" })))));
    }
    else {
      return (h(Host, null, this.mode === 'pinned' && h("div", { class: { backdrop: (this.mode === 'pinned'),
          fullscreen: this.fullscreen
        }, onClick: this.backdropClick }), (!this.loading) && h("div", { class: { photoWrapper: true,
          'as-photo-wrapper': true,
          'pinned': (this.mode === 'pinned' && !this.fullscreen),
          'fullscreen': (this.fullscreen && this.mode === 'pinned' || this.widget === 'carousel_photo_viewer_fullscreen'),
          'br': (this.position === 'br'),
          'bl': (this.position === 'bl'),
          'tr': (this.position === 'tr'),
          'tl': (this.position === 'tl'),
          'hidden': (this.hidden),
          'sizemini': (this.size === 'mini'),
        }, id: `as-photo-viewer-${((_b = this.photo) === null || _b === void 0 ? void 0 : _b.id) || Date.now() * Math.random()}`, style: { width: `${this.w && !this.fullscreen ? this.w : '100%'}`, height: `${this.h ? this.h : (this.fullscreen || this.sw < 576 ? '100vh' : '75vh')}` } }, !this.productoverlay && h("as-product-overlay", { trackevent: this.trackEvent, env: this.env }), !this.photo && this.mode !== 'pinned' && (h("div", { class: "cards" }, h("div", { class: "card_image loading" }), h("div", { class: "card_title loading" }))), this.photo && (h("div", { style: { height: '100%', position: 'relative' } }, h("div", { class: "photoviewer", style: {
          aspectRatio: `(${this.w ? this.w.replace('px', '') : 9})/(${this.h ? this.h.replace('px', '') : 16})`
        } }, h("img", { class: "lazy", style: { objectFit: 'cover' }, alt: this.photo.title, "data-src": this.photo.finalUrls['576'] || "https://cdnv2.allstudio.live/video-poster-placeholder.png" })), h("div", { class: "flexWrapper" }, h("main", { class: "vmWrapper" }, this.showheader && h("div", { class: { topPlayerShow: true } }), h("div", { class: { bottomPlayerShow: true } }), (this.playclick && !this.fullscreen) ? (h("div", { class: "fullphotoviewerclick", onClick: this.playControlClick }, h("div", { style: { height: `${this.h}` } }))) : h("div", null), this.showheader ? (h("div", { class: "topRight controls" }, this.showheadertitle ? (h("div", { class: {
          photoTitle: true,
        } }, h("span", { class: { photoTitleText: true } }, this.photo.title))) : (h("div", null)), !this.fullscreen && this.mode != 'pinned' && h("div", null), this.mode === 'pinned' && !this.fullscreen && h("div", { class: "closeIcon control", onClick: this.closePipClick }, h("div", { class: "icon", role: "img", "aria-label": "Close" }, h("svg", { viewBox: "0 0 24 24", xmlns: "http://www.w3.org/2000/svg" }, h("path", { d: "M19 6.41L17.59 5L12 10.59L6.41 5L5 6.41L10.59 12L5 17.59L6.41 19L12 13.41L17.59 19L19 17.59L13.41 12L19 6.41Z" })))), this.fullscreen && (this.mode === 'pinned') && h("div", { class: "pipIconControl closeIcon", onClick: this.enterPipClick }, h("div", { class: "icon", role: "img", "aria-label": "Close" }, h("svg", { viewBox: "0 0 24 24", xmlns: "http://www.w3.org/2000/svg" }, h("path", { d: "M19 6.41L17.59 5L12 10.59L6.41 5L5 6.41L10.59 12L5 17.59L6.41 19L12 13.41L17.59 19L19 17.59L13.41 12L19 6.41Z" })))), this.fullscreen && (this.handlerPipMode) && h("div", { class: "pipHandlerIconControl", onClick: this.enterPipClick }, h("div", { class: "closeIcon control" }, h("div", { class: "icon", role: "img", "aria-label": "Close" }, h("svg", { viewBox: "0 0 24 24", xmlns: "http://www.w3.org/2000/svg" }, h("path", { d: "M19 6.41L17.59 5L12 10.59L6.41 5L5 6.41L10.59 12L5 17.59L6.41 19L12 13.41L17.59 19L19 17.59L13.41 12L19 6.41Z" }))))), this.fullscreen && this.mode !== 'pinned' && !this.handlerPipMode && (h("div", { style: { width: '30px', height: '28px' } })))) : (h("span", null)), this.showfootertitle ? (h("div", { class: "bottomLeft controls" }, h("div", { class: {
          footerTitle: true,
        } }, h("span", { class: { footerTitleText: true } }, this.photo.title)))) : (h("span", null))), !this.showfootertitle && this.showheadertitle && this.photo.shoppableType === 'cta'
        && ((_c = this.photo.shoppableData) === null || _c === void 0 ? void 0 : _c.ctaLink) !== '' && (h("footer", { class: "ctaLinkContainer" }, h("a", { class: {
          ctaLink: true,
          large: (this.photo.channel.ctaButtonSize === 'large'),
          small: (this.photo.channel.ctaButtonSize === 'small'),
        }, style: {
          "color": `${this.photo.channel.textColor.hex}`,
          "background-color": `${this.photo.channel.primaryColor.hex}`,
        }, href: (_d = this.photo.shoppableData) === null || _d === void 0 ? void 0 : _d.ctaLink, title: (_e = this.photo.shoppableData) === null || _e === void 0 ? void 0 : _e.ctaType }, (_f = this.photo.shoppableData) === null || _f === void 0 ? void 0 : _f.ctaType))), !this.showfootertitle && this.showheadertitle && this.platform === 'shopify' && this.photo.shoppableType === 'addtocart'
        && this.shopifyVariantId && (h("footer", { class: "ctaLinkContainer" }, this.addedToCart ? h("div", { class: "toastMessage" }, "Item added to cart.") :
        h("a", { class: {
            ctaLink: true,
            large: (this.photo.channel.ctaButtonSize === 'large'),
            small: (this.photo.channel.ctaButtonSize === 'small'),
          }, style: {
            "color": `${this.photo.channel.textColor.hex}`,
            "background-color": `${this.photo.channel.primaryColor.hex}`
          }, onClick: async (e) => {
            e.preventDefault();
            if (!this.addToCartLoading)
              await this.addShopifyItem();
          }, title: (_g = this.photo.shoppableData) === null || _g === void 0 ? void 0 : _g.ctaType }, this.addToCartLoading ? (h("div", { class: "lds-ring" }, h("div", null), h("div", null), h("div", null), h("div", null))) : (_h = this.photo.shoppableData) === null || _h === void 0 ? void 0 : _h.ctaType))), this.showproductchip && ((_j = this.photo.shoppableData) === null || _j === void 0 ? void 0 : _j.products) && !this.loading && this.playclick ? (h("footer", { class: "ctaLinkContainer" }, h("as-product-chip", { size: this.size, onClick: this.playControlClick, trackevent: this.trackEvent, products: (_k = this.photo.shoppableData) === null || _k === void 0 ? void 0 : _k.products }))) : (h("span", null)), this.showproductcard && ((_l = this.photo.shoppableData) === null || _l === void 0 ? void 0 : _l.products) && !this.loading ? (h("footer", { class: "ctaLinkContainer" }, h("as-product-card-slider", { products: (_m = this.photo.shoppableData) === null || _m === void 0 ? void 0 : _m.products, overlay: this.productoverlay ? this.productoverlay : this.el.shadowRoot.querySelector('as-product-overlay'), channel: this.photo.channel, photoviewer: this, trackevent: this.trackEvent }))) : (h("span", null))))))));
    }
  }
  getApiUrl(env) {
    let apiUrl = `https://apiv2.allstudio.live`;
    if (env === 'dev') {
      apiUrl = `${apiUrl}/dev`;
    }
    else if (env === 'qa') {
      apiUrl = `${apiUrl}/qa`;
    }
    return apiUrl;
  }
  getPhotoUrl(vid) {
    let finalUrl = vid.url;
    try {
      if (vid.finalUrls) {
        finalUrl = vid.finalUrls['576'];
      }
    }
    catch (e) {
      finalUrl = vid.url;
    }
    // console.log('finalUrl', finalUrl);
    return finalUrl;
  }
  resetHeight(vidEl, s) {
    // reset the body height to that of the inner browser
    // s.sh = window.innerHeight;
    // console.log('window inner height', s.sh);
    this.setPlayerHeight(vidEl, s);
  }
  setPlayerHeight(vidEl, s) {
    const ch = s.el.getBoundingClientRect();
    // console.log('ch final', ch, s.fullscreen);
    if (s.w || s.h) {
      // console.log('defined final', s.w, s.h, s.fullscreen);
      if (s.fullscreen) {
        s.h = `${s.sh}px`;
      }
    }
    else {
      // const cw = this.el.clientHeight;
      let vw = ch.width;
      let vh = s.sh || ch.height;
      // console.log('sw sh final', s.sw, s.sh);
      if (vw === 0 && vh === 0) {
        vw = s.sw || 0;
        vh = s.sh || 0;
      }
      if (vw === 0) {
        if (vh === 0) {
          vh = 320;
        }
        vw = vh * 9 / 16;
      }
      else if (vh > 0 && vh > vw * 16 / 9) {
        const tw = vh * 9 / 16;
        if (tw > vw && !this.fullscreen) {
          vh = vw * 16 / 9;
        }
        else if (vw === 0 && tw > 0 && !this.fullscreen) {
          vw = tw;
        }
      }
      else {
        if (vh === 0) {
          // console.log('setting photo height', vidEl);
          if (!s.fullscreen) {
            vidEl.setAttribute('style', 'height:75vh;');
          }
          else {
            vidEl.setAttribute('style', 'height:100vh;');
          }
          vh = vidEl.getBoundingClientRect().height;
          vw = vidEl.getBoundingClientRect().width;
        }
        else {
          if (vh < vw && vh > 100) {
            vw = vh * 9 / 16;
          }
          else {
            vh = vw * 16 / 9;
          }
        }
      }
      // if(vh > ch.height && ch.height> 100) {
      //   vh = ch.height;
      //   vw = vh*9/16;
      // }
      if (vw > 576) {
        vw = 576;
        vh = vw * 16 / 9;
      }
      // console.log('vw final', vw);
      s.w = `${vw}px`;
      s.h = `${vh}px`;
      // }
    }
    // console.log('final height', s.w, s.h, this.fullscreen);
  }
  enablePip() {
    this.w = '180px';
    this.h = '320px';
    this.showheader = true;
    this.showfootertitle = false;
    this.showheadertitle = false;
    this.showfooterplay = true;
  }
  pipFullScreen(vidEl, s) {
    console.log('full screen pip');
    s.trackEvent('full_screen', {
      category: 'floating_photo_viewer',
    });
    s.w = null;
    s.h = null;
    s.fullscreen = true;
    s.showheadertitle = true;
    s.showfooterplay = false;
    // s.w = '100%';
    // s.h = '100vh';
    s.setPlayerHeight(vidEl, s);
    // s.trackEvent('view', {
    //   category: 'fullscreen_photo_viewer',
    //   ...s.getCtaAttributes(s),
    // });
  }
  getCtaAttributes(s) {
    var _a, _b, _c, _d;
    if (s.fullscreen) {
      return {
        cta_type: (_a = s.photo) === null || _a === void 0 ? void 0 : _a.shoppableType,
        cta_title: (_c = (_b = s.photo) === null || _b === void 0 ? void 0 : _b.shoppableData) === null || _c === void 0 ? void 0 : _c.ctaType,
        products_count: (((_d = s.photo) === null || _d === void 0 ? void 0 : _d.shoppableType) === 'addtocart') ? 1 : 0,
      };
    }
    else {
      return {};
    }
  }
  async addShopifyItem() {
    this.addToCartLoading = true;
    this.trackEvent('addtocart_click', Object.assign(Object.assign({}, this.getCtaAttributes(this)), { category: 'fullscreen_photo_viewer', addtocart_id: this.shopifyVariantId, productid: this.shopifyProduct.product.id }));
    const result = await fetch("/cart/add.json", {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
        "Accept": "application/json"
      },
      body: JSON.stringify({
        id: this.shopifyVariantId,
        quantity: this.shopifyQty,
      })
    });
    this.addToCartLoading = false;
    if (result.status === 200) {
      this.addedToCart = true;
      this.trackEvent('addtocart_success', Object.assign(Object.assign({}, this.getCtaAttributes(this)), { category: 'fullscreen_photo_viewer', addtocart_id: this.shopifyVariantId, productid: this.shopifyProduct.product.id }));
      const data = await result.json();
      if (!result.redirected) {
        var s = this;
        setTimeout(function () {
          window.location.reload();
          s.enterPipClick(false);
        }, 600);
      }
      return data;
    }
    else {
      this.trackEvent('addtocart_failure', Object.assign(Object.assign({}, this.getCtaAttributes(this)), { category: 'fullscreen_photo_viewer', addtocart_id: this.shopifyVariantId, productid: this.shopifyProduct.product.id }));
      return false;
    }
  }
  async onShopifyProductPage() {
    var _a, _b, _c, _d, _e;
    const w = window;
    const path = w.location.pathname;
    // The pathname most likely looks like /collections/something/products/product-handle
    const potentialHandle = path.substring(path.lastIndexOf("/") + 1);
    if ((w === null || w === void 0 ? void 0 : w.meta) && ((_a = w.meta) === null || _a === void 0 ? void 0 : _a.product.id)) {
      console.log('returning p from meta');
      this.shopifyProduct = w.meta;
      this.shopifyVariantId = ((_c = (_b = this.shopifyProduct) === null || _b === void 0 ? void 0 : _b.product) === null || _c === void 0 ? void 0 : _c.variants[0].id) || null;
      return this.shopifyProduct;
    }
    const result = await fetch(`/products/${potentialHandle}.json`, {
      method: "GET",
      headers: {
        "Accept": "application/json"
      }
    });
    if (result.status === 200) {
      this.shopifyProduct = await result.json();
      this.shopifyVariantId = ((_e = (_d = this.shopifyProduct) === null || _d === void 0 ? void 0 : _d.product) === null || _e === void 0 ? void 0 : _e.variants[0].id) || null;
      return this.shopifyProduct;
    }
    else {
      return false;
    }
  }
  getViewerCategory() {
    if (this.fullscreen && this.mode === 'pinned') {
      return 'fullscreen_photo_viewer';
    }
    return this.widget;
  }
  widgetPlayClick(s) {
    console.log('widget play click', s.widget);
    s.trackEvent('full_screen', {
      category: s.getViewerCategory(),
    });
    s.playclick();
    // s.trackEvent('view', {
    //   category: `${s.widget}_fullscreen`,
    //   ...s.getCtaAttributes(s),
    // });
  }
  setJitsu(s) {
    var _a, _b;
    jitsu.set({
      channelid: s.photo.channelId,
      photoid: s.photo.id,
      width: s.photo.width,
      height: s.photo.height,
      category: s.widget,
      env: s.env === '' ? 'live' : s.env,
      appid: 'allstudio',
      accountid: (_b = (_a = s.photo) === null || _a === void 0 ? void 0 : _a.channel) === null || _b === void 0 ? void 0 : _b.accountId,
      playlistid: s.playlistId,
      index: s.index,
      type: 'photo',
      typeId: s.photo.id,
      videoid: null,
    });
  }
  async onIntersection(entries) {
    for (const entry of entries) {
      if (entry.isIntersecting) {
        if (this.observer) {
          this.observer.disconnect();
        }
        this.loadImg();
      }
    }
  }
  ;
  async loadImg() {
    var img = this.el.shadowRoot.querySelector('img');
    img.setAttribute('src', img.getAttribute('data-src'));
    this.imgloaded = true;
  }
  trackEvent(name, data, s = null) {
    if (!s) {
      s = this;
    }
    else {
      s.setJitsu(s);
    }
    if (s.tk || s.tk === undefined) {
      // console.log('tracking event', name, data);
      try {
        jitsu.track(name, data);
        // posthog.capture(name, data);
      }
      catch (e) {
        console.log('jitsu tracking error', e);
      }
    }
  }
  static get assetsDirs() { return ["icons"]; }
  get el() { return this; }
  static get style() { return asPhotoViewerCss; }
}, [1, "as-photo-viewer", {
    "photoId": [1, "vid"],
    "fphoto": [8],
    "channelId": [1, "cid"],
    "playlistId": [1, "pid"],
    "env": [1],
    "showheader": [4],
    "showheadertitle": [4],
    "showfooterplay": [4],
    "showfootertitle": [4],
    "showproductchip": [4],
    "showproductcard": [4],
    "w": [1025],
    "h": [1025],
    "sw": [1026],
    "sh": [1026],
    "fullscreen": [4],
    "playclick": [8],
    "mode": [1],
    "position": [1],
    "piphandler": [8],
    "platform": [8],
    "widget": [1032],
    "shopify": [1028],
    "tk": [4],
    "placeholder": [4],
    "productoverlay": [8],
    "index": [2],
    "size": [1],
    "photo": [32],
    "photoUrl": [32],
    "hidden": [32],
    "handlerPipMode": [32],
    "addedToCart": [32],
    "addToCartLoading": [32],
    "loading": [32],
    "load": [64],
    "closeoverlay": [64]
  }, [[9, "resize", "windowResize"], [9, "beforeunload", "pageExit"]]]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["as-photo-viewer", "as-product-card", "as-product-card-slider", "as-product-chip", "as-product-overlay"];
  components.forEach(tagName => { switch (tagName) {
    case "as-photo-viewer":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, AsPhotoViewer);
      }
      break;
    case "as-product-card":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "as-product-card-slider":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "as-product-chip":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "as-product-overlay":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { AsPhotoViewer as A, defineCustomElement as d };

//# sourceMappingURL=as-photo-viewer2.js.map