/*!
 * All Studio Web Components
 * Copyright (c) Halfcute Internet Pvt Ltd
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { p as plyr_min } from './plyr.min.js';
import { j as jitsuClient } from './jitsu.es.js';
import { d as defineCustomElement$4 } from './as-product-card2.js';
import { d as defineCustomElement$3 } from './as-product-card-slider2.js';
import { d as defineCustomElement$2 } from './as-product-chip2.js';
import { d as defineCustomElement$1 } from './as-product-overlay2.js';

const asPlayerCss = "@charset \"UTF-8\";@-webkit-keyframes plyr-progress{to{background-position:25px 0;background-position:var(--plyr-progress-loading-size,25px) 0}}@keyframes plyr-progress{to{background-position:25px 0;background-position:var(--plyr-progress-loading-size,25px) 0}}@-webkit-keyframes plyr-popup{0%{opacity:.5;-webkit-transform:translateY(10px);transform:translateY(10px)}to{opacity:1;-webkit-transform:translateY(0);transform:translateY(0)}}@keyframes plyr-popup{0%{opacity:.5;-webkit-transform:translateY(10px);transform:translateY(10px)}to{opacity:1;-webkit-transform:translateY(0);transform:translateY(0)}}@-webkit-keyframes plyr-fade-in{0%{opacity:0}to{opacity:1}}@keyframes plyr-fade-in{0%{opacity:0}to{opacity:1}}.plyr{-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;-ms-flex-align:center;align-items:center;direction:ltr;display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;font-family:inherit;font-family:var(--plyr-font-family,inherit);font-variant-numeric:tabular-nums;font-weight:400;font-weight:var(--plyr-font-weight-regular,400);line-height:1.7;line-height:var(--plyr-line-height,1.7);max-width:100%;min-width:200px;position:relative;text-shadow:none;-webkit-transition:-webkit-box-shadow .3s ease;transition:-webkit-box-shadow .3s ease;transition:box-shadow .3s ease;transition:box-shadow .3s ease, -webkit-box-shadow .3s ease;z-index:0}.plyr audio,.plyr iframe,.plyr video{display:block;height:100%;width:100%}.plyr button{font:inherit;line-height:inherit;width:auto}.plyr:focus{outline:0}.plyr--full-ui{-webkit-box-sizing:border-box;box-sizing:border-box}.plyr--full-ui *,.plyr--full-ui :after,.plyr--full-ui :before{-webkit-box-sizing:inherit;box-sizing:inherit}.plyr--full-ui a,.plyr--full-ui button,.plyr--full-ui input,.plyr--full-ui label{-ms-touch-action:manipulation;touch-action:manipulation}.plyr__badge{background:#4a5464;background:var(--plyr-badge-background,#4a5464);border-radius:2px;border-radius:var(--plyr-badge-border-radius,2px);color:#fff;color:var(--plyr-badge-text-color,#fff);font-size:9px;font-size:var(--plyr-font-size-badge,9px);line-height:1;padding:3px 4px}.plyr--full-ui ::-webkit-media-text-track-container{display:none}.plyr__captions{-webkit-animation:plyr-fade-in .3s ease;animation:plyr-fade-in .3s ease;bottom:0;display:none;font-size:13px;font-size:var(--plyr-font-size-small,13px);left:0;padding:10px;padding:var(--plyr-control-spacing,10px);position:absolute;text-align:center;-webkit-transition:-webkit-transform .4s ease-in-out;transition:-webkit-transform .4s ease-in-out;transition:transform .4s ease-in-out;transition:transform .4s ease-in-out, -webkit-transform .4s ease-in-out;width:100%}.plyr__captions span:empty{display:none}@media (min-width:480px){.plyr__captions{font-size:15px;font-size:var(--plyr-font-size-base,15px);padding:20px;padding:calc(var(--plyr-control-spacing, 10px)*2)}}@media (min-width:768px){.plyr__captions{font-size:18px;font-size:var(--plyr-font-size-large,18px)}}.plyr--captions-active .plyr__captions{display:block}.plyr:not(.plyr--hide-controls) .plyr__controls:not(:empty)~.plyr__captions{-webkit-transform:translateY(-40px);transform:translateY(-40px);-webkit-transform:translateY(calc(var(--plyr-control-spacing, 10px)*-4));transform:translateY(calc(var(--plyr-control-spacing, 10px)*-4))}.plyr__caption{background:#000c;background:var(--plyr-captions-background,#000c);border-radius:2px;-webkit-box-decoration-break:clone;box-decoration-break:clone;color:#fff;color:var(--plyr-captions-text-color,#fff);line-height:185%;padding:.2em .5em;white-space:pre-wrap}.plyr__caption div{display:inline}.plyr__control{background:#0000;border:0;border-radius:4px;border-radius:var(--plyr-control-radius,4px);color:inherit;cursor:pointer;-ms-flex-negative:0;flex-shrink:0;overflow:visible;padding:7px;padding:calc(var(--plyr-control-spacing, 10px)*.7);position:relative;-webkit-transition:all .3s ease;transition:all .3s ease}.plyr__control svg{fill:currentColor;display:block;height:18px;height:var(--plyr-control-icon-size,18px);pointer-events:none;width:18px;width:var(--plyr-control-icon-size,18px)}.plyr__control:focus{outline:0}.plyr__control:focus-visible{outline:2px dashed #00b2ff;outline:2px dashed var(--plyr-focus-visible-color,var(--plyr-color-main,var(--plyr-color-main,#00b2ff)));outline-offset:2px}a.plyr__control{text-decoration:none}.plyr__control.plyr__control--pressed .icon--not-pressed,.plyr__control.plyr__control--pressed .label--not-pressed,.plyr__control:not(.plyr__control--pressed) .icon--pressed,.plyr__control:not(.plyr__control--pressed) .label--pressed,a.plyr__control:after,a.plyr__control:before{display:none}.plyr--full-ui ::-webkit-media-controls{display:none}.plyr__controls{-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;-ms-flex-pack:end;justify-content:flex-end;text-align:center}.plyr__controls .plyr__progress__container{-ms-flex:1;flex:1;min-width:0}.plyr__controls .plyr__controls__item{margin-left:2.5px;margin-left:calc(var(--plyr-control-spacing, 10px)/4)}.plyr__controls .plyr__controls__item:first-child{margin-left:0;margin-right:auto}.plyr__controls .plyr__controls__item.plyr__progress__container{padding-left:2.5px;padding-left:calc(var(--plyr-control-spacing, 10px)/4)}.plyr__controls .plyr__controls__item.plyr__time{padding:0 5px;padding:0 calc(var(--plyr-control-spacing, 10px)/2)}.plyr__controls .plyr__controls__item.plyr__progress__container:first-child,.plyr__controls .plyr__controls__item.plyr__time+.plyr__time,.plyr__controls .plyr__controls__item.plyr__time:first-child{padding-left:0}.plyr [data-plyr=airplay],.plyr [data-plyr=captions],.plyr [data-plyr=fullscreen],.plyr [data-plyr=pip],.plyr__controls:empty{display:none}.plyr--airplay-supported [data-plyr=airplay],.plyr--captions-enabled [data-plyr=captions],.plyr--fullscreen-enabled [data-plyr=fullscreen],.plyr--pip-supported [data-plyr=pip]{display:inline-block}.plyr__menu{display:-ms-flexbox;display:flex;position:relative}.plyr__menu .plyr__control svg{-webkit-transition:-webkit-transform .3s ease;transition:-webkit-transform .3s ease;transition:transform .3s ease;transition:transform .3s ease, -webkit-transform .3s ease}.plyr__menu .plyr__control[aria-expanded=true] svg{-webkit-transform:rotate(90deg);transform:rotate(90deg)}.plyr__menu .plyr__control[aria-expanded=true] .plyr__tooltip{display:none}.plyr__menu__container{-webkit-animation:plyr-popup .2s ease;animation:plyr-popup .2s ease;background:#ffffffe6;background:var(--plyr-menu-background,#ffffffe6);border-radius:8px;border-radius:var(--plyr-menu-radius,8px);bottom:100%;-webkit-box-shadow:0 1px 2px #00000026;box-shadow:0 1px 2px #00000026;-webkit-box-shadow:var(--plyr-menu-shadow,0 1px 2px #00000026);box-shadow:var(--plyr-menu-shadow,0 1px 2px #00000026);color:#4a5464;color:var(--plyr-menu-color,#4a5464);font-size:15px;font-size:var(--plyr-font-size-base,15px);margin-bottom:10px;position:absolute;right:-3px;text-align:left;white-space:nowrap;z-index:3}.plyr__menu__container>div{overflow:hidden;-webkit-transition:height .35s cubic-bezier(.4,0,.2,1),width .35s cubic-bezier(.4,0,.2,1);transition:height .35s cubic-bezier(.4,0,.2,1),width .35s cubic-bezier(.4,0,.2,1)}.plyr__menu__container:after{border:4px solid #0000;border-top-color:#ffffffe6;border:var(--plyr-menu-arrow-size,4px) solid #0000;border-top-color:var(--plyr-menu-background,#ffffffe6);content:\"\";height:0;position:absolute;right:14px;right:calc(var(--plyr-control-icon-size, 18px)/2 + var(--plyr-control-spacing, 10px)*.7 - var(--plyr-menu-arrow-size, 4px)/2);top:100%;width:0}.plyr__menu__container [role=menu]{padding:7px;padding:calc(var(--plyr-control-spacing, 10px)*.7)}.plyr__menu__container [role=menuitem],.plyr__menu__container [role=menuitemradio]{margin-top:2px}.plyr__menu__container [role=menuitem]:first-child,.plyr__menu__container [role=menuitemradio]:first-child{margin-top:0}.plyr__menu__container .plyr__control{-ms-flex-align:center;align-items:center;color:#4a5464;color:var(--plyr-menu-color,#4a5464);display:-ms-flexbox;display:flex;font-size:13px;font-size:var(--plyr-font-size-menu,var(--plyr-font-size-small,13px));padding:4.66667px 10.5px;padding:calc(var(--plyr-control-spacing, 10px)*.7/1.5) calc(var(--plyr-control-spacing, 10px)*.7*1.5);-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;width:100%}.plyr__menu__container .plyr__control>span{-ms-flex-align:inherit;align-items:inherit;display:-ms-flexbox;display:flex;width:100%}.plyr__menu__container .plyr__control:after{border:4px solid #0000;border:var(--plyr-menu-item-arrow-size,4px) solid #0000;content:\"\";position:absolute;top:50%;-webkit-transform:translateY(-50%);transform:translateY(-50%)}.plyr__menu__container .plyr__control--forward{padding-right:28px;padding-right:calc(var(--plyr-control-spacing, 10px)*.7*4)}.plyr__menu__container .plyr__control--forward:after{border-left-color:#728197;border-left-color:var(--plyr-menu-arrow-color,#728197);right:6.5px;right:calc(var(--plyr-control-spacing, 10px)*.7*1.5 - var(--plyr-menu-item-arrow-size, 4px))}.plyr__menu__container .plyr__control--forward:focus-visible:after,.plyr__menu__container .plyr__control--forward:hover:after{border-left-color:initial}.plyr__menu__container .plyr__control--back{font-weight:400;font-weight:var(--plyr-font-weight-regular,400);margin:7px;margin:calc(var(--plyr-control-spacing, 10px)*.7);margin-bottom:3.5px;margin-bottom:calc(var(--plyr-control-spacing, 10px)*.7/2);padding-left:28px;padding-left:calc(var(--plyr-control-spacing, 10px)*.7*4);position:relative;width:calc(100% - 14px);width:calc(100% - var(--plyr-control-spacing, 10px)*.7*2)}.plyr__menu__container .plyr__control--back:after{border-right-color:#728197;border-right-color:var(--plyr-menu-arrow-color,#728197);left:6.5px;left:calc(var(--plyr-control-spacing, 10px)*.7*1.5 - var(--plyr-menu-item-arrow-size, 4px))}.plyr__menu__container .plyr__control--back:before{background:#dcdfe5;background:var(--plyr-menu-back-border-color,#dcdfe5);-webkit-box-shadow:0 1px 0 #fff;box-shadow:0 1px 0 #fff;-webkit-box-shadow:0 1px 0 var(--plyr-menu-back-border-shadow-color,#fff);box-shadow:0 1px 0 var(--plyr-menu-back-border-shadow-color,#fff);content:\"\";height:1px;left:0;margin-top:3.5px;margin-top:calc(var(--plyr-control-spacing, 10px)*.7/2);overflow:hidden;position:absolute;right:0;top:100%}.plyr__menu__container .plyr__control--back:focus-visible:after,.plyr__menu__container .plyr__control--back:hover:after{border-right-color:initial}.plyr__menu__container .plyr__control[role=menuitemradio]{padding-left:7px;padding-left:calc(var(--plyr-control-spacing, 10px)*.7)}.plyr__menu__container .plyr__control[role=menuitemradio]:after,.plyr__menu__container .plyr__control[role=menuitemradio]:before{border-radius:100%}.plyr__menu__container .plyr__control[role=menuitemradio]:before{background:#0000001a;content:\"\";display:block;-ms-flex-negative:0;flex-shrink:0;height:16px;margin-right:10px;margin-right:var(--plyr-control-spacing,10px);-webkit-transition:all .3s ease;transition:all .3s ease;width:16px}.plyr__menu__container .plyr__control[role=menuitemradio]:after{background:#fff;border:0;height:6px;left:12px;opacity:0;top:50%;-webkit-transform:translateY(-50%) scale(0);transform:translateY(-50%) scale(0);-webkit-transition:opacity .3s ease,-webkit-transform .3s ease;transition:opacity .3s ease,-webkit-transform .3s ease;transition:transform .3s ease,opacity .3s ease;transition:transform .3s ease,opacity .3s ease,-webkit-transform .3s ease;width:6px}.plyr__menu__container .plyr__control[role=menuitemradio][aria-checked=true]:before{background:#00b2ff;background:var(--plyr-control-toggle-checked-background,var(--plyr-color-main,var(--plyr-color-main,#00b2ff)))}.plyr__menu__container .plyr__control[role=menuitemradio][aria-checked=true]:after{opacity:1;-webkit-transform:translateY(-50%) scale(1);transform:translateY(-50%) scale(1)}.plyr__menu__container .plyr__control[role=menuitemradio]:focus-visible:before,.plyr__menu__container .plyr__control[role=menuitemradio]:hover:before{background:#23282f1a}.plyr__menu__container .plyr__menu__value{-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;margin-left:auto;margin-right:-5px;margin-right:calc(var(--plyr-control-spacing, 10px)*.7*-1 - -2px);overflow:hidden;padding-left:24.5px;padding-left:calc(var(--plyr-control-spacing, 10px)*.7*3.5);pointer-events:none}.plyr--full-ui input[type=range]{-webkit-appearance:none;-moz-appearance:none;appearance:none;background:#0000;border:0;border-radius:26px;border-radius:calc(var(--plyr-range-thumb-height, 13px)*2);color:#00b2ff;color:var(--plyr-range-fill-background,var(--plyr-color-main,var(--plyr-color-main,#00b2ff)));display:block;height:19px;height:calc(var(--plyr-range-thumb-active-shadow-width, 3px)*2 + var(--plyr-range-thumb-height, 13px));margin:0;min-width:0;padding:0;-webkit-transition:-webkit-box-shadow .3s ease;transition:-webkit-box-shadow .3s ease;transition:box-shadow .3s ease;transition:box-shadow .3s ease, -webkit-box-shadow .3s ease;width:100%}.plyr--full-ui input[type=range]::-webkit-slider-runnable-track{background:#0000;background-image:-webkit-gradient(linear,left top, right top,color-stop(0, currentColor),color-stop(0, #0000));background-image:linear-gradient(90deg,currentColor 0,#0000 0);background-image:-webkit-gradient(linear,left top, right top,from(currentColor),to(#0000));background-image:linear-gradient(to right,currentColor var(--value,0),#0000 var(--value,0));border:0;border-radius:2.5px;border-radius:calc(var(--plyr-range-track-height, 5px)/2);height:5px;height:var(--plyr-range-track-height,5px);-webkit-transition:box-shadow .3s ease;-webkit-transition:-webkit-box-shadow .3s ease;transition:-webkit-box-shadow .3s ease;transition:box-shadow .3s ease;transition:box-shadow .3s ease, -webkit-box-shadow .3s ease;-webkit-user-select:none;user-select:none}.plyr--full-ui input[type=range]::-webkit-slider-thumb{-webkit-appearance:none;appearance:none;background:#fff;background:var(--plyr-range-thumb-background,#fff);border:0;border-radius:100%;-webkit-box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33;box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33;-webkit-box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33);box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33);height:13px;height:var(--plyr-range-thumb-height,13px);margin-top:-4px;margin-top:calc((var(--plyr-range-thumb-height, 13px) - var(--plyr-range-track-height, 5px))/2*-1);position:relative;-webkit-transition:all .2s ease;transition:all .2s ease;width:13px;width:var(--plyr-range-thumb-height,13px)}.plyr--full-ui input[type=range]::-moz-range-track{background:#0000;border:0;border-radius:2.5px;border-radius:calc(var(--plyr-range-track-height, 5px)/2);height:5px;height:var(--plyr-range-track-height,5px);-moz-transition:box-shadow .3s ease;transition:box-shadow .3s ease;-moz-user-select:none;user-select:none}.plyr--full-ui input[type=range]::-moz-range-thumb{background:#fff;background:var(--plyr-range-thumb-background,#fff);border:0;border-radius:100%;box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33;box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33);height:13px;height:var(--plyr-range-thumb-height,13px);position:relative;-moz-transition:all .2s ease;transition:all .2s ease;width:13px;width:var(--plyr-range-thumb-height,13px)}.plyr--full-ui input[type=range]::-moz-range-progress{background:currentColor;border-radius:2.5px;border-radius:calc(var(--plyr-range-track-height, 5px)/2);height:5px;height:var(--plyr-range-track-height,5px)}.plyr--full-ui input[type=range]::-ms-track{color:#0000}.plyr--full-ui input[type=range]::-ms-fill-upper,.plyr--full-ui input[type=range]::-ms-track{background:#0000;border:0;border-radius:2.5px;border-radius:calc(var(--plyr-range-track-height, 5px)/2);height:5px;height:var(--plyr-range-track-height,5px);-ms-transition:box-shadow .3s ease;transition:box-shadow .3s ease;-ms-user-select:none;user-select:none}.plyr--full-ui input[type=range]::-ms-fill-lower{background:#0000;background:currentColor;border:0;border-radius:2.5px;border-radius:calc(var(--plyr-range-track-height, 5px)/2);height:5px;height:var(--plyr-range-track-height,5px);-ms-transition:box-shadow .3s ease;transition:box-shadow .3s ease;-ms-user-select:none;user-select:none}.plyr--full-ui input[type=range]::-ms-thumb{background:#fff;background:var(--plyr-range-thumb-background,#fff);border:0;border-radius:100%;box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33;box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33);height:13px;height:var(--plyr-range-thumb-height,13px);margin-top:0;position:relative;-ms-transition:all .2s ease;transition:all .2s ease;width:13px;width:var(--plyr-range-thumb-height,13px)}.plyr--full-ui input[type=range]::-ms-tooltip{display:none}.plyr--full-ui input[type=range]::-moz-focus-outer{border:0}.plyr--full-ui input[type=range]:focus{outline:0}.plyr--full-ui input[type=range]:focus-visible::-webkit-slider-runnable-track{outline:2px dashed #00b2ff;outline:2px dashed var(--plyr-focus-visible-color,var(--plyr-color-main,var(--plyr-color-main,#00b2ff)));outline-offset:2px}.plyr--full-ui input[type=range]:focus-visible::-moz-range-track{outline:2px dashed #00b2ff;outline:2px dashed var(--plyr-focus-visible-color,var(--plyr-color-main,var(--plyr-color-main,#00b2ff)));outline-offset:2px}.plyr--full-ui input[type=range]:focus-visible::-ms-track{outline:2px dashed #00b2ff;outline:2px dashed var(--plyr-focus-visible-color,var(--plyr-color-main,var(--plyr-color-main,#00b2ff)));outline-offset:2px}.plyr__poster{background-color:#000;background-color:var(--plyr-video-background,var(--plyr-video-background,#000));background-position:50% 50%;background-repeat:no-repeat;background-size:contain;height:100%;left:0;opacity:0;position:absolute;top:0;-webkit-transition:opacity .2s ease;transition:opacity .2s ease;width:100%;z-index:1}.plyr--stopped.plyr__poster-enabled .plyr__poster{opacity:1}.plyr--youtube.plyr--paused.plyr__poster-enabled:not(.plyr--stopped) .plyr__poster{display:none}.plyr__time{font-size:13px;font-size:var(--plyr-font-size-time,var(--plyr-font-size-small,13px))}.plyr__time+.plyr__time:before{content:\"⁄\";margin-right:10px;margin-right:var(--plyr-control-spacing,10px)}@media (max-width:767px){.plyr__time+.plyr__time{display:none}}.plyr__tooltip{background:#fff;background:var(--plyr-tooltip-background,#fff);border-radius:5px;border-radius:var(--plyr-tooltip-radius,5px);bottom:100%;-webkit-box-shadow:0 1px 2px #00000026;box-shadow:0 1px 2px #00000026;-webkit-box-shadow:var(--plyr-tooltip-shadow,0 1px 2px #00000026);box-shadow:var(--plyr-tooltip-shadow,0 1px 2px #00000026);color:#4a5464;color:var(--plyr-tooltip-color,#4a5464);font-size:13px;font-size:var(--plyr-font-size-small,13px);font-weight:400;font-weight:var(--plyr-font-weight-regular,400);left:50%;line-height:1.3;margin-bottom:10px;margin-bottom:calc(var(--plyr-control-spacing, 10px)/2*2);opacity:0;padding:5px 7.5px;padding:calc(var(--plyr-control-spacing, 10px)/2) calc(var(--plyr-control-spacing, 10px)/2*1.5);pointer-events:none;position:absolute;-webkit-transform:translate(-50%,10px) scale(.8);transform:translate(-50%,10px) scale(.8);-webkit-transform-origin:50% 100%;transform-origin:50% 100%;-webkit-transition:opacity .2s ease .1s,-webkit-transform .2s ease .1s;transition:opacity .2s ease .1s,-webkit-transform .2s ease .1s;transition:transform .2s ease .1s,opacity .2s ease .1s;transition:transform .2s ease .1s,opacity .2s ease .1s,-webkit-transform .2s ease .1s;white-space:nowrap;z-index:2}.plyr__tooltip:before{border-left:4px solid #0000;border-left:var(--plyr-tooltip-arrow-size,4px) solid #0000;border-right:4px solid #0000;border-right:var(--plyr-tooltip-arrow-size,4px) solid #0000;border-top:4px solid #fff;border-top:var(--plyr-tooltip-arrow-size,4px) solid var(--plyr-tooltip-background,#fff);bottom:-4px;bottom:calc(var(--plyr-tooltip-arrow-size, 4px)*-1);content:\"\";height:0;left:50%;position:absolute;-webkit-transform:translateX(-50%);transform:translateX(-50%);width:0;z-index:2}.plyr .plyr__control:focus-visible .plyr__tooltip,.plyr .plyr__control:hover .plyr__tooltip,.plyr__tooltip--visible{opacity:1;-webkit-transform:translate(-50%) scale(1);transform:translate(-50%) scale(1)}.plyr .plyr__control:hover .plyr__tooltip{z-index:3}.plyr__controls>.plyr__control:first-child .plyr__tooltip,.plyr__controls>.plyr__control:first-child+.plyr__control .plyr__tooltip{left:0;-webkit-transform:translateY(10px) scale(.8);transform:translateY(10px) scale(.8);-webkit-transform-origin:0 100%;transform-origin:0 100%}.plyr__controls>.plyr__control:first-child .plyr__tooltip:before,.plyr__controls>.plyr__control:first-child+.plyr__control .plyr__tooltip:before{left:16px;left:calc(var(--plyr-control-icon-size, 18px)/2 + var(--plyr-control-spacing, 10px)*.7)}.plyr__controls>.plyr__control:last-child .plyr__tooltip{left:auto;right:0;-webkit-transform:translateY(10px) scale(.8);transform:translateY(10px) scale(.8);-webkit-transform-origin:100% 100%;transform-origin:100% 100%}.plyr__controls>.plyr__control:last-child .plyr__tooltip:before{left:auto;right:16px;right:calc(var(--plyr-control-icon-size, 18px)/2 + var(--plyr-control-spacing, 10px)*.7);-webkit-transform:translateX(50%);transform:translateX(50%)}.plyr__controls>.plyr__control:first-child .plyr__tooltip--visible,.plyr__controls>.plyr__control:first-child+.plyr__control .plyr__tooltip--visible,.plyr__controls>.plyr__control:first-child+.plyr__control:focus-visible .plyr__tooltip,.plyr__controls>.plyr__control:first-child+.plyr__control:hover .plyr__tooltip,.plyr__controls>.plyr__control:first-child:focus-visible .plyr__tooltip,.plyr__controls>.plyr__control:first-child:hover .plyr__tooltip,.plyr__controls>.plyr__control:last-child .plyr__tooltip--visible,.plyr__controls>.plyr__control:last-child:focus-visible .plyr__tooltip,.plyr__controls>.plyr__control:last-child:hover .plyr__tooltip{-webkit-transform:translate(0) scale(1);transform:translate(0) scale(1)}.plyr__progress{left:6.5px;left:calc(var(--plyr-range-thumb-height, 13px)*.5);margin-right:13px;margin-right:var(--plyr-range-thumb-height,13px);position:relative}.plyr__progress input[type=range],.plyr__progress__buffer{margin-left:-6.5px;margin-left:calc(var(--plyr-range-thumb-height, 13px)*-.5);margin-right:-6.5px;margin-right:calc(var(--plyr-range-thumb-height, 13px)*-.5);width:calc(100% + 13px);width:calc(100% + var(--plyr-range-thumb-height, 13px))}.plyr__progress input[type=range]{position:relative;z-index:2}.plyr__progress .plyr__tooltip{left:0;max-width:120px;overflow-wrap:break-word}.plyr__progress__buffer{-webkit-appearance:none;background:#0000;border:0;border-radius:100px;height:5px;height:var(--plyr-range-track-height,5px);left:0;margin-top:-2.5px;margin-top:calc((var(--plyr-range-track-height, 5px)/2)*-1);padding:0;position:absolute;top:50%}.plyr__progress__buffer::-webkit-progress-bar{background:#0000}.plyr__progress__buffer::-webkit-progress-value{background:currentColor;border-radius:100px;min-width:5px;min-width:var(--plyr-range-track-height,5px);-webkit-transition:width .2s ease;transition:width .2s ease}.plyr__progress__buffer::-moz-progress-bar{background:currentColor;border-radius:100px;min-width:5px;min-width:var(--plyr-range-track-height,5px);-moz-transition:width .2s ease;transition:width .2s ease}.plyr__progress__buffer::-ms-fill{border-radius:100px;-ms-transition:width .2s ease;transition:width .2s ease}.plyr--loading .plyr__progress__buffer{-webkit-animation:plyr-progress 1s linear infinite;animation:plyr-progress 1s linear infinite;background-image:linear-gradient(-45deg,#23282f99 25%,#0000 0,#0000 50%,#23282f99 0,#23282f99 75%,#0000 0,#0000);background-image:linear-gradient(-45deg,var(--plyr-progress-loading-background,#23282f99) 25%,#0000 25%,#0000 50%,var(--plyr-progress-loading-background,#23282f99) 50%,var(--plyr-progress-loading-background,#23282f99) 75%,#0000 75%,#0000);background-repeat:repeat-x;background-size:25px 25px;background-size:var(--plyr-progress-loading-size,25px) var(--plyr-progress-loading-size,25px);color:#0000}.plyr--video.plyr--loading .plyr__progress__buffer{background-color:#ffffff40;background-color:var(--plyr-video-progress-buffered-background,#ffffff40)}.plyr--audio.plyr--loading .plyr__progress__buffer{background-color:#c1c8d199;background-color:var(--plyr-audio-progress-buffered-background,#c1c8d199)}.plyr__progress__marker{background-color:#fff;background-color:var(--plyr-progress-marker-background,#fff);border-radius:1px;height:5px;height:var(--plyr-range-track-height,5px);position:absolute;top:50%;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%);width:3px;width:var(--plyr-progress-marker-width,3px);z-index:3}.plyr__volume{-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;position:relative}.plyr__volume input[type=range]{margin-left:5px;margin-left:calc(var(--plyr-control-spacing, 10px)/2);margin-right:5px;margin-right:calc(var(--plyr-control-spacing, 10px)/2);max-width:90px;min-width:60px;position:relative;z-index:2}.plyr--audio{display:block}.plyr--audio .plyr__controls{background:#fff;background:var(--plyr-audio-controls-background,#fff);border-radius:inherit;color:#4a5464;color:var(--plyr-audio-control-color,#4a5464);padding:10px;padding:var(--plyr-control-spacing,10px)}.plyr--audio .plyr__control:focus-visible,.plyr--audio .plyr__control:hover,.plyr--audio .plyr__control[aria-expanded=true]{background:#00b2ff;background:var(--plyr-audio-control-background-hover,var(--plyr-color-main,var(--plyr-color-main,#00b2ff)));color:#fff;color:var(--plyr-audio-control-color-hover,#fff)}.plyr--full-ui.plyr--audio input[type=range]::-webkit-slider-runnable-track{background-color:#c1c8d199;background-color:var(--plyr-audio-range-track-background,var(--plyr-audio-progress-buffered-background,#c1c8d199))}.plyr--full-ui.plyr--audio input[type=range]::-moz-range-track{background-color:#c1c8d199;background-color:var(--plyr-audio-range-track-background,var(--plyr-audio-progress-buffered-background,#c1c8d199))}.plyr--full-ui.plyr--audio input[type=range]::-ms-track{background-color:#c1c8d199;background-color:var(--plyr-audio-range-track-background,var(--plyr-audio-progress-buffered-background,#c1c8d199))}.plyr--full-ui.plyr--audio input[type=range]:active::-webkit-slider-thumb{-webkit-box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33,0 0 0 3px #23282f1a;box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33,0 0 0 3px #23282f1a;-webkit-box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33),0 0 0 var(--plyr-range-thumb-active-shadow-width,3px) var(--plyr-audio-range-thumb-active-shadow-color,#23282f1a);box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33),0 0 0 var(--plyr-range-thumb-active-shadow-width,3px) var(--plyr-audio-range-thumb-active-shadow-color,#23282f1a)}.plyr--full-ui.plyr--audio input[type=range]:active::-moz-range-thumb{box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33,0 0 0 3px #23282f1a;box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33),0 0 0 var(--plyr-range-thumb-active-shadow-width,3px) var(--plyr-audio-range-thumb-active-shadow-color,#23282f1a)}.plyr--full-ui.plyr--audio input[type=range]:active::-ms-thumb{box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33,0 0 0 3px #23282f1a;box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33),0 0 0 var(--plyr-range-thumb-active-shadow-width,3px) var(--plyr-audio-range-thumb-active-shadow-color,#23282f1a)}.plyr--audio .plyr__progress__buffer{color:#c1c8d199;color:var(--plyr-audio-progress-buffered-background,#c1c8d199)}.plyr--video{overflow:hidden}.plyr--video.plyr--menu-open{overflow:visible}.plyr__video-wrapper{background:#000;background:var(--plyr-video-background,var(--plyr-video-background,#000));border-radius:inherit;height:100%;margin:auto;overflow:hidden;position:relative;width:100%}.plyr__video-embed,.plyr__video-wrapper--fixed-ratio{aspect-ratio:16/9}@supports not (aspect-ratio:16/9){.plyr__video-embed,.plyr__video-wrapper--fixed-ratio{height:0;padding-bottom:56.25%;position:relative}}.plyr__video-embed iframe,.plyr__video-wrapper--fixed-ratio video{border:0;height:100%;left:0;position:absolute;top:0;width:100%}.plyr--full-ui .plyr__video-embed>.plyr__video-embed__container{padding-bottom:240%;position:relative;-webkit-transform:translateY(-38.28125%);transform:translateY(-38.28125%)}.plyr--video .plyr__controls{background:-webkit-gradient(linear,left top, left bottom,from(#0000),to(#000000bf));background:linear-gradient(#0000,#000000bf);background:var(--plyr-video-controls-background,linear-gradient(#0000,#000000bf));border-bottom-left-radius:inherit;border-bottom-right-radius:inherit;bottom:0;color:#fff;color:var(--plyr-video-control-color,#fff);left:0;padding:5px;padding:calc(var(--plyr-control-spacing, 10px)/2);padding-top:20px;padding-top:calc(var(--plyr-control-spacing, 10px)*2);position:absolute;right:0;-webkit-transition:opacity .4s ease-in-out,-webkit-transform .4s ease-in-out;transition:opacity .4s ease-in-out,-webkit-transform .4s ease-in-out;transition:opacity .4s ease-in-out,transform .4s ease-in-out;transition:opacity .4s ease-in-out,transform .4s ease-in-out,-webkit-transform .4s ease-in-out;z-index:3}@media (min-width:480px){.plyr--video .plyr__controls{padding:10px;padding:var(--plyr-control-spacing,10px);padding-top:35px;padding-top:calc(var(--plyr-control-spacing, 10px)*3.5)}}.plyr--video.plyr--hide-controls .plyr__controls{opacity:0;pointer-events:none;-webkit-transform:translateY(100%);transform:translateY(100%)}.plyr--video .plyr__control:focus-visible,.plyr--video .plyr__control:hover,.plyr--video .plyr__control[aria-expanded=true]{background:#00b2ff;background:var(--plyr-video-control-background-hover,var(--plyr-color-main,var(--plyr-color-main,#00b2ff)));color:#fff;color:var(--plyr-video-control-color-hover,#fff)}.plyr__control--overlaid{background:#00b2ff;background:var(--plyr-video-control-background-hover,var(--plyr-color-main,var(--plyr-color-main,#00b2ff)));border:0;border-radius:100%;color:#fff;color:var(--plyr-video-control-color,#fff);display:none;left:50%;opacity:.9;padding:15px;padding:calc(var(--plyr-control-spacing, 10px)*1.5);position:absolute;top:50%;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%);-webkit-transition:.3s;transition:.3s;z-index:2}.plyr__control--overlaid svg{left:2px;position:relative}.plyr__control--overlaid:focus,.plyr__control--overlaid:hover{opacity:1}.plyr--playing .plyr__control--overlaid{opacity:0;visibility:hidden}.plyr--full-ui.plyr--video .plyr__control--overlaid{display:block}.plyr--full-ui.plyr--video input[type=range]::-webkit-slider-runnable-track{background-color:#ffffff40;background-color:var(--plyr-video-range-track-background,var(--plyr-video-progress-buffered-background,#ffffff40))}.plyr--full-ui.plyr--video input[type=range]::-moz-range-track{background-color:#ffffff40;background-color:var(--plyr-video-range-track-background,var(--plyr-video-progress-buffered-background,#ffffff40))}.plyr--full-ui.plyr--video input[type=range]::-ms-track{background-color:#ffffff40;background-color:var(--plyr-video-range-track-background,var(--plyr-video-progress-buffered-background,#ffffff40))}.plyr--full-ui.plyr--video input[type=range]:active::-webkit-slider-thumb{-webkit-box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33,0 0 0 3px #ffffff80;box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33,0 0 0 3px #ffffff80;-webkit-box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33),0 0 0 var(--plyr-range-thumb-active-shadow-width,3px) var(--plyr-audio-range-thumb-active-shadow-color,#ffffff80);box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33),0 0 0 var(--plyr-range-thumb-active-shadow-width,3px) var(--plyr-audio-range-thumb-active-shadow-color,#ffffff80)}.plyr--full-ui.plyr--video input[type=range]:active::-moz-range-thumb{box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33,0 0 0 3px #ffffff80;box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33),0 0 0 var(--plyr-range-thumb-active-shadow-width,3px) var(--plyr-audio-range-thumb-active-shadow-color,#ffffff80)}.plyr--full-ui.plyr--video input[type=range]:active::-ms-thumb{box-shadow:0 1px 1px #23282f26,0 0 0 1px #23282f33,0 0 0 3px #ffffff80;box-shadow:var(--plyr-range-thumb-shadow,0 1px 1px #23282f26,0 0 0 1px #23282f33),0 0 0 var(--plyr-range-thumb-active-shadow-width,3px) var(--plyr-audio-range-thumb-active-shadow-color,#ffffff80)}.plyr--video .plyr__progress__buffer{color:#ffffff40;color:var(--plyr-video-progress-buffered-background,#ffffff40)}.plyr:-webkit-full-screen{background:#000;border-radius:0!important;height:100%;margin:0;width:100%}.plyr:-ms-fullscreen{background:#000;border-radius:0!important;height:100%;margin:0;width:100%}.plyr:fullscreen{background:#000;border-radius:0!important;height:100%;margin:0;width:100%}.plyr:-webkit-full-screen video{height:100%}.plyr:-ms-fullscreen video{height:100%}.plyr:fullscreen video{height:100%}.plyr:-webkit-full-screen .plyr__control .icon--exit-fullscreen{display:block}.plyr:-ms-fullscreen .plyr__control .icon--exit-fullscreen{display:block}.plyr:fullscreen .plyr__control .icon--exit-fullscreen{display:block}.plyr:-webkit-full-screen .plyr__control .icon--exit-fullscreen+svg{display:none}.plyr:-ms-fullscreen .plyr__control .icon--exit-fullscreen+svg{display:none}.plyr:fullscreen .plyr__control .icon--exit-fullscreen+svg{display:none}.plyr:-webkit-full-screen.plyr--hide-controls{cursor:none}.plyr:-ms-fullscreen.plyr--hide-controls{cursor:none}.plyr:fullscreen.plyr--hide-controls{cursor:none}@media (min-width:1024px){.plyr:-webkit-full-screen .plyr__captions{font-size:21px;font-size:var(--plyr-font-size-xlarge,21px)}.plyr:-ms-fullscreen .plyr__captions{font-size:21px;font-size:var(--plyr-font-size-xlarge,21px)}.plyr:fullscreen .plyr__captions{font-size:21px;font-size:var(--plyr-font-size-xlarge,21px)}}.plyr--fullscreen-fallback{background:#000;border-radius:0!important;bottom:0;height:100%;left:0;margin:0;position:fixed;right:0;top:0;width:100%;z-index:10000000}.plyr--fullscreen-fallback video{height:100%}.plyr--fullscreen-fallback .plyr__control .icon--exit-fullscreen{display:block}.plyr--fullscreen-fallback .plyr__control .icon--exit-fullscreen+svg{display:none}.plyr--fullscreen-fallback.plyr--hide-controls{cursor:none}@media (min-width:1024px){.plyr--fullscreen-fallback .plyr__captions{font-size:21px;font-size:var(--plyr-font-size-xlarge,21px)}}.plyr__ads{border-radius:inherit;bottom:0;cursor:pointer;left:0;overflow:hidden;position:absolute;right:0;top:0;z-index:-1}.plyr__ads>div,.plyr__ads>div iframe{height:100%;position:absolute;width:100%}.plyr__ads:after{background:#23282f;border-radius:2px;bottom:10px;bottom:var(--plyr-control-spacing,10px);color:#fff;content:attr(data-badge-text);font-size:11px;padding:2px 6px;pointer-events:none;position:absolute;right:10px;right:var(--plyr-control-spacing,10px);z-index:3}.plyr__ads:empty:after{display:none}.plyr__cues{background:currentColor;display:block;height:5px;height:var(--plyr-range-track-height,5px);left:0;opacity:.8;position:absolute;top:50%;-webkit-transform:translateY(-50%);transform:translateY(-50%);width:3px;z-index:3}.plyr__preview-thumb{background-color:#fff;background-color:var(--plyr-tooltip-background,#fff);border-radius:8px;border-radius:var(--plyr-menu-radius,8px);bottom:100%;-webkit-box-shadow:0 1px 2px #00000026;box-shadow:0 1px 2px #00000026;-webkit-box-shadow:var(--plyr-tooltip-shadow,0 1px 2px #00000026);box-shadow:var(--plyr-tooltip-shadow,0 1px 2px #00000026);margin-bottom:10px;margin-bottom:calc(var(--plyr-control-spacing, 10px)/2*2);opacity:0;padding:3px;pointer-events:none;position:absolute;-webkit-transform:translateY(10px) scale(.8);transform:translateY(10px) scale(.8);-webkit-transform-origin:50% 100%;transform-origin:50% 100%;-webkit-transition:opacity .2s ease .1s,-webkit-transform .2s ease .1s;transition:opacity .2s ease .1s,-webkit-transform .2s ease .1s;transition:transform .2s ease .1s,opacity .2s ease .1s;transition:transform .2s ease .1s,opacity .2s ease .1s,-webkit-transform .2s ease .1s;z-index:2}.plyr__preview-thumb--is-shown{opacity:1;-webkit-transform:translate(0) scale(1);transform:translate(0) scale(1)}.plyr__preview-thumb:before{border-left:4px solid #0000;border-left:var(--plyr-tooltip-arrow-size,4px) solid #0000;border-right:4px solid #0000;border-right:var(--plyr-tooltip-arrow-size,4px) solid #0000;border-top:4px solid #fff;border-top:var(--plyr-tooltip-arrow-size,4px) solid var(--plyr-tooltip-background,#fff);bottom:-4px;bottom:calc(var(--plyr-tooltip-arrow-size, 4px)*-1);content:\"\";height:0;left:calc(50% + var(--preview-arrow-offset));position:absolute;-webkit-transform:translateX(-50%);transform:translateX(-50%);width:0;z-index:2}.plyr__preview-thumb__image-container{background:#c1c8d1;border-radius:7px;border-radius:calc(var(--plyr-menu-radius, 8px) - 1px);overflow:hidden;position:relative;z-index:0}.plyr__preview-thumb__image-container img,.plyr__preview-thumb__image-container:after{height:100%;left:0;position:absolute;top:0;width:100%}.plyr__preview-thumb__image-container:after{border-radius:inherit;-webkit-box-shadow:inset 0 0 0 1px #00000026;box-shadow:inset 0 0 0 1px #00000026;content:\"\";pointer-events:none}.plyr__preview-thumb__image-container img{max-height:none;max-width:none}.plyr__preview-thumb__time-container{background:-webkit-gradient(linear,left top, left bottom,from(#0000),to(#000000bf));background:linear-gradient(#0000,#000000bf);background:var(--plyr-video-controls-background,linear-gradient(#0000,#000000bf));border-bottom-left-radius:7px;border-bottom-left-radius:calc(var(--plyr-menu-radius, 8px) - 1px);border-bottom-right-radius:7px;border-bottom-right-radius:calc(var(--plyr-menu-radius, 8px) - 1px);bottom:0;left:0;line-height:1.1;padding:20px 6px 6px;position:absolute;right:0;z-index:3}.plyr__preview-thumb__time-container span{color:#fff;font-size:13px;font-size:var(--plyr-font-size-time,var(--plyr-font-size-small,13px))}.plyr__preview-scrubbing{bottom:0;-webkit-filter:blur(1px);filter:blur(1px);height:100%;left:0;margin:auto;opacity:0;overflow:hidden;pointer-events:none;position:absolute;right:0;top:0;-webkit-transition:opacity .3s ease;transition:opacity .3s ease;width:100%;z-index:1}.plyr__preview-scrubbing--is-shown{opacity:1}.plyr__preview-scrubbing img{height:100%;left:0;max-height:none;max-width:none;-o-object-fit:contain;object-fit:contain;position:absolute;top:0;width:100%}.plyr--no-transition{-webkit-transition:none!important;transition:none!important}.plyr__sr-only{clip:rect(1px,1px,1px,1px);border:0!important;height:1px!important;overflow:hidden;padding:0!important;position:absolute!important;width:1px!important}.plyr [hidden]{display:none!important}.player{min-width:90px !important;min-height:160px !important}.player{min-width:100px !important;height:100% !important}:host{display:block;padding:0;margin:0;width:100%;height:100%;max-height:100%;font-family:inherit !important}vm-player[video]{width:100%;--vm-player-border-radius:0px;--vm-control-spacing:12px;height:100%;--vm-control-bg:rgba(0,0,0,0.25);--vm-control-bg:rgba(45, 45, 45, 0.7);--vm-control-focus-bg:rgba(45, 45, 45, 0.7);--vm-control-border-radius:50%;position:relative}.playerWrapper.fullscreen vm-player[video]{--vm-control-icon-size:24px;--vm-player-border-radius:0px;--vm-control-padding:7px;--vm-control-border:1px solid #fff}.playerWrapper{padding:0;margin:0;border-radius:6px;-webkit-border-radius:6px;-moz-border-radius:6px;-webkit-background-clip:padding-box;-moz-background-clip:padding;background-clip:padding-box;width:100%;max-height:100vh;max-width:calc(100vh * 9/16);margin:auto;background-color:transparent;overflow:hidden;z-index:1;-webkit-background-clip:padding-box;-moz-background-clip:padding;background-clip:padding-box}@media (min-width: 576px){.playerWrapper{aspect-ratio:9/16;width:auto !important}}.playerWrapper.sizemini{border-radius:4px;-webkit-border-radius:4px;-moz-border-radius:4px}.plyr{min-width:100px !important;-webkit-background-clip:padding-box;-moz-background-clip:padding;background-clip:padding-box}.playerWrapper.pinned vm-player[video]{--vm-player-border-radius:0px;--vm-control-bg:transparent}.playerWrapper.pinned.show{display:block}.playerWrapper.pinned{border-radius:6px;-webkit-boder-radius:6px;-moz-border-radius:6px}.playerWrapper.pinned.sizemini{border-radius:4px;-webkit-border-radius:4px;-moz-border-radius:4px}.playerWrapper.pinned{display:none;background-color:transparent;width:calc(var(--asplayer-ch,320px) * 9/16);height:var(--asplayer-ch,320px);position:fixed;z-index:9;-ms-touch-action:manipulation;touch-action:manipulation;outline:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-webkit-transform-origin:center;transform-origin:center;-webkit-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );-moz-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );-ms-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );margin:var( --asplayer-margin, 8px );top:var(--asplayer-pip-top, 0);right:var(--asplayer-pip-right, auto);bottom:var(--asplayer-pip-bottom, auto);left:var(--asplayer-pip-left, 0);}.backdrop{display:none;background:rgba(0,0,0,0.7);-webkit-backdrop-filter:blur(5px);backdrop-filter:blur(5px);position:fixed;top:0;bottom:0;left:0;right:0;width:100vw;height:100vh;z-index:9998;cursor:pointer}.backdrop.fullscreen{display:block}.playerWrapper.fullscreen .plyr{border-radius:0px;-webkit-border-radius:0px;-moz-border-radius:0px}.playerWrapper.fullscreen{background-color:transparent;position:fixed;-ms-touch-action:manipulation;touch-action:manipulation;outline:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-webkit-transform-origin:center;transform-origin:center;-webkit-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );-moz-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );-ms-transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );transform:translate3d( var(--asplayer-translate-x, 0), var(--asplayer-translate-y, 0), 0 );margin:0px auto;top:0;right:0;bottom:0;left:0;z-index:2147483647;}@media (max-width: 576px){.playerWrapper.fullscreen{border-radius:0px;-webkit-border-radius:0px;-moz-border-radius:0px}}.playerWrapper.pinned.hidden{visibility:hidden;height:0px;opacity:0}.playerWrapper.pinned.br{--asplayer-pip-top:auto;--asplayer-pip-right:0;--asplayer-pip-bottom:0;--asplayer-pip-left:auto}.playerWrapper.pinned.bl{--asplayer-pip-top:auto;--asplayer-pip-right:auto;--asplayer-pip-bottom:0;--asplayer-pip-left:0}.playerWrapper.pinned.tr{--asplayer-pip-top:0;--asplayer-pip-right:0;--asplayer-pip-bottom:auto;--asplayer-pip-left:auto}.playerWrapper.pinned.tl{--asplayer-pip-top:0;--asplayer-pip-right:auto;--asplayer-pip-bottom:auto;--asplayer-pip-left:0}video{background:#000}.videoTitle{display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;-ms-flex:1;flex:1;text-overflow:ellipsis;overflow:hidden;height:24px;line-height:24px;white-space:nowrap;font-weight:500;font-size:14px}.videoTitleText{color:#fff;overflow:hidden;display:block;height:28px;text-overflow:ellipsis}.footerTitle .footerTitleText{font-size:18px;line-height:24px !important;font-weight:400;text-shadow:0 0 1px rgb(0 0 0 / 50%);-webkit-transition:opacity 0.3s;transition:opacity 0.3s;display:-webkit-box;line-clamp:2;-webkit-line-clamp:2;box-orient:vertical;-webkit-box-orient:vertical;display:block;text-overflow:ellipsis;overflow:hidden;color:#fff !important;word-wrap:break-word;word-break:break-all}.topPlayerShow{position:absolute;top:0px;left:0px;right:0px;height:33.33%;max-height:80px;width:100%}.bottomPlayerShow{position:absolute;bottom:0px;left:0px;right:0px;height:33.33%;background-image:-webkit-gradient(linear, left bottom, left top, from(rgba(43, 43, 43, 0.5)), to(rgba(43, 43, 43, 0)));background-image:linear-gradient(to top, rgba(43, 43, 43, 0.5), rgba(43, 43, 43, 0));width:100%}.fullplayerclick{position:absolute;top:0;left:0;width:100%;height:100%;display:inline-block;cursor:pointer;z-index:999}.closeIcon{height:var(--vm-control-icon-size);width:var(--vm-control-icon-size);overflow:hidden}.closeIcon:after{display:inline-block;content:\"\\00d7\";font-size:var(--vm-control-icon-size);line-height:var(--vm-control-icon-size);position:relative;top:-2px}.flexWrapper{-webkit-box-sizing:border-box;box-sizing:border-box;min-height:calc(100% - 80px);display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;position:absolute;width:100%;top:80px;text-align:left}.vmWrapper{-ms-flex-positive:1;flex-grow:1;-ms-flex-align:stretch;align-items:stretch;display:-ms-flexbox;display:flex;z-index:1}.ctaLinkContainer{-ms-flex-positive:0;flex-grow:0;-ms-flex-negative:0;flex-shrink:0;margin:0;padding:0px calc(min(12px, 3%)) 16px;z-index:10000}.ctaLinkContainer.no-padding{padding-left:0px;padding-right:0px}.sizemini .ctaLinkContainer{padding-bottom:4px}.playerWrapper.fullscreen .ctaLinkContainer{bottom:40px}.ctaLink{position:relative;display:inline-block;outline:none;cursor:pointer;text-decoration:none;text-align:center;z-index:100;padding:8px 16px;height:auto;font-size:18px;font-weight:500;line-height:36px;vertical-align:middle;border-radius:4px;-webkit-border-radius:4px;-moz-border-radius:4px;margin-bottom:0px;box-shadow:2px 7px 96px -2px rgba(255, 255, 255,0.5);-webkit-box-shadow:2px 7px 96px -2px rgba(255, 255, 255,0.5);-moz-box-shadow:2px 7px 96px -2px rgba(255, 255, 255,0.5)}.ctaLink.large{display:block}.ctaLink.small{float:right}.lds-ring{display:inline-block;position:relative;width:40px;height:40px}.lds-ring div{-webkit-box-sizing:border-box;box-sizing:border-box;display:block;position:absolute;width:32px;height:32px;margin:4px;border:4px solid #fff;border-radius:50%;-webkit-border-radius:50%;-moz-border-radius:50%;-webkit-animation:lds-ring 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;animation:lds-ring 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;border-color:#fff transparent transparent transparent}.lds-ring div:nth-child(1){-webkit-animation-delay:-0.45s;animation-delay:-0.45s}.lds-ring div:nth-child(2){-webkit-animation-delay:-0.3s;animation-delay:-0.3s}.lds-ring div:nth-child(3){-webkit-animation-delay:-0.15s;animation-delay:-0.15s}@-webkit-keyframes lds-ring{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes lds-ring{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}.toastMessage{background-color:rgba(0,0,0,0.7);color:#fff;display:inline-block;padding:8px 16px;text-align:left;width:100%;font-size:14px;line-height:1.2}.ctaLink::after{opacity:0;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;-webkit-box-pack:center;-ms-flex-pack:center;-webkit-justify-content:center;justify-content:center;-webkit-align-items:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;position:absolute;top:0;left:0;right:0;bottom:0;content:'';height:100%;width:100%;background:var(--asplayer-btn-color, var(--gradient));-webkit-animation-name:animation-cta;animation-name:animation-cta;-webkit-animation-duration:2s;animation-duration:2s;-webkit-animation-delay:0;animation-delay:0;-webkit-animation-iteration-count:infinite;animation-iteration-count:infinite;-webkit-animation-timing-function:cubic-bezier(0.65, 0, 0.34, 1);animation-timing-function:cubic-bezier(0.65, 0, 0.34, 1);z-index:-1;border-radius:4px}@keyframes animation-cta{from{opacity:0.7;-webkit-transform:scale3d(1, 1, 1);-moz-transform:scale3d(1, 1, 1);-ms-transform:scale3d(1, 1, 1);transform:scale3d(1, 1, 1)}to{opacity:0;-webkit-transform:scale3d(1.2, 1.2, 1);-moz-transform:scale3d(1.2, 1.2, 1);-ms-transform:scale3d(1.2, 1.2, 1);transform:scale3d(1.2, 1.2, 1)}}@-webkit-keyframes animation-cta{from{opacity:0.7;-webkit-transform:scale3d(1, 1, 1);-moz-transform:scale3d(1, 1, 1);-ms-transform:scale3d(1, 1, 1);transform:scale3d(1, 1, 1)}to{opacity:0;-webkit-transform:scale3d(1.2, 1.2, 1);-moz-transform:scale3d(1.2, 1.2, 1);-ms-transform:scale3d(1.2, 1.2, 1);transform:scale3d(1.2, 1.2, 1)}}.as-player-wrapper{max-height:100%;overflow:hidden}.cards.dark{background-color:#000}.cards{background:#fff;height:100%;width:100%;overflow:hidden;-webkit-box-shadow:5px 8px 15px -10px rgba(0,0,0,0.25);box-shadow:5px 8px 15px -10px rgba(0,0,0,0.25);position:relative}.cards.fullheight{position:absolute;top:0px;left:0px}.z2{z-index:2}.cards img{-o-object-fit:cover;object-fit:cover;width:100%;height:100%}.card_image{width:100%;height:100%}.card_image.loading{width:100%;height:100%}.card_title{padding:8px;font-size:22px;font-weight:700;position:absolute;bottom:0px;left:0px}.card_title.loading{width:50%;height:1rem;margin:1rem;border-radius:3px;position:relative}.card_description{padding:8px;font-size:16px}.card_description.loading{height:3rem;margin:1rem;border-radius:3px}.loading{position:relative;background:#cccccc}.playerWrapper.fullscreen .loading{background:#3a3a3a}.loading:after{content:\"\";display:block;position:absolute;top:0;width:100%;height:100%;-webkit-transform:translateX(-100px);transform:translateX(-100px);background:-webkit-gradient(linear, left top, right top, from(transparent), color-stop(rgba(255,255,255,0.2)), to(transparent));background:linear-gradient(90deg, transparent, rgba(255,255,255,0.2), transparent);-webkit-animation:loading 0.8s infinite;animation:loading 0.8s infinite}.playerWrapper.fullscreen .loading:after{background:-webkit-gradient(linear, left top, right top, from(#3a3a3a), color-stop(10%, #3f3f3f), color-stop(20%, #4a4a4a), color-stop(30%, #3f3f3f), color-stop(50%, #3a3a3a), to(#3a3a3a));background:linear-gradient(to right, #3a3a3a 0%, #3f3f3f 10%, #4a4a4a 20%, #3f3f3f 30%, #3a3a3a 50%, #3a3a3a 100%)}.playanimation{-webkit-animation:pulse 1s infinite;animation:pulse 1s infinite;border-radius:50%;-webkit-border-radius:50%;-moz-border-radius:50%;box-sizing:border-box;-webkit-box-sizing:border-box;-moz-box-sizing:border-box;-o-box-sizing:border-box}.playanimation:hover{-webkit-animation:none;animation:none}.playanimation{width:40px;height:40px;margin:auto;position:absolute;top:0;left:0;bottom:0;right:0;padding:8px;color:#fff;background:rgba(0, 0, 0, 0.7)}.playanimation svg{fill:#fff}.sizemini .playanimation{width:32px;height:32px;padding:6px}.plyr__video-embed iframe,.plyr__video-wrapper--fixed-ratio video{-o-object-fit:cover;object-fit:cover}.plyr__progress{position:absolute;left:4px;width:calc(100% - 16px);display:none;z-index:10001;top:4px}.playerWrapper.reels .plyr__progress{display:block}.fullscreen .plyr__progress{display:block}.playerWrapper{--plyr-color-main:#121212;--plyr-video-progress-buffered-background:rgba(255, 255, 255, 0.5);--plyr-range-thumb-height:1px;--plyr-range-fill-background:rgba(255,255,255, 1);--plyr-range-track-height:2px;--plyr-control-icon-size:24px;--plyr-range-thumb-active-shadow-width:1px;--plyr-control-spacing:10px;--plyr-control-radius:50%}.plyr--video .plyr__controls{top:0px;bottom:inherit;background:-webkit-gradient(linear, left top, left bottom, from(#272727), to(rgba(45, 45, 45, 0)));background:linear-gradient(180deg, #272727 0%, rgba(45, 45, 45, 0) 100%);z-index:10000;padding:16px}.playerWrapper .plyr--video .plyr__controls .plyr__control{padding:7px;background:rgba(45, 45, 45, 0.7);border:1px solid #fff;margin-left:8px}.playerWrapper.pinned .plyr--video .plyr__controls .plyr__control{background:transparent;border:1px solid transparent}.playerWrapper.pinned .plyr--video .plyr__controls .plyr__control:hover{background:rgba(45, 45, 45, 0.7)}.playerWrapper.pinned .plyr{min-width:100px}.plyr--video .plyr__controls.footercontrols{bottom:0px;top:inherit;background:-webkit-gradient(linear, left bottom, left top, from(#272727), to(rgba(45, 45, 45, 0)));background:linear-gradient(360deg, #272727 0%, rgba(45, 45, 45, 0) 100%);-ms-flex-pack:start;justify-content:flex-start}.plyr--video .plyr__controls.footercontrols .plyr__control{margin-left:0px}.playerWrapper.pinned .plyr--video .plyr__controls{padding:8px}.playerWrapper.pinned .plyr{z-index:10001}.plyr--video{height:100%}.playerWrapper.cover .plyr video{-o-object-fit:cover;object-fit:cover}.playerWrapper .plyr__poster{background-size:cover}.plyr video{background:transparent}@-webkit-keyframes pulse{0%{-webkit-box-shadow:0 0 0 0 rgba(0, 0, 0, 0.7)}70%{-webkit-box-shadow:0 0 0 10px rgba(0, 0, 0, 0)}100%{-webkit-box-shadow:0 0 0 0 rgba(0, 0, 0, 0)}}@keyframes pulse{0%{-moz-box-shadow:0 0 0 0 rgba(0, 0, 0, 0.7);-webkit-box-shadow:0 0 0 0 rgba(0, 0, 0, 0.7);box-shadow:0 0 0 0 rgba(0, 0, 0, 0.7)}70%{-moz-box-shadow:0 0 0 10px rgba(0, 0, 0, 0);-webkit-box-shadow:0 0 0 10px rgba(0, 0, 0, 0);box-shadow:0 0 0 10px rgba(0, 0, 0, 0)}100%{-moz-box-shadow:0 0 0 0 rgba(0, 0, 0, 0);-webkit-box-shadow:0 0 0 0 rgba(0, 0, 0, 0);box-shadow:0 0 0 0 rgba(0, 0, 0, 0)}}@-webkit-keyframes pulse-white{0%{-webkit-box-shadow:0 0 0 0 rgba(255, 255, 255, 0.7);box-shadow:0 0 0 0 rgba(255, 255, 255, 0.7)}70%{-webkit-box-shadow:0 0 0 10px rgba(255, 255, 255, 0);box-shadow:0 0 0 10px rgba(255, 255, 255, 0)}100%{-webkit-box-shadow:0 0 0 0 rgba(255, 255, 255, 0);box-shadow:0 0 0 0 rgba(255, 255, 255, 0)}}@keyframes pulse-white{0%{-webkit-box-shadow:0 0 0 0 rgba(255, 255, 255, 0.7);box-shadow:0 0 0 0 rgba(255, 255, 255, 0.7)}70%{-webkit-box-shadow:0 0 0 10px rgba(255, 255, 255, 0);box-shadow:0 0 0 10px rgba(255, 255, 255, 0)}100%{-webkit-box-shadow:0 0 0 0 rgba(255, 255, 255, 0);box-shadow:0 0 0 0 rgba(255, 255, 255, 0)}}@-webkit-keyframes loading{100%{-webkit-transform:translateX(100%);transform:translateX(100%)}}@keyframes loading{100%{-webkit-transform:translateX(100%);transform:translateX(100%)}}";

// import posthog from 'posthog-js'
// if (!window.location.host.includes('127.0.0.1') && !window.location.host.includes('localhost')) {
//   posthog.init('phc_PFn3ipf7jR88MXFX73PMM6l7A0G5EeZf0llC0u5FVKv', { api_host: 'https://app.posthog.com', autocapture: false, capture_pageview: false})
// }
const jitsu = jitsuClient({
  key: "js.ku52f0vferwtf16hunn8p6.s4zhwpli8w7pwz9k0y1kc",
  tracking_host: "https://t.jitsu.com"
});
const AsPlayer = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.shopifyProduct = null;
    this.shopifyVariantId = null;
    this.shopifyQty = 1;
    this.playingTime = 0;
    this.startTime = 0;
    this.plyrloaded = false;
    this.pload = 'metadata';
    this.videoId = undefined;
    this.fvideo = undefined;
    this.channelId = null;
    this.playlistId = null;
    this.env = '';
    this.showheader = true;
    this.showheadertitle = true;
    this.showfooterplay = false;
    this.showfootertitle = false;
    this.showproductchip = false;
    this.showproductcard = false;
    this.w = null;
    this.h = null;
    this.sw = undefined;
    this.sh = undefined;
    this.autoplay = false;
    this.loop = true;
    this.fullscreen = false;
    this.playclick = undefined;
    this.mode = 'story';
    this.position = 'br';
    this.piphandler = null;
    this.platform = 'web';
    this.widget = 'storyblok';
    this.shopify = false;
    this.tk = true;
    this.placeholder = true;
    this.productoverlay = null;
    this.forcemute = null;
    this.mutehandler = null;
    this.index = null;
    this.size = 'default';
    this.ch = 320;
    this.preload = false;
    this.video = null;
    this.isMute = true;
    this.isPlaying = false;
    this.videoUrl = undefined;
    this.hiddenControls = false;
    this.hidden = false;
    this.handlerPipMode = false;
    this.addedToCart = false;
    this.addToCartLoading = false;
    this.loopCount = 0;
    this.loading = true;
    this.playerready = false;
    this.cover = true;
    this.playsuspend = false;
  }
  // private iosSafari: boolean = false;
  async load() {
    if (this.loading) {
      setTimeout(this.load, 100);
    }
    else if (!this.plyrloaded) {
      try {
        this.setupPlyr();
      }
      catch (e) {
        setTimeout(this.load, 200);
      }
    }
  }
  async closeoverlay() {
    const overlay = this.productoverlay ? this.productoverlay : this.el.shadowRoot.querySelector('as-product-overlay');
    overlay === null || overlay === void 0 ? void 0 : overlay.close(false);
  }
  async play() {
    var _a;
    // show a prompt
    //  console.log(`play triggered ${this.video.title}`, this.player.playing, this.isPlaying, this.playerready, this.loading);
    if (!this.plyrloaded) {
      this.setupPlyr();
      setTimeout(() => this.play(), 100);
    }
    else {
      try {
        if (!this.loading && this.playerready) {
          if (!((_a = this.player) === null || _a === void 0 ? void 0 : _a.playing) && !this.isPlaying) {
            // const overlay = this.productoverlay ? this.productoverlay : this.el.shadowRoot.querySelector('as-product-overlay');
            // overlay?.close();
            this.player.play().catch((error) => {
              console.log(error.name);
              if (error.name === 'NotAllowedError') {
                this.playsuspend = true;
              }
              else {
                this.muted(true);
                if (!this.playsuspend) {
                  setTimeout(() => this.play(), 100);
                  this.playsuspend = true;
                }
              }
              // alert(error);
            });
            this.isPlaying = true;
          }
          // else {
          if (!this.playsuspend) {
            setTimeout(() => {
              var _a;
              this.isPlaying = (_a = this.player) === null || _a === void 0 ? void 0 : _a.playing;
              if (!this.isPlaying) {
                const vel = this.el.shadowRoot.querySelector('video');
                const velplaying = !!(vel.currentTime > 0 && !vel.paused && !vel.ended && vel.readyState > 2);
                this.isPlaying = velplaying;
                // console.log('vel playing', vel, velplaying);
                if (!this.isPlaying) {
                  // this.player.destroy();
                  // this.setupPlyr();
                  this.play();
                }
                // 
              }
            }, 100);
          }
          else {
            // this.isPlaying = false;
            this.player.playing = false;
          }
          // }
        }
        else {
          setTimeout(() => this.play(), 200);
        }
      }
      catch (e) {
        // console.log('play error', e);
        this.isMute = true;
        if (this.player) {
          this.player.muted = true;
          this.play();
        }
        else {
          setTimeout(() => this.play(), 200);
        }
      }
    }
  }
  async pause() {
    // show a prompt
    // console.log(`pause triggered ${this.video.title}`, this.player.playing, this.isPlaying);
    var _a, _b, _c;
    if (!this.player) {
      setTimeout(() => this.pause(), 100);
    }
    else {
      if (this.isPlaying || ((_a = this.player) === null || _a === void 0 ? void 0 : _a.playing)) {
        (_b = this.player) === null || _b === void 0 ? void 0 : _b.pause();
        // alert('pause');
        this.isPlaying = false;
      }
      const vel = this.el.shadowRoot.querySelector('video');
      const velplaying = !!(vel.currentTime > 0 && !vel.paused && !vel.ended && vel.readyState > 2);
      if (((_c = this.player) === null || _c === void 0 ? void 0 : _c.playing) || velplaying) {
        vel.pause();
      }
    }
  }
  async muted(t) {
    // show a prompt
    // console.log('muted', t);
    if (this.playerready && this.player) {
      this.isMute = t;
      this.player.muted = t;
    }
    else {
      setTimeout(() => this.muted(t), 200);
    }
  }
  async viewFullScreen() {
    this.openFullScreen();
  }
  // @Listen('load', { target: 'window' })
  // async onPageLoad() {
  //   if(this.mode === 'pinned' || this.widget === 'storyblok' || this.preload) {
  //     // console.log('plyr loaded', this.plyrloaded);
  //     setTimeout(() => this.load(), 100);
  //   }
  // }
  async windowResize() {
    // show a prompt
    var s = this;
    const vidEl = this.el.shadowRoot.querySelector('.as-player-wrapper');
    this.resetHeight(vidEl, s);
  }
  async pageExit() {
    // show a prompt
    if (this.video) {
      this.trackEvent("end_watch_video", Object.assign({ category: this.getPlayerCategory(), loop_count: this.loopCount, playing_time: this.playingTime, watch_time: Math.min(10, this.loopCount) * this.video.duration + this.playingTime, mute: this.isMute }, this.getCtaAttributes(this)));
    }
    return true;
  }
  async pageBlur() {
  }
  async pageFocus() {
  }
  watchStateHandler(newValue) {
  }
  componentWillLoad() {
    if (this.size === 'mini') {
      this.ch = 180;
      var style = document.createElement('style');
      style.innerHTML = `:root { --asplayer-ch: ${this.ch}px; }`;
      if (this.ch <= 210) {
        style.innerHTML = `${style.innerHTML}  @media (min-width: 768px) { :root { --asplayer-ch: ${this.ch * 1.5}px; } }`;
      }
      document.body.appendChild(style);
    }
    if (this.mode === 'pinned') {
      this.enablePip();
      if (this.widget === 'storyblok') {
        this.widget = 'floating_player';
      }
    }
    if (this.piphandler) {
      // console.log('handler pip mode fls', this.fullscreen);
      this.handlerPipMode = true;
    }
    if (this.forcemute) {
      this.isMute = true;
    }
  }
  async componentDidLoad() {
    // var ua = window.navigator.userAgent;
    // var iOS = !!ua.match(/iPad/i) || !!ua.match(/iPhone/i);
    // var webkit = !!ua.match(/WebKit/i);
    // this.iosSafari = iOS && webkit && !ua.match(/CriOS/i);
    var _a, _b, _c, _d, _e, _f, _g;
    var s = window;
    // var isSafari = /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
    // if(isSafari) {
    //   this.pload = 'auto';
    // }
    // console.log('given w h', this.w, this.h);
    if (this.video || this.placeholder) {
      if (!this.sw) {
        this.sw = this.el.getBoundingClientRect().width;
        this.sh = this.el.getBoundingClientRect().height;
        if (this.h) {
          this.sh = parseInt(this.h.replace('px', ''));
        }
      }
      const vidEl = this.el.shadowRoot.querySelector('.as-player-wrapper');
      const st = this;
      this.resetHeight(vidEl, st);
    }
    let finalvideo = null;
    if (this.fvideo) {
      finalvideo = this.fvideo;
      this.videoUrl = this.getVideoUrl(finalvideo);
    }
    if ((s === null || s === void 0 ? void 0 : s.Shopify) && this.platform === 'shopify') {
      this.shopify = true;
      if (this.mode === 'pinned' && !this.videoId) {
        const sp = await this.onShopifyProductPage();
        if (!sp) {
          // console.log('not product page - player wont load');
          return false;
        }
      }
      // console.log('shopify product', this.shopifyProduct);
    }
    // console.log('video', this.video.id);
    if (!finalvideo) {
      let cheader = {
        "Content-type": "application/json;charset=UTF-8",
      };
      if (this.channelId) {
        cheader["channel_id"] = this.channelId;
      }
      let vUrl = `${this.getApiUrl(this.env)}/web/videos/`;
      if (this.videoId) {
        vUrl = `${vUrl}${this.videoId}`;
      }
      else if (this.platform === 'shopify' && ((_b = (_a = this.shopifyProduct) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id)) {
        vUrl = `${vUrl}product-video?productId=${(_d = (_c = this.shopifyProduct) === null || _c === void 0 ? void 0 : _c.product) === null || _d === void 0 ? void 0 : _d.id}&platform=shopify`;
      }
      else {
        // console.log('no api to fetch from');
        return false;
      }
      const vidResponse = await fetch(vUrl, {
        method: "GET",
        headers: cheader,
      });
      if (vidResponse.status === 200) {
        const vidData = await vidResponse.json();
        finalvideo = vidData;
        this.videoUrl = this.getVideoUrl(finalvideo);
      }
      else {
        return false;
      }
    }
    // console.log('final video', finalvideo);
    this.setVideo(finalvideo);
    if ((_g = (_f = (_e = this.video) === null || _e === void 0 ? void 0 : _e.channel) === null || _f === void 0 ? void 0 : _f.primaryColor) === null || _g === void 0 ? void 0 : _g.hex) {
      var style = document.createElement('style');
      style.innerHTML = `.photoWrapper { --as-player-btn-color: ${this.video.channel.primaryColor.hex}; --as-player-btn-txt-color: ${this.video.channel.textColor.hex}; }`;
      this.el.shadowRoot.appendChild(style);
    }
    if (this.tk && this.video) {
      this.setJitsu(this);
    }
    return true;
  }
  render() {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return (h(Host, null, this.mode === 'pinned' && h("div", { class: { backdrop: (this.mode === 'pinned'),
        fullscreen: this.fullscreen
      }, onClick: this.backdropClick }), h("div", { class: { playerWrapper: true,
        'as-player-wrapper': true,
        'cover': this.cover,
        'pinned': (this.mode === 'pinned' && !this.fullscreen),
        'fullscreen': ((this.fullscreen || this.widget === 'carousel_player_fullscreen') && this.widget !== 'reels_player_fullscreen'),
        'reels': (this.widget === 'reels_player_fullscreen'),
        'br': (this.position === 'br'),
        'bl': (this.position === 'bl'),
        'tr': (this.position === 'tr'),
        'tl': (this.position === 'tl'),
        'hidden': (this.hidden),
        'show': this.videoUrl ? true : false,
        'sizemini': (this.size === 'mini'),
      }, style: { width: `${this.w && !this.fullscreen ? this.w : '100%'}`, height: `${this.h ? this.h : (this.fullscreen || this.sw < 576 ? '100%' : '75vh')}` } }, (!this.video) && this.mode !== 'pinned' && (h("div", { class: "cards" }, h("div", { class: "card_image loading" }))), h("div", { style: { height: '100%', position: 'relative', background: '#000' }, id: `as-player-${((_a = this.video) === null || _a === void 0 ? void 0 : _a.id) || Date.now() * Math.random()}` }, !this.productoverlay && h("as-product-overlay", { trackevent: this.trackEvent, env: this.env }), this.videoUrl && h("video", { preload: this.pload, class: "lazy player lozad", playsinline: true, id: "player", "data-poster": ((_c = (_b = this.video) === null || _b === void 0 ? void 0 : _b.posterUrls) === null || _c === void 0 ? void 0 : _c['576']) || "https://cdnv2.allstudio.live/video-poster-placeholder.png", "data-src": this.videoUrl, style: { width: `${this.w && !this.fullscreen ? this.w : '100%'}`, height: `${this.h ? this.h : (this.fullscreen || this.sw < 576 ? '100vh' : '75vh')}` } }, this.videoUrl && h("source", { "data-src": this.videoUrl, type: "video/mp4" })), (this.mode !== 'pinned') && ((!this.isPlaying && this.playerready && !this.fullscreen)) && (h("div", { class: "cards fullheight z2" }, h("img", { src: ((_e = (_d = this.video) === null || _d === void 0 ? void 0 : _d.posterUrls) === null || _e === void 0 ? void 0 : _e['576']) || "https://cdnv2.allstudio.live/video-poster-placeholder.png" }), h("div", { class: "playanimation", onClick: this.playControlClick }, h("svg", { class: "icon", role: "presentation", width: this.size === 'mini' ? 20 : 24, viewBox: "0 0 24 24" }, h("use", { xlinkHref: "#as-play" }))))), this.isPlaying && (this.widget === 'carousel_player' || this.widget === 'grid_player') && (h("div", { class: "fullheight z2" }, h("div", { class: "playanimation", onClick: this.playControlClick }, h("svg", { class: "icon", role: "presentation", width: this.size === 'mini' ? 20 : 24, viewBox: "0 0 24 24" }, h("use", { xlinkHref: "#as-play" }))))), this.video && h("div", { class: "flexWrapper", style: { height: `calc(${this.h} - ${this.mode === 'pinned' && !this.fullscreen ? '56px' : '104px'})` } }, h("main", { class: "vmWrapper", onClick: this.playControlClick }), !this.showfootertitle && this.showheadertitle && this.video.shoppableType === 'cta'
      && ((_f = this.video.shoppableData) === null || _f === void 0 ? void 0 : _f.ctaLink) !== '' && (h("footer", { class: "ctaLinkContainer" }, h("a", { class: {
        ctaLink: true,
        large: (this.video.channel.ctaButtonSize === 'large'),
        small: (this.video.channel.ctaButtonSize === 'small'),
      }, style: {
        "color": `${this.video.channel.textColor.hex}`,
        "background-color": `${this.video.channel.primaryColor.hex}`,
      }, href: (_g = this.video.shoppableData) === null || _g === void 0 ? void 0 : _g.ctaLink, title: (_h = this.video.shoppableData) === null || _h === void 0 ? void 0 : _h.ctaType }, (_j = this.video.shoppableData) === null || _j === void 0 ? void 0 : _j.ctaType))), !this.showfootertitle && this.showheadertitle && this.platform === 'shopify' && this.video.shoppableType === 'addtocart'
      && this.shopifyVariantId && (h("footer", { class: "ctaLinkContainer" }, this.addedToCart ? h("div", { class: "toastMessage" }, "Item added to cart.") :
      h("a", { class: {
          ctaLink: true,
          large: (this.video.channel.ctaButtonSize === 'large'),
          small: (this.video.channel.ctaButtonSize === 'small'),
        }, style: {
          "color": `${this.video.channel.textColor.hex}`,
          "background-color": `${this.video.channel.primaryColor.hex}`
        }, onClick: async (e) => {
          e.preventDefault();
          if (!this.addToCartLoading)
            await this.addShopifyItem();
        }, title: (_k = this.video.shoppableData) === null || _k === void 0 ? void 0 : _k.ctaType }, this.addToCartLoading ? (h("div", { class: "lds-ring" }, h("div", null), h("div", null), h("div", null), h("div", null))) : (_l = this.video.shoppableData) === null || _l === void 0 ? void 0 : _l.ctaType))), this.showproductchip && ((_m = this.video.shoppableData) === null || _m === void 0 ? void 0 : _m.products) && !this.loading && this.playclick ? (h("footer", { class: "ctaLinkContainer" }, h("as-product-chip", { size: this.size, onClick: this.playControlClick, products: (_o = this.video.shoppableData) === null || _o === void 0 ? void 0 : _o.products, trackevent: this.trackEvent }))) : (h("span", null)), this.showproductcard && ((_p = this.video.shoppableData) === null || _p === void 0 ? void 0 : _p.products) && !this.loading ? (h("footer", { class: "ctaLinkContainer no-padding" }, h("as-product-card-slider", { products: (_q = this.video.shoppableData) === null || _q === void 0 ? void 0 : _q.products, overlay: this.productoverlay ? this.productoverlay : this.el.shadowRoot.querySelector('as-product-overlay'), channel: this.video.channel, trackevent: this.trackEvent, player: this }))) : (h("span", null))))), h("div", { hidden: true }, h("svg", null, h("defs", null, h("g", { id: "as-airplay" }, h("path", { d: "M28.444 1.778h-24.889c-0.983 0-1.778 0.795-1.778 1.778v17.778c0 0.983 0.795 1.778 1.778 1.778h5.333v-3.556h-3.556v-14.222h21.333v14.222h-3.556v3.556h5.333c0.983 0 1.778-0.795 1.778-1.778v-17.778c0-0.983-0.795-1.778-1.778-1.778v0z" }), h("path", { d: "M7.111 30.222h17.778l-8.889-10.667z" })), h("g", { id: "as-enter-fullscreen" }, h("path", { d: "M17.778 5.333h6.4l-7.111 7.111 2.489 2.489 7.111-7.111v6.4h3.556v-12.444h-12.444z" }), h("path", { d: "M12.444 17.067l-7.111 7.111v-6.4h-3.556v12.444h12.444v-3.556h-6.4l7.111-7.111z" })), h("g", { id: "as-exit-fullscreen" }, h("path", { d: "M1.778 21.333h6.4l-7.111 7.111 2.489 2.489 7.111-7.111v6.4h3.556v-12.444h-12.444z" }), h("path", { d: "M28.444 1.067l-7.111 7.111v-6.4h-3.556v12.444h12.444v-3.556h-6.4l7.111-7.111z" })), h("g", { id: "as-fast-forward" }, h("path", { d: "M14 12.749l-14-10.971v28.444l14-10.971v10.971l18-14.222-18-14.222z" })), h("g", { id: "as-logo-vimeo" }, h("path", { d: "M30.222 9.422c-0.178 2.844-2.133 6.578-5.867 11.378-3.911 4.978-7.111 7.467-9.778 7.467-1.6 0-3.022-1.6-4.267-4.622-1.422-4.267-2.489-12.978-4.978-12.978-0.178 0-0.889 0.533-2.133 1.422l-1.422-1.778c1.422-1.244 6.222-6.044 8.356-6.222s3.556 1.244 4.089 4.444c0.533 3.556 1.422 10.844 3.2 10.844 1.6 0 4.444-6.044 4.622-7.111 0.178-1.6-0.533-3.378-4.089-1.956 1.422-4.622 4.089-6.756 8-6.756 3.022 0.178 4.444 2.133 4.267 5.867z" })), h("g", { id: "as-logo-youtube" }, h("path", { d: "M29.867 10.311c-0.356-2.311-1.422-3.911-3.911-4.267-3.911-0.711-9.956-0.711-9.956-0.711s-6.044 0-9.956 0.711c-2.489 0.356-3.733 1.956-3.911 4.267-0.356 2.311-0.356 5.689-0.356 5.689s0 3.378 0.356 5.689c0.356 2.311 1.422 3.911 3.911 4.267 3.911 0.711 9.956 0.711 9.956 0.711s6.044 0 9.956-0.711c2.489-0.533 3.556-1.956 3.911-4.267s0.356-5.689 0.356-5.689c0 0 0-3.378-0.356-5.689zM12.444 21.333v-10.667l8.889 5.333-8.889 5.333z" })), h("g", { id: "as-pause" }, h("path", { d: "M7 5H11V20H7V5ZM14 5H18V20H14V5Z" })), h("g", { id: "as-pip" }, h("path", { d: "M23.632 5.854l-11.148 11.148 2.514 2.514 11.148-11.148 4.076 4.076v-10.667h-10.667z" }), h("path", { d: "M23.111 26.667h-17.778v-17.778h8.889v-3.556h-10.667c-0.981 0-1.778 0.796-1.778 1.778v21.333c0 0.981 0.796 1.778 1.778 1.778h21.333c0.981 0 1.778-0.796 1.778-1.778v-10.667h-3.556v8.889z" })), h("g", { id: "as-play" }, h("path", { d: "M7.00002 5.47025C7.00002 5.09676 7.57955 4.87281 7.87872 5.07784L17.7971 12.1762C18.0676 12.3616 18.0676 12.7756 17.7971 12.961L7.8787 19.9222C7.57953 20.1272 7 19.9032 7 19.5297L7.00002 12.5686V5.47025Z" })), h("g", { id: "as-restart" }, h("path", { d: "M17.244 2.133l1.244 11.378 3.733-3.733c3.378 3.378 3.378 9.067 0 12.444-1.6 1.778-3.911 2.667-6.222 2.667s-4.622-0.889-6.222-2.667c-3.378-3.378-3.378-9.067 0-12.444 1.067-1.067 2.489-1.956 4.089-2.311l-1.067-3.378c-2.133 0.533-4.089 1.6-5.689 3.2-4.8 4.8-4.8 12.622 0 17.6 2.311 2.311 5.511 3.556 8.711 3.556 3.378 0 6.4-1.244 8.711-3.556 4.8-4.8 4.8-12.622 0-17.6l3.911-3.911-11.2-1.244z" })), h("g", { id: "as-rewind" }, h("path", { d: "M18 1.778l-18 14.222 18 14.222v-10.971l14 10.971v-28.444l-14 10.971z" })), h("g", { id: "as-settings" }, h("path", { d: "M28.684 13.838c-2.316-0.58-3.415-3.232-2.187-5.278 0.572-0.953 0.4-1.774-0.167-2.34l-0.551-0.551c-0.565-0.565-1.387-0.738-2.34-0.167-2.048 1.228-4.7 0.13-5.278-2.187-0.268-1.079-0.972-1.538-1.772-1.538h-0.779c-0.8 0-1.502 0.459-1.772 1.538-0.58 2.316-3.232 3.415-5.278 2.187-0.953-0.572-1.776-0.4-2.341 0.165l-0.551 0.551c-0.565 0.565-0.738 1.388-0.165 2.341 1.228 2.048 0.13 4.7-2.187 5.278-1.076 0.268-1.538 0.971-1.538 1.772v0.779c0 0.8 0.459 1.502 1.538 1.772 2.316 0.58 3.415 3.232 2.187 5.278-0.572 0.953-0.4 1.774 0.167 2.34l0.551 0.551c0.567 0.567 1.39 0.738 2.34 0.167 2.048-1.228 4.7-0.13 5.278 2.187 0.268 1.079 0.972 1.538 1.772 1.538h0.779c0.8 0 1.502-0.459 1.772-1.538 0.58-2.316 3.232-3.415 5.278-2.187 0.951 0.571 1.772 0.4 2.34-0.167l0.551-0.551c0.565-0.565 0.738-1.388 0.167-2.34-1.228-2.048-0.13-4.7 2.187-5.278 1.079-0.268 1.538-0.972 1.538-1.772v-0.779c0-0.802-0.462-1.504-1.538-1.772v0zM16 21.333c-2.946 0-5.333-2.388-5.333-5.333s2.388-5.333 5.333-5.333c2.946 0 5.333 2.388 5.333 5.333s-2.388 5.333-5.333 5.333v0z" })), h("g", { id: "as-arrow-down" }, h("path", { d: "M5.027 8.44l-2.36 2.36 13.2 13.2 13.2-13.2-2.36-2.36-10.84 10.84-10.84-10.84z" })), h("g", { id: "as-arrow-left" }, h("path", { d: "M23.56 5.027l-2.36-2.36-13.2 13.2 13.2 13.2 2.36-2.36-10.84-10.84 10.84-10.84z" })), h("g", { id: "as-arrow-right-mini" }, h("path", { d: "M11.453 22.12l6.107-6.12-6.107-6.12 1.88-1.88 8 8-8 8-1.88-1.88z" })), h("g", { id: "as-arrow-right-white" }, h("path", { fill: "#000", d: "M17.113 16.008l-4.845-4.846c-0.358-0.358-0.358-0.937 0-1.294s0.937-0.358 1.294 0l5.494 5.493c0.358 0.357 0.358 0.936 0 1.294l-5.493 5.492c-0.358 0.358-0.937 0.358-1.294 0s-0.358-0.937 0-1.294l4.844-4.845z" }), h("path", { fill: "#fff", d: "M17.113 16.008l-4.845-4.846c-0.358-0.358-0.358-0.937 0-1.294s0.937-0.358 1.294 0l5.494 5.493c0.358 0.357 0.358 0.936 0 1.294l-5.493 5.492c-0.358 0.358-0.937 0.358-1.294 0s-0.358-0.937 0-1.294l4.844-4.845z" })), h("g", { id: "as-captions-off" }, h("path", { opacity: "0.5", fill: "#000", d: "M4 8.001c0-0.615 0.669-1.334 1.33-1.334h21.339c0.71 0 1.33 0.719 1.33 1.334v15.983c0 0.682-0.649 1.349-1.345 1.349h-21.31c-0.647 0-1.345-0.667-1.345-1.349v-15.983zM9.135 11.435c-0.57 0-1.141 0.572-1.141 1.144v6.867c0 0.572 0.571 1.144 1.141 1.144h5.705v-2.289h-4.564v-4.578h4.564v-2.289h-5.705zM23.968 11.435h-5.705c-0.571 0-1.141 0.572-1.141 1.144v6.867c0 0.572 0.571 1.144 1.141 1.144h5.705v-9.155zM19.404 13.724v4.578h4.564v-4.578h-4.564z" })), h("g", { id: "as-captions-on" }, h("path", { d: "M4 8.001c0-0.615 0.669-1.334 1.33-1.334h21.339c0.71 0 1.33 0.719 1.33 1.334v15.983c0 0.682-0.649 1.349-1.345 1.349h-21.31c-0.647 0-1.345-0.667-1.345-1.349v-15.983zM14.84 18.302h-4.564v-4.578h4.564v-2.289h-5.705c-0.571 0-1.141 0.572-1.141 1.144v6.866c0 0.572 0.57 1.144 1.141 1.144h5.705v-2.289zM23.968 20.59v-9.155h-5.705c-0.571 0-1.141 0.572-1.141 1.144v6.866c0 0.572 0.571 1.144 1.141 1.144h5.705zM19.404 13.724h4.564v4.578h-4.564v-4.578z" })), h("g", { id: "as-check" }, h("path", { d: "M7.014 15.484l-3.014 3.123 7.734 8.060 16.266-16.854-3.036-3.146-13.23 13.708-4.72-4.891z" })), h("g", { id: "as-close" }, h("path", { d: "M25.333 8.547l-1.88-1.88-7.453 7.453-7.453-7.453-1.88 1.88 7.453 7.453-7.453 7.453 1.88 1.88 7.453-7.453 7.453 7.453 1.88-1.88-7.453-7.453 7.453-7.453z" })), h("g", { id: "as-muted" }, h("path", { d: "M5.787 3.907l-1.88 1.88 5.813 5.813-0.387 0.4h-5.333v8h5.333l6.667 6.667v-8.787l5.573 5.573c-0.867 0.653-1.84 1.173-2.907 1.48v2.747c1.787-0.4 3.427-1.227 4.813-2.333l2.733 2.733 1.88-1.88-22.307-22.293zM13.333 20.227l-2.893-2.893h-3.773v-2.667h3.773l1.173-1.173 1.72 1.72v5.013zM25.333 16c0 1.093-0.2 2.147-0.547 3.12l2.040 2.040c0.747-1.56 1.173-3.307 1.173-5.16 0-5.707-3.987-10.48-9.333-11.693v2.747c3.853 1.147 6.667 4.72 6.667 8.947zM16 5.333l-2.507 2.507 2.507 2.507v-5.013zM22 16c0-2.36-1.36-4.387-3.333-5.373v2.387l3.307 3.307c0.013-0.107 0.027-0.213 0.027-0.32z" })), h("g", { id: "as-volume" }, h("path", { d: "M4 12v8h5.333l6.667 6.667v-21.333l-6.667 6.667h-5.333zM13.333 11.773v8.453l-2.893-2.893h-3.773v-2.667h3.773l2.893-2.893zM22 16c0-2.36-1.36-4.387-3.333-5.373v10.733c1.973-0.973 3.333-3 3.333-5.36zM18.667 4.307v2.747c3.853 1.147 6.667 4.72 6.667 8.947s-2.813 7.8-6.667 8.947v2.747c5.347-1.213 9.333-5.987 9.333-11.693s-3.987-10.48-9.333-11.693v0z" })))))));
  }
  setupObserver() {
    // console.log('observer setup');
    const obs = new IntersectionObserver((entries, observerRef) => {
      // The callback is run when the visibility of one or more of the elements
      // being observed has changed. It's also called on page load.
      entries.forEach(async (entry) => {
        //`isIntersecting` will be `true` if any part of the element is currently visible
        if (entry.isIntersecting) {
          // We are assuming here that your Web Component is located in a file
          // named after it's tag name
          this.load();
          // Once we've observed this element come into view, we can safely remove
          // the observer since we won't need to import the WC code again
          observerRef.unobserve(entry.target);
        }
      });
    }, {
      rootMargin: '50px 0px 50px'
    });
    setTimeout(() => {
      const els1 = this.el.shadowRoot.querySelectorAll('.as-player-wrapper');
      els1.forEach((el) => {
        obs.observe(el);
      });
    }, 0);
  }
  getApiUrl(env) {
    let apiUrl = `https://apiv2.allstudio.live`;
    if (env === 'dev') {
      apiUrl = `${apiUrl}/dev`;
    }
    else if (env === 'qa') {
      apiUrl = `${apiUrl}/qa`;
    }
    else if (env === 'local') {
      apiUrl = `http://localhost:4011`;
    }
    return apiUrl;
  }
  getVideoUrl(vid) {
    let finalUrl = vid.url;
    try {
      if (vid.isProcessed && vid.processedUrls['576p']) {
        finalUrl = vid.processedUrls['576p'];
      }
    }
    catch (e) {
      finalUrl = vid.url;
    }
    // console.log('finalUrl', finalUrl);
    return finalUrl;
  }
  resetHeight(vidEl, s) {
    // reset the body height to that of the inner browser
    // s.sh = window.innerHeight;
    // console.log('window inner height', s.sh);
    this.setPlayerHeight(vidEl, s);
  }
  setPlayerHeight(vidEl, s) {
    const ch = s.el.getBoundingClientRect();
    // console.log('ch final', ch, s.fullscreen);
    if (s.w || s.h) {
      // console.log('defined final', s.w, s.h, s.fullscreen);
      if (s.mode === 'pinned' && s.fullscreen) {
        s.sh = window.innerHeight;
      }
      if (s.fullscreen) {
        s.h = `${s.sh}px`;
      }
      if (!s.w) {
        s.h = `100%`;
        s.w = `100%`;
      }
    }
    else {
      // const cw = this.el.clientHeight;
      let vw = ch.width;
      let vh = s.sh || ch.height;
      if (vw === 0 && vh === 0) {
        vw = s.sw || 0;
        vh = s.sh || 0;
      }
      if (this.mode === 'pinned' && this.fullscreen) {
        vh = window.innerHeight;
        vw = vh * 9 / 16;
      }
      if (vw === 0 || !vw) {
        if (vh === 0) {
          vh = this.ch;
        }
        vw = vh * 9 / 16;
      }
      else if (vh > 0 && vh / vw > 16 / 9) {
        const tw = vh * 9 / 16;
        if (tw > vw && !this.fullscreen) {
          vh = vw * 16 / 9;
        }
        else if (vw === 0 && tw > 0 && !this.fullscreen) {
          vw = tw;
        }
      }
      else if (vh > 0 && vh / vw < 16 / 9) {
        const th = vw * 16 / 9;
        if (th > vh) {
          vw = vh * 9 / 16;
        }
        else if (vw === 0 && th > 0) {
          vh = th;
        }
      }
      else {
        if (vh === 0) {
          // console.log('setting video height', vidEl);
          if (!s.fullscreen) {
            vidEl.setAttribute('style', 'height:75vh;');
          }
          else {
            vidEl.setAttribute('style', 'height:100vh;');
          }
          vh = vidEl.getBoundingClientRect().height;
          vw = vidEl.getBoundingClientRect().width;
        }
        else {
          if (vh < vw && vh > 100) {
            vw = vh * 9 / 16;
          }
          else {
            vh = vw * 16 / 9;
          }
        }
      }
      // if(vh > ch.height && ch.height> 100) {
      //   vh = ch.height;
      //   vw = vh*9/16;
      // }
      if (vw >= 576) {
        if (vh > 1024) {
          vw = 576;
          vh = vw * 16 / 9;
        }
        else {
          vh = window.innerHeight;
          vw = vh * 9 / 16;
        }
      }
      // console.log('vw final', vw);
      s.w = `${Math.round(vw)}px`;
      s.h = `${Math.round(vh)}px`;
      // }
    }
    setTimeout(() => {
      if (s.fullscreen) {
        const flw = s.el.shadowRoot.querySelector('.flexWrapper');
        // console.log(flw);
        if (flw) {
          flw.style.maxHeight = window.innerHeight + 'px';
        }
      }
    }, 100);
    // console.log('final height', s.w, s.h, this.fullscreen);
  }
  hideElement(cl, s = this) {
    var _a;
    (_a = s.el.shadowRoot.querySelector(`.${cl}`)) === null || _a === void 0 ? void 0 : _a.setAttribute('hidden', 'true');
  }
  showElement(cl, s = this) {
    var _a;
    (_a = s.el.shadowRoot.querySelector(`.${cl}`)) === null || _a === void 0 ? void 0 : _a.removeAttribute('hidden');
  }
  enablePip() {
    if ((window === null || window === void 0 ? void 0 : window.innerWidth) > 768 && this.ch < 215) {
      this.w = `${Math.round(this.ch * 1.5 * 9 / 16)}px`;
      this.h = `${this.ch * 1.5}px`;
    }
    else {
      this.w = `${Math.round(this.ch * 9 / 16)}px`;
      this.h = `${this.ch}px`;
    }
    this.autoplay = true;
    this.showheader = true;
    this.showfootertitle = false;
    this.showheadertitle = false;
    this.showfooterplay = true;
  }
  pipFullScreen(vidEl, s) {
    // console.log('full screen pip');
    s.w = null;
    s.h = null;
    s.fullscreen = true;
    s.setPlayerHeight(vidEl, s);
    // console.log(this.h);
    s.showheadertitle = true;
    this.showElement('headerVideoTitle');
    s.showfooterplay = false;
    this.hideElement('footerPlay');
    this.hideElement('fullplayerclick');
    this.hideElement('closePipControl');
    this.showElement('enterPipControl');
    // s.w = '100%';
    // s.h = '100vh';
    s.isMute = false;
    s.player.muted = false;
    if (s.fullscreen || s.variant === 'chip') {
      s.showproductcard = true;
    }
    // s.setupPlyr();
    s.trackEvent('full_screen', {
      category: 'floating_player',
      mute: s.isMute,
      playing_time: s.playingTime,
      loop_count: s.loopCount,
    });
    setTimeout(() => {
      s.isPlaying = s.player.playing;
      if (!s.isPlaying && (s.autoplay || s.mode === 'pinned')) {
        s.player.play();
        s.isPlaying = true;
      }
    }, 50);
    // s.trackEvent('view', {
    //   category: 'fullscreen_player',
    //   mute: s.isMute,
    //   playing_time: s.playingTime,
    //   loop_count: s.loopCount,
    //   ...s.getCtaAttributes(s),
    // });
  }
  getCtaAttributes(s) {
    var _a, _b, _c, _d, _e, _f;
    if (s.fullscreen) {
      return {
        cta_type: (_a = s.video) === null || _a === void 0 ? void 0 : _a.shoppableType,
        cta_title: (_c = (_b = s.video) === null || _b === void 0 ? void 0 : _b.shoppableData) === null || _c === void 0 ? void 0 : _c.ctaType,
        products_count: (((_d = s.video) === null || _d === void 0 ? void 0 : _d.shoppableType) === 'addtocart') ? 1 : 0,
        loop_count: this.loopCount,
        playingTime: this.playingTime,
        platform: this.platform,
        duration: (_e = s.video) === null || _e === void 0 ? void 0 : _e.duration,
      };
    }
    else {
      return {
        loop_count: this.loopCount,
        playingTime: this.playingTime,
        platform: this.platform,
        duration: (_f = s.video) === null || _f === void 0 ? void 0 : _f.duration,
      };
    }
  }
  openCart() {
    var cartel = document.querySelector('a[href="/cart"]');
    cartel.click();
  }
  async addShopifyItem() {
    this.addToCartLoading = true;
    this.trackEvent('addtocart_click', Object.assign(Object.assign({}, this.getCtaAttributes(this)), { category: 'fullscreen_player', playing_time: this.playingTime, loop_count: this.loopCount, mute: this.player.muted, playing: this.isPlaying, addtocart_id: this.shopifyVariantId, productid: this.shopifyProduct.product.id }));
    const result = await fetch("/cart/add.json", {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
        "Accept": "application/json"
      },
      body: JSON.stringify({
        id: this.shopifyVariantId,
        quantity: this.shopifyQty,
      })
    });
    this.addToCartLoading = false;
    if (result.status === 200) {
      this.addedToCart = true;
      this.trackEvent('addtocart_success', Object.assign(Object.assign({}, this.getCtaAttributes(this)), { category: 'fullscreen_player', playing_time: this.playingTime, loop_count: this.loopCount, mute: this.player.muted, playing: this.isPlaying, addtocart_id: this.shopifyVariantId, productid: this.shopifyProduct.product.id }));
      const cart = await result.json();
      document.documentElement.dispatchEvent(new CustomEvent("cart:refresh", {
        bubbles: true,
      }));
      document.documentElement.dispatchEvent(new CustomEvent("cart:updated", {
        bubbles: true,
        detail: {
          cart,
        }
      }));
      if (!result.redirected) {
        var s = this;
        s === null || s === void 0 ? void 0 : s.pause();
        setTimeout(function () {
          s.openCart();
          s.enterPipClick(false);
        }, 600);
      }
      return cart;
    }
    else {
      this.trackEvent('addtocart_failure', Object.assign(Object.assign({}, this.getCtaAttributes(this)), { category: 'fullscreen_player', playing_time: this.playingTime, loop_count: this.loopCount, mute: this.player.muted, playing: this.isPlaying, addtocart_id: this.shopifyVariantId, productid: this.shopifyProduct.product.id }));
      return false;
    }
  }
  async onShopifyProductPage() {
    var _a, _b, _c, _d, _e, _f;
    const w = window;
    const path = w.location.pathname;
    // The pathname most likely looks like /collections/something/products/product-handle
    const potentialHandle = path.substring(path.lastIndexOf("/") + 1);
    if ((w === null || w === void 0 ? void 0 : w.meta) && ((_b = (_a = w === null || w === void 0 ? void 0 : w.meta) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id)) {
      // console.log('returning p from meta');
      this.shopifyProduct = w.meta;
      this.shopifyVariantId = ((_d = (_c = this.shopifyProduct) === null || _c === void 0 ? void 0 : _c.product) === null || _d === void 0 ? void 0 : _d.variants[0].id) || null;
      return this.shopifyProduct;
    }
    const result = await fetch(`/products/${potentialHandle}.json`, {
      method: "GET",
      headers: {
        "Accept": "application/json"
      }
    });
    if (result.status === 200) {
      this.shopifyProduct = await result.json();
      this.shopifyVariantId = ((_f = (_e = this.shopifyProduct) === null || _e === void 0 ? void 0 : _e.product) === null || _f === void 0 ? void 0 : _f.variants[0].id) || null;
      return this.shopifyProduct;
    }
    else {
      return false;
    }
  }
  getPlayerCategory() {
    if (this.fullscreen && this.mode === 'pinned') {
      return 'fullscreen_player';
    }
    return this.widget;
  }
  autoPause() {
    if (this.widget === 'carousel_player' || this.widget === 'carousel_player_fullscreen') {
      return false;
    }
    return true;
  }
  widgetPlayClick(s) {
    // console.log('widget play click', s.widget);
    s.playclick();
    s.trackEvent('full_screen', {
      category: s.getPlayerCategory(),
      mute: s.player.muted,
      playing_time: s.playingTime,
      loop_count: s.loopCount,
    });
    // s.trackEvent('view', {
    //   category: `${s.widget}_fullscreen`,
    //   mute: s.player.muted,
    //   playing_time: s.playingTime,
    //   loop_count: s.loopCount,
    //   ...s.getCtaAttributes(s),
    // });
  }
  setVideo(finalvideo) {
    var _a, _b, _c, _d;
    if ((finalvideo === null || finalvideo === void 0 ? void 0 : finalvideo.width) / (finalvideo === null || finalvideo === void 0 ? void 0 : finalvideo.height) > 9 / 16) {
      this.cover = false;
    }
    if ((_b = (_a = finalvideo === null || finalvideo === void 0 ? void 0 : finalvideo.channel) === null || _a === void 0 ? void 0 : _a.primaryColor) === null || _b === void 0 ? void 0 : _b.hex) {
      var style = document.createElement('style');
      style.innerHTML = `.playerWrapper { --asplayer-btn-color: ${finalvideo.channel.primaryColor.hex}; --asplayer-ch: ${this.ch}px; }`;
      if (this.ch <= 210) {
        style.innerHTML = `${style.innerHTML}  @media (min-width: 768px) { .playerWrapper { --asplayer-ch: ${this.ch * 1.5}px; } }`;
      }
      this.el.shadowRoot.appendChild(style);
    }
    if ((_c = finalvideo === null || finalvideo === void 0 ? void 0 : finalvideo.channel) === null || _c === void 0 ? void 0 : _c.forceMute) {
      this.forcemute = true;
      this.isMute = true;
    }
    if (this.fullscreen && !this.forcemute) {
      this.isMute = false;
    }
    if (this.forcemute) {
      this.isMute = true;
    }
    if (this.platform === 'shopify' && this.shopify) {
      if ((finalvideo === null || finalvideo === void 0 ? void 0 : finalvideo.shoppableType) === 'addtocart' &&
        ((_d = finalvideo.shoppableData) === null || _d === void 0 ? void 0 : _d.productId) !== this.shopifyProduct.product.id.toString()) {
        // console.log('product id doesn\'t match');
        return false;
      }
    }
    this.video = finalvideo;
    if (finalvideo) {
      var vidEl = this.el.shadowRoot.querySelector('.as-player-wrapper');
      const s = this;
      if (!this.fullscreen && this.playclick && this.mode != 'pinned') {
        this.playControlClick = () => this.widgetPlayClick(s);
      }
      if (this.fullscreen) {
        this.playControlClick = () => {
          if (!this.isPlaying) {
            this.play();
          }
          this.isMute = !this.isMute;
          this.muted(this.isMute);
        };
      }
      //pip
      this.closePipClick = () => {
        s.pause();
        s.hidden = true;
        s.trackEvent('closed', {
          category: 'floating_player',
          mute: this.isMute,
          playing_time: this.playingTime,
          loop_count: this.loopCount,
        });
      };
      if (this.mode === 'pinned') {
        this.playControlClick = () => this.pipFullScreen(vidEl, s);
        this.playclick = () => this.playControlClick();
      }
      this.openFullScreen = () => {
        this.hideElement('openFsControl');
        this.showElement('closeFsControl');
        s.pipFullScreen(vidEl, s);
      };
      this.closeFullScreen = () => {
        this.hideElement('closeFsControl');
        this.showElement('openFsControl');
        s.w = null;
        s.h = null;
        this.fullscreen = false;
        s.setPlayerHeight(vidEl, s);
      };
      this.enterPipClick = (clicked = true, click_type = 'icon') => {
        // console.log('enter pip click');
        const overlay = this.productoverlay ? this.productoverlay : this.el.shadowRoot.querySelector('as-product-overlay');
        overlay === null || overlay === void 0 ? void 0 : overlay.close();
        this.showElement('fullplayerclick');
        this.isMute = true;
        this.muted(true);
        if (this.mode === 'pinned') {
          this.showElement('footerPlay');
          this.hideElement('headerVideoTitle');
          this.hideElement('footerVideoTitle');
          this.showElement('closePipControl');
          this.hideElement('enterPipControl');
        }
        if (!s.handlerPipMode) {
          s.fullscreen = false;
          s.enablePip();
        }
        else {
          s.pause();
          s.piphandler();
        }
        if (clicked) {
          s.trackEvent('closed_click', Object.assign({ click_type, category: s.getPlayerCategory(), mute: s.isMute, playing_time: s.playingTime, loop_count: s.loopCount }, s.getCtaAttributes(s)));
        }
      };
      this.backdropClick = () => {
        // console.log('back drop click');
        if (this.mode === 'pinned') {
          this.enterPipClick(true, 'backdrop');
        }
        else {
          this.fullscreen = false;
        }
      };
      this.loading = false;
      this.video = finalvideo;
      // lozad
      if (this.mode === 'pinned' || this.widget === 'storyblok' || this.preload) {
        this.setupObserver();
      }
      // console.log(this.playControlClick);
    }
  }
  setupPlyr() {
    if (this.plyrloaded) {
      return;
    }
    try {
      const nel = this.el.shadowRoot.querySelector('#player');
      if (nel === undefined || !nel) {
        setTimeout(() => this.setupPlyr(), 200);
        return;
      }
      nel.setAttribute('poster', nel.getAttribute('data-poster'));
      for (var source in nel.children) {
        var videoSource = nel.children[source];
        if (typeof videoSource.tagName === "string" && videoSource.tagName === "SOURCE") {
          videoSource.src = videoSource.dataset.src;
        }
      }
      let controls = ``;
      const videoTitle = (c) => `<div class="videoTitle ${c}VideoTitle" ><span class="videoTitleText">${this.video.title}</span></div>`;
      const hvideoTitle = (c) => `<div class="videoTitle ${c}VideoTitle" hidden ><span class="videoTitleText">${this.video.title}</span></div>`;
      if (this.showheader) {
        const headerVideoTitle = this.showheadertitle ? videoTitle('header') : hvideoTitle('header');
        /* <button type="button" class="plyr__control" aria-label="Play, {title}" data-plyr="play">
              <svg class="icon--pressed" role="presentation" viewBox="0 0 28 28"><use xlink:href="#as-pause"></use></svg>
              <svg class="icon--not-pressed" role="presentation" viewBox="0 0 28 28"><use xlink:href="#as-play"></use></svg>
              <span class="label--pressed plyr__tooltip" role="tooltip">Pause</span>
              <span class="label--not-pressed plyr__tooltip" role="tooltip">Play</span>
          </button> */
        const closeIcon = `<svg class="icon" role="presentation" viewBox="0 0 30 30"><use xlink:href="#as-close"></use></svg>`;
        const openIcon = `<svg class="icon" role="presentation" viewBox="0 0 32 32"><use xlink:href="#as-enter-fullscreen"></use></svg>`;
        let fsControl = '';
        if (!this.fullscreen && this.mode !== 'pinned') { // storyblok enable open full screen action
          fsControl = `<button type="button" class="plyr__control openFsControl" aria-label="Close">${openIcon}</button>
          <button type="button" hidden class="plyr__control closeFsControl" aria-label="Close">${closeIcon}</button>`;
        }
        if (this.fullscreen && (this.mode !== 'pinned') && !this.handlerPipMode) { // storyblock full screen mode
          fsControl = `<button type="button" class="plyr__control closeFsControl" aria-label="Close">${closeIcon}</button>
          <button type="button" hidden class="plyr__control openFsControl" aria-label="Close">${openIcon}</button>`;
        }
        if (this.mode === 'pinned' && !this.fullscreen) { // pinned and not fullscreen
          fsControl = `<button type="button" class="plyr__control closePipControl" aria-label="Close">${closeIcon}</button>
          <button type="button" class="plyr__control enterPipControl" hidden aria-label="Close">${closeIcon}</button>`;
        }
        if ((this.mode === 'pinned' || this.handlerPipMode) && this.fullscreen) { // pinned and fullscreen
          fsControl = `<button type="button" class="plyr__control enterPipControl" aria-label="Close">${closeIcon}</button>
          <button type="button" class="plyr__control closePipControl" hidden aria-label="Close">${closeIcon}</button>`;
        }
        controls = `<div class="plyr__controls">
        ${headerVideoTitle}
        <button type="button" class="plyr__control" aria-label="Mute" data-plyr="mute">
            <svg class="icon--pressed" role="presentation" viewBox="0 0 32 32"><use xlink:href="#as-muted"></use></svg>
            <svg class="icon--not-pressed" role="presentation" viewBox="0 0 32 32"><use xlink:href="#as-volume"></use></svg>
        </button>
        ${fsControl}
    </div><div class="topPlayerShow"></div>${controls}`;
      }
      if (this.showfootertitle || this.showfooterplay) {
        const footerVideoTitle = this.showfootertitle ? videoTitle('footer') : hvideoTitle('footer');
        const footerPlay = this.showfooterplay ? `<button type="button" class="plyr__control footerPlay" aria-label="Play, {title}" data-plyr="play">
      <svg class="icon--pressed" role="presentation" viewBox="0 0 24 24"><use xlink:href="#as-pause"></use></svg>
      <svg class="icon--not-pressed" role="presentation" viewBox="0 0 24 24"><use xlink:href="#as-play"></use></svg>
  </button>` : `<button type="button" class="plyr__control footerPlay" hidden aria-label="Play, {title}" data-plyr="play">
  <svg class="icon--pressed" role="presentation" viewBox="0 0 24 24"><use xlink:href="#as-pause"></use></svg>
  <svg class="icon--not-pressed" role="presentation" viewBox="0 0 24 24"><use xlink:href="#as-play"></use></svg>
</button>`;
        controls = `${controls}
      <div class="plyr__controls footercontrols">
       ${footerVideoTitle}
       ${footerPlay}
      </div>
      `;
      }
      if (this.playclick && !this.fullscreen) {
        controls = `<div class="fullplayerclick">
    <div style="height: ${this.h}"
    ></div></div>${controls}`;
      }
      controls = `<div class="bottomPlayerShow"></div>
${controls}
<div class="plyr__progress">
<input data-plyr="seek" type="range" min="0" max="100" step="0.01" value="0" aria-label="Seek">
<progress class="plyr__progress__buffer" min="0" max="100" value="0">% buffered</progress>
<span role="tooltip" class="plyr__tooltip">00:00</span>
</div>`;
      // Setup the player
      // console.log('setting up plyr');
      this.player = new plyr_min(nel, {
        autoplay: false,
        autopause: false,
        muted: (this.forcemute !== null && this.forcemute !== undefined) ? this.forcemute : this.isMute,
        loop: { active: this.loop },
        disableContextMenu: true,
        hideControls: false,
        resetOnEnd: true,
        // ratio:`${this.w ? this.w.replace('px', '') : 9}:${this.h ? this.h.replace('px', '') : 16}`,
        storage: { enabled: true, key: 'allstudio-plyr' },
        mediaMetadata: { title: this.video.title },
        displayDuration: false,
        loadSprite: false,
        controls,
        fullscreen: { enabled: false },
        tooltips: { controls: false, seek: false },
      });
      // this.player.autoplay = this.autoplay;
      this.plyrloaded = true;
      this.player.muted = (this.forcemute !== null && this.forcemute !== undefined) ? this.forcemute : this.isMute;
      // this.player.on('controlsshown', this.onControlsShown.bind(this));
      this.player.on('loadstart', this.onVmLoadStart.bind(this));
      this.player.on('canplay', this.onPlaybackReady.bind(this));
      this.player.on('ready', this.onVmReady.bind(this));
      this.player.on('timeupdate', this.onCurrentTimeChange.bind(this));
      this.player.on('playing', this.onPlayingChange.bind(this));
      this.player.on('volumechange', this.onMutedChange.bind(this));
      this.player.on('suspend', this.onPlaySuspend.bind(this));
    }
    catch (e) {
      this.plyrloaded = false;
      console.log('plyr setup err', e.message);
      setTimeout(this.setupPlyr, 200);
    }
  }
  onPlaySuspend() {
    console.log('play suspend');
    this.playsuspend = true;
  }
  onPlaybackStarted(s) {
    s.loopCount += 1;
    // console.log('playback started', s.loopCount);
    s.trackEvent('video_view', Object.assign({ category: s.getPlayerCategory(), mute: s.isMute, loop_count: s.loopCount }, s.getCtaAttributes(s)));
    if (s.loopCount > 10) {
      s.pause();
    }
    else {
      if (s.autoplay && !s.player.playing && !s.playsuspend) {
        s.play();
      }
    }
  }
  onPlaybackReady() {
    // console.log('player ready', this.mode);
    this.playerready = true;
    var s = this;
    if (s.autoplay && !s.playsuspend) {
      s.play();
      // this.trackEvent('autoplay', {
      //   mute: this.isMute,
      //   loopCount: this.loopCount,
      // });
    }
    setTimeout(() => {
      s.isPlaying = s.player.playing;
      if (!s.isPlaying && (s.autoplay || s.mode === 'pinned') && !s.playsuspend) {
        // console.log('not playing');
        this.play();
        s.isPlaying = true;
      }
    }, 0);
  }
  onVmReady() {
    // console.log('vm ready', this.mode);
    var _a, _b, _c, _d, _e;
    if (this.autoplay) {
      setTimeout(() => {
        if (!this.player.playing && !this.playsuspend) {
          this.playerready = true;
          this.play();
          // this.trackEvent('autoplay', {
          //   mute: this.isMute,
          //   loopCount: this.loopCount,
          // });
        }
      }, 500);
    }
    else {
      setTimeout(() => {
        this.playerready = true;
      }, 200);
    }
    (_a = this.el.shadowRoot.querySelector('.fullplayerclick')) === null || _a === void 0 ? void 0 : _a.addEventListener('click', this.playclick, {
      passive: true,
    });
    (_b = this.el.shadowRoot.querySelector('.closeFsControl')) === null || _b === void 0 ? void 0 : _b.addEventListener('click', this.closeFullScreen, {
      passive: true,
    });
    (_c = this.el.shadowRoot.querySelector('.openFsControl')) === null || _c === void 0 ? void 0 : _c.addEventListener('click', this.openFullScreen, {
      passive: true,
    });
    (_d = this.el.shadowRoot.querySelector('.closePipControl')) === null || _d === void 0 ? void 0 : _d.addEventListener('click', this.closePipClick, {
      passive: true,
    });
    (_e = this.el.shadowRoot.querySelector('.enterPipControl')) === null || _e === void 0 ? void 0 : _e.addEventListener('click', this.enterPipClick, {
      passive: true,
    });
    // this.playerready = true;
    // this.trackEvent('impression', {
    //   mute: this.isMute,
    //   loopCount: this.loopCount,
    // });
  }
  onVmLoadStart() {
    // console.log('vm load start');
  }
  onPlayingChange() {
    // console.log('playing changed', this.player.playing);
    this.isPlaying = this.player.playing;
    const vel = this.el.shadowRoot.querySelector('video');
    const velplaying = !!(vel.currentTime > 0 && !vel.paused && !vel.ended && vel.readyState > 2);
    if (!this.isPlaying) {
      this.isPlaying = velplaying;
    }
    // this.trackEvent(this.isPlaying ? 'play' : 'pause', {
    //   category: this.getPlayerCategory(),
    //   mute: this.isMute,
    //   loopCount: this.loopCount,
    //   ...this.getCtaAttributes(this),
    // });
  }
  onMutedChange(event) {
    // console.log('mute changed', event.detail.plyr.muted, this.mutehandler);
    this.isMute = event.detail.plyr.muted;
    if (this.mutehandler) {
      this.mutehandler(this.isMute);
    }
    // this.trackEvent(this.isMute ? 'mute' : 'unmute', {
    //   category: this.getPlayerCategory(),
    //   mute: this.isMute,
    //   loopCount: this.loopCount,
    //   ...this.getCtaAttributes(this),
    // });
  }
  onCurrentTimeChange(event) {
    this.playingTime = event.detail.plyr.currentTime;
    // console.log('time change', this.playingTime, this.startTime, this.loopCount);
    // const watchTime = this.playingTime + this.loopCount * this.video.duration;
    if (this.loopCount === 0) {
      // this.trackEvent('engaged_video')
      if (this.playingTime - this.startTime >= 1) {
        const seconds = Math.round(this.playingTime);
        if (seconds === 3) {
          this.trackEvent('video_view', Object.assign({ category: this.getPlayerCategory(), mute: this.isMute, seconds }, this.getCtaAttributes(this)));
          this.trackEvent('played_second', Object.assign({ category: this.getPlayerCategory(), mute: this.isMute, seconds }, this.getCtaAttributes(this)));
        }
        if (seconds === Math.round(this.video.duration * 0.25)) {
          this.trackEvent('played_one_fourth', Object.assign({ category: this.getPlayerCategory(), mute: this.isMute, seconds }, this.getCtaAttributes(this)));
        }
        if (seconds === Math.round(this.video.duration / 3)) {
          this.trackEvent('played_one_third', Object.assign({ category: this.getPlayerCategory(), mute: this.isMute, seconds }, this.getCtaAttributes(this)));
        }
        if (seconds === Math.round(this.video.duration * 0.5)) {
          this.trackEvent('played_half', Object.assign({ category: this.getPlayerCategory(), mute: this.isMute, seconds }, this.getCtaAttributes(this)));
        }
        if (seconds === Math.round(this.video.duration * 0.75)) {
          this.trackEvent('played_75percent', Object.assign({ category: this.getPlayerCategory(), mute: this.isMute, seconds }, this.getCtaAttributes(this)));
        }
        this.startTime = seconds;
      }
    }
    if (this.playingTime === 0) {
      if (this.loopCount === 0) {
        this.trackEvent('played_full', Object.assign({ category: this.getPlayerCategory(), mute: this.isMute, seconds: this.video.duration }, this.getCtaAttributes(this)));
      }
      this.onPlaybackStarted(this);
    }
  }
  setJitsu(s) {
    var _a, _b;
    jitsu.set({
      channelid: s.video.channelId,
      videoid: s.video.id,
      duration: s.video.duration,
      category: s.widget,
      env: s.env === '' ? 'live' : s.env,
      appid: 'allstudio',
      accountid: (_b = (_a = s.video) === null || _a === void 0 ? void 0 : _a.channel) === null || _b === void 0 ? void 0 : _b.accountId,
      playlistid: s.playlistId,
      index: s.index,
      type: 'video',
      typeId: s.video.id,
      photoid: null,
    });
  }
  trackEvent(name, data, s = null) {
    if (!s) {
      s = this;
    }
    else {
      s.setJitsu(s);
    }
    if (s.tk || s.tk === undefined) {
      // console.log('tracking event', name, data);
      try {
        jitsu.track(name, data);
        if (!name.includes('played_')) ;
      }
      catch (e) {
        // console.log('jitsu tracking error', e);
      }
    }
  }
  static get assetsDirs() { return ["icons"]; }
  get el() { return this; }
  static get watchers() { return {
    "loading": ["watchStateHandler"]
  }; }
  static get style() { return asPlayerCss; }
}, [1, "as-player", {
    "videoId": [1, "vid"],
    "fvideo": [8],
    "channelId": [1, "cid"],
    "playlistId": [1, "pid"],
    "env": [1],
    "showheader": [4],
    "showheadertitle": [4],
    "showfooterplay": [4],
    "showfootertitle": [4],
    "showproductchip": [4],
    "showproductcard": [4],
    "w": [1025],
    "h": [1025],
    "sw": [1026],
    "sh": [1026],
    "autoplay": [4],
    "loop": [4],
    "fullscreen": [4],
    "playclick": [8],
    "mode": [1],
    "position": [1],
    "piphandler": [8],
    "platform": [8],
    "widget": [1032],
    "shopify": [1028],
    "tk": [4],
    "placeholder": [4],
    "productoverlay": [8],
    "forcemute": [1028],
    "mutehandler": [8],
    "index": [2],
    "size": [1],
    "ch": [2],
    "preload": [4],
    "video": [32],
    "isMute": [32],
    "isPlaying": [32],
    "videoUrl": [32],
    "hiddenControls": [32],
    "hidden": [32],
    "handlerPipMode": [32],
    "addedToCart": [32],
    "addToCartLoading": [32],
    "loopCount": [32],
    "loading": [32],
    "playerready": [32],
    "cover": [32],
    "playsuspend": [32],
    "load": [64],
    "closeoverlay": [64],
    "play": [64],
    "pause": [64],
    "muted": [64],
    "viewFullScreen": [64]
  }, [[9, "resize", "windowResize"], [9, "beforeunload", "pageExit"], [9, "blur", "pageBlur"], [9, "focus", "pageFocus"]]]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["as-player", "as-product-card", "as-product-card-slider", "as-product-chip", "as-product-overlay"];
  components.forEach(tagName => { switch (tagName) {
    case "as-player":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, AsPlayer);
      }
      break;
    case "as-product-card":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "as-product-card-slider":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "as-product-chip":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "as-product-overlay":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { AsPlayer as A, defineCustomElement as d };

//# sourceMappingURL=as-player2.js.map