/*!
 * All Studio Web Components
 * Copyright (c) Halfcute Internet Pvt Ltd
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const asProductChipCss = ":host{display:block;height:42px}.chip{display:inline-block;padding:0 25px;height:32px;font-size:14px;font-weight:400;line-height:32px;border-radius:16px;background-color:rgba(0,0,0,0.5);color:#fff;text-overflow:ellipsis;width:70%;white-space:nowrap;position:relative;max-width:140px}.chip.sizemini{padding:0px 17px 0px 8px;font-size:12px;line-height:24px;border-radius:12px;height:24px;width:80%}.chip img{float:left;margin:0 10px 0 -25px;height:48px;width:48px;border-radius:50%;position:relative;top:-8px;border:1px solid #f1f1f1}.chip.sizemini img{margin:0 5px 0 -8px;height:36px;width:36px;top:-6px}.icon{background-color:#3a3a3a;position:absolute;color:#fff;padding:8px;border-radius:50%;right:8px;top:4px;display:none}.gg-shopping-bag{-webkit-transform:scale(var(--ggs,1));transform:scale(var(--ggs,1))}.gg-shopping-bag,.gg-shopping-bag::after{-webkit-box-sizing:border-box;box-sizing:border-box;position:relative;display:block;width:20px;height:20px;border:2px solid;border-radius:3px}.gg-shopping-bag::after{content:\"\";position:absolute;width:10px;height:6px;border-bottom-left-radius:120px;border-bottom-right-radius:120px;border-top:0;top:2px;left:3px}@media (max-width: 359px){.chip{overflow-x:hidden;overflow-y:inherit}.chip img{width:32px;height:32px;top:0px}}";

const AsProductChip = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.products = undefined;
    this.trackevent = null;
    this.size = 'default';
  }
  render() {
    if (this.products && this.products.length > 0) {
      return (h(Host, null, h("div", { class: {
          chip: true,
          sizemini: (this.size === 'mini')
        }, onClick: () => { var _a, _b, _c, _d; this.trackevent('product_chip_click', { productid: (_d = (_c = (_b = (_a = this.products[0]) === null || _a === void 0 ? void 0 : _a.platformId) === null || _b === void 0 ? void 0 : _b.split("/")) === null || _c === void 0 ? void 0 : _c.reverse()) === null || _d === void 0 ? void 0 : _d[0] }); } }, h("img", { src: this.products[0].platformProduct.featuredImage.url, alt: "Product", width: "96", height: "96" }), h("span", { class: "icon" }, h("i", { class: "gg-shopping-bag" })), this.products.length > 1 ? `View Products` : 'View Product')));
    }
    else {
      return (h(Host, null));
    }
  }
  static get style() { return asProductChipCss; }
}, [1, "as-product-chip", {
    "products": [8],
    "trackevent": [8],
    "size": [1]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["as-product-chip"];
  components.forEach(tagName => { switch (tagName) {
    case "as-product-chip":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, AsProductChip);
      }
      break;
  } });
}

export { AsProductChip as A, defineCustomElement as d };

//# sourceMappingURL=as-product-chip2.js.map